Package: BIGDAWG
Type: Package
Title: Case-Cotrol Analysis of Multi-Allelic Loci
Version: 3.1.0
Date: 2026-04-29
Authors@R: c(person("Derek","Pappas",role = "aut",email = "djpappas75@gmail.com"),
               person("Livia","Tran",role = "aut",email = "Livia.Tran@ucsf.edu"),
               person("Steve","Mack",role = c("aut", "cre"),email = "Steven.Mack@ucsf.edu"),
               person("Jill","Hollenbach",role = "aut",email = "Jill.Hollenbach@ucsf.edu"))
Maintainer: Steve Mack <Steven.Mack@ucsf.edu>
URL: https://github.com/IgDAWG/BIGDAWG
BugReports: https://github.com/IgDAWG/BIGDAWG/issues
Description: Data sets and functions for chi-squared Hardy-Weinberg and case-control association tests of highly polymorphic genetic data [e.g., human leukocyte antigen (HLA) data]. Performs association tests at multiple levels of polymorphism (haplotype, locus and HLA amino-acids) as described in Pappas DJ, Marin W, Hollenbach JA, Mack SJ (2016) <doi:10.1016/j.humimm.2015.12.006>. Combines rare variants to a common class to account for sparse cells in tables as described by Hollenbach JA, Mack SJ, Thomson G, Gourraud PA (2012) <doi:10.1007/978-1-61779-842-9_14>.
License: GPL (>= 3)
Depends: R (>= 4.0.0)
Imports: XML, haplo.stats, parallel
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
RoxygenNote: 7.3.3
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2026-04-30 05:15:50 UTC; sjmack
Author: Derek Pappas [aut],
  Livia Tran [aut],
  Steve Mack [aut, cre],
  Jill Hollenbach [aut]
Repository: CRAN
Date/Publication: 2026-04-30 08:30:45 UTC
Built: R 4.5.2; ; 2026-05-01 18:13:16 UTC; unix

Package: BIGDAWG
Type: Package
Title: Case-Cotrol Analysis of Multi-Allelic Loci
Version: 3.1.0
Date: 2026-04-29
Authors@R: c(person("Derek","Pappas",role = "aut",email = "djpappas75@gmail.com"),
               person("Livia","Tran",role = "aut",email = "Livia.Tran@ucsf.edu"),
               person("Steve","Mack",role = c("aut", "cre"),email = "Steven.Mack@ucsf.edu"),
               person("Jill","Hollenbach",role = "aut",email = "Jill.Hollenbach@ucsf.edu"))
Maintainer: Steve Mack <Steven.Mack@ucsf.edu>
URL: https://github.com/IgDAWG/BIGDAWG
BugReports: https://github.com/IgDAWG/BIGDAWG/issues
Description: Data sets and functions for chi-squared Hardy-Weinberg and case-control association tests of highly polymorphic genetic data [e.g., human leukocyte antigen (HLA) data]. Performs association tests at multiple levels of polymorphism (haplotype, locus and HLA amino-acids) as described in Pappas DJ, Marin W, Hollenbach JA, Mack SJ (2016) <doi:10.1016/j.humimm.2015.12.006>. Combines rare variants to a common class to account for sparse cells in tables as described by Hollenbach JA, Mack SJ, Thomson G, Gourraud PA (2012) <doi:10.1007/978-1-61779-842-9_14>.
License: GPL (>= 3)
Depends: R (>= 4.0.0)
Imports: XML, haplo.stats, parallel
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
RoxygenNote: 7.3.3
Encoding: UTF-8
NeedsCompilation: no
Packaged: 2026-04-30 05:15:50 UTC; sjmack
Author: Derek Pappas [aut],
  Livia Tran [aut],
  Steve Mack [aut, cre],
  Jill Hollenbach [aut]
Repository: CRAN
Date/Publication: 2026-04-30 08:30:45 UTC
Built: R 4.6.0; ; 2026-04-30 11:23:51 UTC; unix

exportPattern("^[[:alpha:]]+")
importFrom("parallel","mclapply")
importFrom("graphics", "axis", "mtext", "title")
importFrom("stats", "chisq.test", "fisher.test", "na.omit", "pchisq", "qnorm", "xtabs")
importFrom("utils", "data", "combn", "download.file", "packageVersion", "read.table", "write.table","write.csv")

#' Haplotype Wrapper for Multicore
#'
#' Wrapper for main H function
#' @param SID Character vector of subject IDs.
#' @param Tabsub Data frame of genotype calls for set being analyzed.
#' @param loci Character vector of unique loci being analyzed.
#' @param loci.ColNames Character vector of genos column names.
#' @param genos The genotype columns of the loci set being analyzed.
#' @param grp Case/Control or Phenotype groupings.
#' @param All.Pairwise Haplotype argument carryover from main BIGDAWG function
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test
#' @param Output Data return carryover from main BIGDAWG function
#' @param Verbose Summary display carryover from main BIGDAWG function
#' @param Cores Cores carryover from main BIGDAWG function
#' @note This function is for internal BIGDAWG use only.
H.MC.wrapper <- function(SID,Tabsub,loci,loci.ColNames,genos,grp,All.Pairwise,Strict.Bin,Output,Verbose,Cores) {

  cat(">>>> STARTING HAPLOTYPE ANALYSIS...","\n")

  # Define Pairwise Combinations to Run When Selected
  if(All.Pairwise) {

    # Define Combinations
    Combos <- t(combn(length(loci),2))
    Combos <- lapply(seq_len(nrow(Combos)),FUN=function(x) Combos[x,])

    cat("\nYou have opted to run all pairwise combinations for the haplotype analysis.\n")
    cat("There are", length(Combos), "possible locus combinations to run.\n" )

    # Define Pairwise Sets
    HAPsets <- parallel::mclapply(Combos,FUN=buildHAPsets,genos=genos,loci=loci,loci.ColNames=loci.ColNames,mc.cores=Cores)
    HAPnames <- unlist(parallel::mclapply(Combos,FUN=buildHAPnames,loci=loci,mc.cores=Cores))
    names(HAPsets) <- HAPnames

  } else {

    HAPsets <- list()
    HAPsets[[paste(loci,collapse='~')]] <- genos

  }

  # Run H
  #Start <- Sys.time()
  H.list <- parallel::mclapply(HAPsets,H.MC,grp=grp,Strict.Bin=Strict.Bin,Verbose=Verbose,mc.cores=Cores)
  #Sys.time() - Start

  if(All.Pairwise) {

    #chisq
    tmp.cs <- parallel::mclapply(H.list,"[[","chisq",mc.cores=Cores)
    tmp.cs <- do.call(rbind,tmp.cs)
    tmp.cs <- cbind(rownames(tmp.cs),tmp.cs)
    colnames(tmp.cs)[1] <- "Pairwise.Loci"
    rownames(tmp.cs) <- NULL

  }

  if(Output) {

      # Gathering List Elements
      H.out <- list()

      if(All.Pairwise) {

        #Frequencies
          tmp <- parallel::mclapply(H.list,"[[","freq",mc.cores=Cores)
          nrow.tmp <- lapply(tmp,nrow)
          haps.tmp <- rep(names(nrow.tmp),nrow.tmp)
          tmp <- cbind(haps.tmp,do.call(rbind,tmp))
          colnames(tmp)[1:2] <- c("Pairwise.Loci","Haplotype")
          H.out[['freq']] <- tmp

        #binned
          tmp <- parallel::mclapply(H.list,"[[","binned",mc.cores=Cores)
          nrow.tmp <- lapply(tmp,nrow)
          haps.tmp <- rep(names(nrow.tmp),nrow.tmp)
          tmp <- cbind(haps.tmp,do.call(rbind,tmp))
          colnames(tmp)[1:2] <- c("Pairwise.Loci","Haplotype")
          H.out[['binned']] <- tmp

        #OR
          tmp <- parallel::mclapply(H.list,"[[","OR",mc.cores=Cores)
          nrow.tmp <- lapply(tmp,nrow)
          haps.tmp <- rep(names(nrow.tmp),nrow.tmp)
          tmp <- cbind(haps.tmp,do.call(rbind,tmp))
          colnames(tmp)[1:2] <- c("Pairwise.Loci","Haplotype")
          H.out[['OR']] <- tmp

        #chisq
          H.out[['chisq']] <- tmp.cs

        #table
          tmp <- parallel::mclapply(H.list,"[[","table",mc.cores=Cores)
          nrow.tmp <- lapply(tmp,nrow)
          haps.tmp <- rep(names(nrow.tmp),nrow.tmp)
          tmp <- cbind(haps.tmp,do.call(rbind,tmp))
          colnames(tmp)[1:2] <- c("Pairwise.Loci","Haplotype")
          H.out[['table']] <- tmp

        #Haplotypes
          tmp <- parallel::mclapply(H.list,"[[","Haplotypes",mc.cores=Cores)
          nrow.tmp <- lapply(tmp,nrow)
          haps.tmp <- rep(names(nrow.tmp),nrow.tmp)
          tmp <- cbind(SID,haps.tmp,do.call(rbind,tmp))
          colnames(tmp) <- c("SAMPLE.ID","Pairwise.Loci","Haplotype.1","Haplotype.2")
          H.out[['Haplotypes']] <- tmp

      } else {

        #Frequencies-binned-OR-chisq-table
          H.out[['freq']] <- H.list[[1]][['freq']]
          H.out[['binned']] <- H.list[[1]][['binned']]
          H.out[['OR']] <- H.list[[1]][['OR']]
          H.out[['chisq']] <- H.list[[1]][['chisq']]
          H.out[['table']] <- H.list[[1]][['table']]

        #Haplotyeps
          tmp <- H.list[[1]][['Haplotypes']]
          tmp <- cbind(SID,tmp)
          colnames(tmp)[1] <- "SAMPLE.ID"
          H.out[['Haplotypes']] <- tmp

      }


      ## write to file
      write.table(H.out[['freq']], "haplotype_freqs.txt", sep="\t", quote = F, row.names=F, col.names=T)
      write.table(H.out[['binned']], "haplotype_binned.txt", sep="\t", quote = F, row.names=F, col.names=T)
      write.table(H.out[['OR']], "haplotype_OR.txt", sep="\t", quote = F, row.names=F, col.names=T)
      write.table(H.out[['chisq']], "haplotype_chisq.txt", sep="\t", row.names = F, quote = F)
      write.table(H.out[['table']], "haplotype_table.txt", sep="\t", row.names = F, quote = F)
      write.table(H.out[['Haplotypes']], "haplotype_HapsbySubject.txt", sep="\t", row.names = F, quote = F)

  }

  if(All.Pairwise) {

    PairSetName <- paste("Pairwise.Set",seq_len(length(H.list)),sep="")

    # Hapset Legend File
    if(Output) {
      tmp <- cbind(PairSetName,names(HAPsets))
      colnames(tmp) <- c("Set_Name","Loci")
      write.table(tmp,file="haplotype_PairwiseSets.txt",sep="\t",quote=F,col.names=T,row.names=F)
    }

    names(H.list) <- PairSetName

  } else { H.list <- H.list[[1]] }

  cat("> HAPLOTYPE ANALYSIS COMPLETED","\n")
    if(Verbose) {
      if(All.Pairwise) { overall.chisq <- tmp.cs } else { overall.chisq <- H.list[['chisq']] }
      print(as.data.frame(overall.chisq), row.names=F)
      cat("\n")
    }

  return(H.list)

}

#' Hardy-Weinbery Wrapper
#'
#' Wrapper for main HWE function
#' @param Tab Data frame of genotype files post processing.
#' @param Output Data return carryover from main BIGDAWG function
#' @param Verbose Summary display carryover from main BIGDAWG function
#' @note This function is for internal BIGDAWG use only.
HWE.wrapper <- function(Tab,Output,Verbose) {

  HWE <- HWE(Tab)

  if(Output) {
    sink("HWE.txt")
    print(HWE,quote=F)
    sink()
  }

  cat("\n> HARDY-WEINBERG ANALYSIS COMPLETED\n")
  if(Verbose) {
    cat("\nControls (Group 0):\n")
    HWE.con <- as.data.frame(HWE[['controls']])
    print(HWE.con,row.names=F,quote=F)
    cat("\nCases (Group 1):\n")
    HWE.cas <- as.data.frame(HWE[['cases']])
    print(HWE.cas,row.names=F,quote=F)
    cat("\n")
  }

  return(HWE)

}

#' Locus Analysis Function 25Jun2025
#'
#' This is the workhorse function for the locus level analysis.
#' @param loci.ColNames The column names of the loci being analyzed.
#' @param Locus Locus being analyzed.
#' @param genos Genotype table
#' @param grp Case/Control or Phenotype groupings.
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test
#' @note This function is for internal BIGDAWG use only.
L <- function(loci.ColNames,Locus,genos,grp,Strict.Bin) {

  # pull out locus specific columns
  getCol <- seq(1,length(loci.ColNames),1)[loci.ColNames %in% Locus]
  HLA_grp <- cbind(grp,genos[,getCol])
  rownames(HLA_grp) <- NULL
  nAllele <- length(na.omit(HLA_grp[,2])) + length(na.omit(HLA_grp[,3]))

  ## extract alleles and counts for Grp1 and Grp0
  Alleles <- sort(unique(c(HLA_grp[,2],HLA_grp[,3])))

  # Build Contingency Matrix of Counts
  Allele.df <- list()
  for(i in 1:length(Alleles)) {
    Allele.df[[i]] <- cbind(Locus,
                            Alleles[i],
                            sum(length(which(subset(HLA_grp, grp==0)[,2]==Alleles[i])),
                                length(which(subset(HLA_grp, grp==0)[,3]==Alleles[i]))),
                            sum(length(which(subset(HLA_grp, grp==1)[,2]==Alleles[i])),
                                length(which(subset(HLA_grp, grp==1)[,3]==Alleles[i]))))
  }; rm(i)
  Allele.df <- do.call(rbind,Allele.df)
  colnames(Allele.df) <- c("Locus","Allele","Group.0","Group.1")

  Allele.con <- matrix(as.numeric(Allele.df[,3:4]),
                       ncol=2,
                       dimnames=list(Allele.df[,'Allele'],c("Group.0", "Group.1")))

  if(nrow(Allele.con)>1) {

    ### get expected values for cells, bin small cells, and run chi square
    if(Strict.Bin) { Result <- RunChiSq(Allele.con) } else { Result <- RunChiSq_c(Allele.con) }

    if( !Result$Flag ) {

      alleles_binned <- NULL
      Final_binned <- NULL
      overall.chisq <- NULL
      ORout <- NULL

    } else {

      alleles_binned <- Result$Binned
      Final_binned <- Result$Matrix
      overall.chisq <- Result$Test

      ## make a nice table of ORs, ci, p values
      ccdat <-TableMaker(Final_binned)
      ORout <- lapply(ccdat, cci.pval) #OR
      ORout <- do.call(rbind,ORout)
      colnames(ORout) <- c("OR","CI.lower","CI.upper","p.value","sig")
      rmRows <- which(ORout[,'sig']=="NA")
      if( length(rmRows > 0) ) {  ORout <- ORout[-rmRows,,drop=F] }

    }

  } else {

    alleles_binned <- NULL
    Final_binned <- NULL
    overall.chisq <- NULL
    ORout <- NULL

  }

  ####################################################### Build Output List

  L.tmp <- list()

  ## Alleles.binned_out
  if( any(!is.null(alleles_binned)) ) {
    if( sum(is.na(alleles_binned))==2) { alleles_binned <- NULL }
  }
  if( any(!is.null(alleles_binned)) ) {
    Allele.binned.tmp <- cbind(rep(Locus,nrow(alleles_binned)),
                               rownames(alleles_binned),
                               alleles_binned)
    rownames(Allele.binned.tmp) <- NULL
    colnames(Allele.binned.tmp) <- c("Locus","Allele","Group.0","Group.1")
    if(sum(grepl("\\^",Allele.binned.tmp[,'Allele']))>0) { Allele.binned.tmp[,'Allele'] <- gsub("\\^","Abs",Allele.binned.tmp[,'Allele']) }
    L.tmp[['binned']] <- Allele.binned.tmp
  } else {
    binned.out <- cbind(Locus,'Nothing.binned',NA,NA)
    colnames(binned.out) <- c("Locus","Allele","Group.0","Group.1")
    rownames(binned.out) <- NULL
    L.tmp[['binned']] <- binned.out
  }


  ## Allele.freq_out
  Allele.freq.out <- cbind(rep(Locus,nrow(Allele.con)),
                           rownames(Allele.con),
                           round(Allele.con[,'Group.0']/sum(Allele.con[,'Group.0']),digits=5),
                           round(Allele.con[,'Group.1']/sum(Allele.con[,'Group.1']),digits=5))
  rownames(Allele.freq.out) <- NULL
  colnames(Allele.freq.out) <- c("Locus","Allele","Group.0","Group.1")
  if(sum(grepl("\\^",Allele.freq.out[,'Allele']))>0) { Allele.freq.out[,'Allele'] <- gsub("\\^","Abs",Allele.freq.out[,'Allele']) }
  L.tmp[['freq']] <- Allele.freq.out


  ## ORtable_out
  if(!is.null(ORout)) {
    ORtable_out.tmp <- cbind(rep(Locus,nrow(ORout)),
                             rownames(ORout),
                             ORout)
    rownames(ORtable_out.tmp) <- NULL
    colnames(ORtable_out.tmp) <- c("Locus","Allele","OR","CI.lower","CI.upper","p.value","sig")
    if(sum(grepl("\\^",ORtable_out.tmp[,'Allele']))>0) { ORtable_out.tmp[,'Allele'] <- gsub("\\^","Abs",ORtable_out.tmp[,'Allele']) }
    L.tmp[['OR']] <- ORtable_out.tmp
  } else {
    ORtable_out.tmp <- cbind(Locus,Alleles,"NCalc","NCalc","NCalc","NCalc","NCalc")
    rownames(ORtable_out.tmp) <- NULL
    colnames(ORtable_out.tmp) <- c("Locus","Allele","OR","CI.lower","CI.upper","p.value","sig")
    if(sum(grepl("\\^",ORtable_out.tmp[,'Allele']))>0) { ORtable_out.tmp[,'Allele'] <- gsub("\\^","Abs",ORtable_out.tmp[,'Allele']) }
    L.tmp[['OR']] <- ORtable_out.tmp
  }


  ## overall.chisq_out
  if(!is.null(overall.chisq)) {
    overall.chisq.tmp <- cbind(Locus, overall.chisq)
    rownames(overall.chisq.tmp) <- NULL
    colnames(overall.chisq.tmp) <- c("Locus","X.square","df","p.value","sig")
    L.tmp[['chisq']] <- overall.chisq.tmp
  } else {
    overall.chisq.tmp <- cbind(Locus,"NCalc","NCalc","NCalc","NCalc")
    rownames(overall.chisq.tmp) <- NULL
    colnames(overall.chisq.tmp) <- c("Locus","X.square","df","p.value","sig")
    L.tmp[['chisq']] <- overall.chisq.tmp
  }


  ## Final_binned_out
  if(!is.null(Final_binned)) {
    Final_binned.tmp <- cbind(rep(Locus,nrow(Final_binned)),
                              rownames(Final_binned),
                              Final_binned)
    rownames(Final_binned.tmp) <- NULL
    colnames(Final_binned.tmp) <- c("Locus","Allele","Group.0","Group.1")
    if(sum(grepl("\\^",Final_binned.tmp[,'Allele']))>0) { Final_binned.tmp[,'Allele'] <- gsub("\\^","Abs",Final_binned.tmp[,'Allele']) }
    L.tmp[['table']] <- Final_binned.tmp
  } else {
    Final_binned.tmp <- cbind(Locus,Alleles,"NCalc","NCalc")
    rownames(Final_binned.tmp) <- NULL
    colnames(Final_binned.tmp) <- c("Locus","Allele","Group.0","Group.1")
    if(sum(grepl("\\^",Final_binned.tmp[,'Allele']))>0) { Final_binned.tmp[,'Allele'] <- gsub("\\^","Abs",Final_binned.tmp[,'Allele']) }
    L.tmp[['table']] <- Final_binned.tmp
  }


  return(L.tmp)


}

#' Haplotype List Builder
#'
#' Builds table of haplotypes from combinations
#' @param Combn Combination of loci to extraction from genos
#' @param genos The genotype columns of the loci set being analyzed.
#' @param loci Character vector of unique loci being analyzed.
#' @param loci.ColNames Character vector of genos column names.
#' @note This function is for internal BIGDAWG use only.
buildHAPsets <- function(Combn,genos,loci,loci.ColNames) {
  
  # Range in matrix
  Set.H <- loci.ColNames %in% loci[Combn]
  return(genos[,Set.H])
  
}

#' Haplotype Name Builder
#'
#' Builds table of names for HAPsets
#' @param Combn Combination of loci to extraction from genos
#' @param loci Character vector of unique loci being analyzed.
#' @note This function is for internal BIGDAWG use only.
buildHAPnames <- function(Combn,loci) {
  
  return(paste(loci[Combn],collapse="~"))

}


#' Haplotype Table Maker
#'
#' Builds table of haplotypes
#' @param HaploEM Haplotype output object from haplo.stat::haplo.em function.
#' @param SID Index number (i.e., row number) of sample ID from genotype matrix.
#' @note This function is for internal BIGDAWG use only.
getHap <- function(SID,HaploEM) {
  
  # SID subject number
  # haplotype object from Haplo.em
  
  # Range in matrix
  Range <- which(HaploEM$indx.subj==SID)
  HapGet <- which.max(HaploEM$post[Range])
  
  # Which haplotype (when more than one possibility)
  Hap1.no <- HaploEM$hap1code[Range][HapGet]
  Hap2.no <- HaploEM$hap2code[Range][HapGet]
  
  # Combine into a haplotype string
  Hap1 <- paste(HaploEM$haplotype[Hap1.no,],collapse="~")
  Hap2 <- paste(HaploEM$haplotype[Hap2.no,],collapse="~")
  
  # Output haplotype
  return(c(Hap1,Hap2))
  
}

#' Haplotype Analysis Function for Multicore
#'
#' This is the workhorse function for the haplotype analysis.
#' @param genos.sub The genotype columns of the loci(locus) set being analyzed.
#' @param grp Case/Control or Phenotype groupings.
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test
#' @param Verbose Summary display carryover from main BIGDAWG function
#' @note This function is for internal BIGDAWG use only.
H.MC <- function(genos.sub,grp,Strict.Bin,Verbose) {

    loci.sub <- unique(gsub(".1","",colnames(genos.sub),fixed=T))
    nloci.sub <- as.numeric(length(loci.sub))
    Haplotype <- paste(loci.sub,collapse="~")

    cat("Estimating Haplotypes ...",Haplotype,"\n")

    ### estimate haplotypes
    Tab.out <- haplo.stats::haplo.em(geno=genos.sub,locus.label=loci.sub)

    ## extract haplotype freqs for cases and controls
    Subjects <- as.list(seq_len(nrow(genos.sub)))
    Tab.Haps <- lapply(Subjects,FUN=getHap,HaploEM=Tab.out)
    Tab.Haps <- cbind(grp,do.call(rbind,Tab.Haps))
    colnames(Tab.Haps)[2:3] <-c("Haplotype.1","Haplotype.2")

    ## Build Contingency Matrix of Counts
    haps <- sort(unique(c(Tab.Haps[,'Haplotype.1'],Tab.Haps[,'Haplotype.2'])))
    haps_counts <- mat.or.vec(nr=length(haps),nc=2)
    rownames(haps_counts) <- haps
    colnames(haps_counts) <- c('Group.0','Group.1')

      #Group 0
      Tab.Haps.grp0  <- Tab.Haps[which(Tab.Haps[,'grp']==0),c('Haplotype.1','Haplotype.2')]
      haps_grp0 <- table(Tab.Haps.grp0)
      haps_counts[match(names(haps_grp0),haps),'Group.0'] <- haps_grp0

      #Group 1
      Tab.Haps.grp1  <- Tab.Haps[which(Tab.Haps[,'grp']==1),c('Haplotype.1','Haplotype.2')]
      haps_grp1 <- table(Tab.Haps.grp1)
      haps_counts[match(names(haps_grp1),haps),'Group.1'] <- haps_grp1

    ### get expected values for cells, bin small cells, and run chi square
    if(Strict.Bin) { Result <- RunChiSq(haps_counts) } else { Result <- RunChiSq_c(haps_counts) }


    if( !(Result$Flag) ) {

      haps_binned <- NULL
      Final_binned <- haps_counts
      overall.chisq <- NULL

      ## Convert counts to frequencies
      haps_freq <- haps_counts
      haps_freq[,'Group.0'] <- haps_freq[,'Group.0']/(nrow(Tab.Haps.grp0)*2)
      haps_freq[,'Group.1'] <- haps_freq[,'Group.1']/(nrow(Tab.Haps.grp1)*2)

      ## make a nice table of ORs, ci, p values
      ccdat <-TableMaker(haps_counts)
      ORout <- lapply(ccdat, cci.pval) #OR list
      ORout <- do.call(rbind,ORout) #OR matrix
      rmRows <- which(ORout[,'sig']=="NA")
      if( length(rmRows > 0) ) {  ORout <- ORout[-rmRows,,drop=F] }


    } else {

      haps_binned <- Result$Binned
      Final_binned <- Result$Matrix
      overall.chisq <- Result$Test

      ## Convert counts to frequencies
      haps_freq <- haps_counts
      haps_freq[,'Group.0'] <- haps_freq[,'Group.0']/(nrow(Tab.Haps.grp0)*2)
      haps_freq[,'Group.1'] <- haps_freq[,'Group.1']/(nrow(Tab.Haps.grp1)*2)

      ## make a nice table of ORs, ci, p values
      ccdat <-TableMaker(Final_binned)
      ORout <- lapply(ccdat, cci.pval) #OR list
      ORout <- do.call(rbind,ORout) #OR
      rmRows <- which(ORout[,'sig']=="NA")
      if( length(rmRows > 0) ) {  ORout <- ORout[-rmRows,,drop=F] }

    }


    ####################################################### Build Output List


    #haps_binned - Binned Haplotypes
    if( is.null(row.names(haps_binned)) ) { names <- "Nothing.binned" } else { names <- rownames(haps_binned) }
    haps_binned_fix <- cbind(names,haps_binned)
    colnames(haps_binned_fix) <- c(Haplotype,colnames(haps_binned))
    rownames(haps_binned_fix) <- NULL
    if( sum(grepl("\\^",haps_binned_fix[,Haplotype]))>0 ) { haps_binned_fix[,Haplotype] <- gsub("\\^","Abs",haps_binned_fix[,Haplotype]) }

    #final_binned - Contingency Table for ChiSq
    Final_binned_fix <- cbind(rownames(Final_binned),Final_binned)
    colnames(Final_binned_fix) <- c(Haplotype,colnames(Final_binned))
    rownames(Final_binned_fix) <- NULL
    if( sum(grepl("^",Final_binned_fix[,Haplotype]))>0 ) { Final_binned_fix[,Haplotype] <- gsub("\\^","Abs",Final_binned_fix[,Haplotype]) }

    #haps_freq - Frequencies
    haps_freq_fix <- cbind(rownames(haps_freq),haps_freq)
    colnames(haps_freq_fix) <- c(Haplotype,colnames(haps_freq))
    rownames(haps_freq_fix) <- NULL
    if(sum(grepl("\\^",haps_freq_fix[,Haplotype]))>0) { haps_freq_fix[,Haplotype] <- gsub("\\^","Abs",haps_freq_fix[,Haplotype]) }

    #ORout - ODDs Ratios
    ORout_fix <- cbind(rownames(ORout),ORout)
    colnames(ORout_fix) <- c(Haplotype,colnames(ORout))
    rownames(ORout_fix) <- NULL
    if(sum(grepl("\\^",ORout_fix[,Haplotype]))>0) { ORout_fix[,Haplotype] <- gsub("\\^","Abs",ORout_fix[,Haplotype]) }

    #Haplotype - Replace Abs symbols
    if(sum(grepl("\\^",Tab.Haps[,'Haplotype.1'])) + sum(grepl("\\^",Tab.Haps[,'Haplotype.2'])) >0) {
      Tab.Haps[,'Haplotype.1'] <- gsub("\\^","Abs",Tab.Haps[,'Haplotype.1'])
      Tab.Haps[,'Haplotype.2'] <- gsub("\\^","Abs",Tab.Haps[,'Haplotype.2'])
      }
    colnames(Tab.Haps)[2:3] <- c(paste(Haplotype,".Hap1",sep=""),paste(Haplotype,".Hap2",sep=""))

    #Overall ChiSq NULL
    if( is.null(overall.chisq) ) {
      overall.chisq <- data.frame(rbind(rep("NCalc",4)))
      colnames(overall.chisq) <- c("X.square", "df", "p.value", "sig")
    }

    H.tmp <- list()
    H.tmp[['Haplotypes']] <- Tab.Haps[,2:3] # table of subject haplotypes
    H.tmp[['freq']] <- haps_freq_fix # rounded frequencies
    H.tmp[['binned']] <- haps_binned_fix # binned haplotypes
    H.tmp[['OR']] <- ORout_fix # odd ratio table
    H.tmp[['chisq']] <- overall.chisq # chi sq test statistic
    H.tmp[['table']] <- Final_binned_fix # final table for chi sq

    #if(Verbose) {
    #  overall.chisq$X.square <- round(as.numeric(levels(overall.chisq$X.square)),digits=5)
    #  print(overall.chisq, row.names=F)
    #  cat("\n")
    #}

    return(H.tmp)

}

#' Amino Acid Analysis Function
#'
#' This is the workhorse function for the amino acid analysis.
#' @param Locus Locus being analyzed.
#' @param loci.ColNames The column names of the loci being analyzed.
#' @param genos Genotype table.
#' @param grp Case/Control or Phenotype groupings.
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test.
#' @param ExonAlign Exon protein alignment filtered for locus.
#' @param Cores Number of cores to use for analysis.
#' @note This function is for internal BIGDAWG use only.
A <- function(Locus,loci.ColNames,genos,grp,Strict.Bin,ExonAlign,Cores) {

  # pull out locus specific columns
  getCol <- seq(1,length(loci.ColNames),1)[loci.ColNames %in% Locus]
  HLA_grp <- cbind(grp,genos[,getCol])
  rownames(HLA_grp) <- NULL
  nAllele <- length(na.omit(HLA_grp[,2])) + length(na.omit(HLA_grp[,3]))

  ## extract alleles
  Alleles <- unique(c(HLA_grp[,2],HLA_grp[,3]))
  Alleles2F <- sort(unique(as.character(sapply(Alleles, GetField, Res=2))))

  if( length(Alleles2F)>1 ) {

    # Filter exon alignment matrix for specific alleles
    TabAA <- AlignmentFilter(ExonAlign,Alleles2F,Locus)
    TabAA.list <- lapply(seq_len(ncol(TabAA)), function(x) TabAA[,c(2,x)])
    TabAA.list <- TabAA.list[5:ncol(TabAA)]
    TabAA.names <- colnames(TabAA)[5:ncol(TabAA)]

    # Generate Contingency Tables
    ConTabAA.list <- parallel::mclapply(TabAA.list,AAtable.builder,y=HLA_grp,mc.cores=Cores)
    names(ConTabAA.list) <- TabAA.names

    # Check Contingency Tables
    # FlagAA.list <- parallel::mclapply(ConTabAA.list,AA.df.check,Strict.Bin=Strict.Bin,mc.cores=Cores)

    # Run ChiSq
    ChiSqTabAA.list <- parallel::mclapply(ConTabAA.list,AA.df.cs,Strict.Bin=Strict.Bin,mc.cores=Cores)
    FlagAA.list <- lapply(ChiSqTabAA.list,"[[",4)

    # build data frame for 2x2 tables
    Final_binned.list <- lapply(ChiSqTabAA.list,"[[",1)
    ccdat.list <- lapply(Final_binned.list,TableMaker)
    OR.list <- lapply(ccdat.list, cci.pval.list) #OR

  } else {

    # Filter exon alignment matrix for single allele
    TabAA <- AlignmentFilter(ExonAlign,Alleles2F,Locus)
    FlagAA.list <- as.list(rep(TRUE,length(TabAA[6:length(TabAA)])))
    names(FlagAA.list) <- names(TabAA[6:length(TabAA)])

    ChiSqTabAA.list <- NA
    OR.list <- NA
    Final_binned.list <- NA

  }

  ####################################################### Build Output List

  A.tmp <- list()

  ## AAlog_out - Positions with insufficient variation or invalid ChiSq
  csRange <- which(FlagAA.list==FALSE) # all failed ChiSeq
  FlagAA.fail <- rownames(do.call(rbind,FlagAA.list[csRange]))

  if( length(csRange)>0 ) {

    # identify insufficient vs invalid flags
    invRange <- intersect(names(csRange),
                          names(which(lapply(Final_binned.list,nrow)>=2)) )# invalid cont table
    isfRange <- setdiff(names(csRange),invRange) # insufficient variation

    if( length(isfRange)>=1 ){
      AAlog.out.isf <- cbind(rep(Locus,length(isfRange)),
                             isfRange,
                             rep("Insufficient variation at position.",length(isfRange)))
    } else { AAlog.out.isf <- NULL }
    if( length(invRange)>=1 ){
      AAlog.out.inv <- cbind(rep(Locus,length(invRange)),
                             invRange,
                             rep("Position invalid for Chisq test.",length(invRange)))
    } else { AAlog.out.inv <- NULL }

    # Final AAlog.out
    AAlog.out <- rbind(AAlog.out.inv, AAlog.out.isf)
    colnames(AAlog.out) <- c("Locus","Position","Comment")
    rownames(AAlog.out) <- NULL
    AAlog.out <- AAlog.out[match(FlagAA.fail,AAlog.out[,'Position']),]

  } else { AAlog.out <- NULL }
  A.tmp[['log']] <- AAlog.out

  ## AminoAcid.binned_out
  if(length(ChiSqTabAA.list)>1) {
    binned.list <- lapply(ChiSqTabAA.list,"[[",2)
    binned.list <- binned.list[which(lapply(binned.list,is.logical)==F)]
    binned.out <- do.call(rbind,binned.list)
    if(!is.null(nrow(binned.out))) {
      binned.out <- cbind(rep(Locus,nrow(binned.out)),
                          rep(names(binned.list),as.numeric(lapply(binned.list,nrow))),
                          rownames(binned.out),
                          binned.out)
      colnames(binned.out) <- c("Locus","Position","Residue","Group.0","Group.1")
      rownames(binned.out) <- NULL
      A.tmp[['binned']] <- binned.out
    } else {
       binned.out <- cbind(Locus,'Nothing.binned',NA,NA,NA)
       colnames(binned.out) <- c("Locus","Position","Residue","Group.0","Group.1")
       rownames(binned.out) <- NULL
       A.tmp[['binned']] <- binned.out
    }
  } else{
    binned.out <- cbind(Locus,'Nothing.binned',NA,NA,NA)
    colnames(binned.out) <- c("Locus","Position","Residue","Group.0","Group.1")
    rownames(binned.out) <- NULL
    A.tmp[['binned']] <- binned.out
  }

  ## overall.chisq_out
  rmPos <- match(FlagAA.fail,names(ChiSqTabAA.list))
  ChiSqTabAA.list <- ChiSqTabAA.list[-rmPos]
  if(length(ChiSqTabAA.list)>1) {
    ChiSq.list <- lapply(ChiSqTabAA.list,"[[",3)
    ChiSq.out <- do.call(rbind,ChiSq.list)
    if(!is.null(ChiSq.out)){
      ChiSq.out <- cbind(rep(Locus,nrow(ChiSq.out)),
                         rownames(ChiSq.out),
                         ChiSq.out)
      colnames(ChiSq.out) <- c("Locus","Position","X.square","df","p.value","sig")
      rownames(ChiSq.out) <- NULL
      A.tmp[['chisq']] <- ChiSq.out
    } else {
      Names <- c("Locus","Position","X.square","df","p.value","sig")
      A.tmp[['chisq']] <- Create.Null.Table(Locus,Names,nr=1)
    }
  } else {
    Names <- c("Locus","Position","X.square","df","p.value","sig")
    A.tmp[['chisq']] <- Create.Null.Table(Locus,Names,nr=1)
  }

  ## ORtable_out
  #rmPos <- match(FlagAA.fail,names(OR.list))
  #OR.list <- OR.list[-rmPos]
  if(length(OR.list)>1) {
    OR.out <- do.call(rbind,OR.list)
    if(!is.null(OR.out)) {
      OR.out <- cbind(rep(Locus,nrow(OR.out)),
                      rep(names(OR.list),as.numeric(lapply(OR.list,nrow))),
                      rownames(OR.out),
                      OR.out)
      colnames(OR.out) <- c("Locus","Position","Residue","OR","CI.lower","CI.upper","p.value","sig")
      rownames(OR.out) <- NULL
      rmRows <- unique(which(OR.out[,'sig']=="NA"))
      if( length(rmRows) > 0 ) {  OR.out <- OR.out[-rmRows,,drop=F] }
      A.tmp[['OR']] <- OR.out
    } else {
      Names <- c("Locus","Position","Residue","OR","CI.lower","CI.upper","p.value","sig")
      A.tmp[['OR']] <- Create.Null.Table(Locus,Names,nr=1)
    }
  } else {
    Names <- c("Locus","Position","Residue","OR","CI.lower","CI.upper","p.value","sig")
    A.tmp[['OR']] <- Create.Null.Table(Locus,Names,nr=1)
  }

  ## Final_binned_out (Final Table)
  #rmPos <- match(FlagAA.fail,names(Final_binned.list))
  #Final_binned.list <- Final_binned.list[-rmPos]
  if( length(Final_binned.list)>1 ) {
    Final_binned.out <- do.call(rbind,Final_binned.list)
    if(!is.null(Final_binned.out)) {
      Final_binned.out <- cbind(rep(Locus,nrow(Final_binned.out)),
                                rep(names(Final_binned.list),as.numeric(lapply(Final_binned.list,nrow))),
                                rownames(Final_binned.out),
                                Final_binned.out)
      colnames(Final_binned.out) <- c("Locus","Position","Residue","Group.0","Group.1")
      rownames(Final_binned.out) <- NULL
      A.tmp[['table']] <- Final_binned.out
    } else {
      Final_binned.out <- NULL
      Names <- c("Locus","Position","Residue","Group.0","Group.1")
      A.tmp[['table']] <- Create.Null.Table(Locus,Names,nr=1)
    }
  } else {
    Final_binned.out <- NULL
    Names <- c("Locus","Position","Residue","Group.0","Group.1")
    A.tmp[['table']] <- Create.Null.Table(Locus,Names,nr=1)
  }

  ## AminoAcid.freq_out
  if( !is.null(Final_binned.out) ) {

    Positions <- unique(Final_binned.out[,'Position'])
    for(p in Positions) {
      getRows <- which(Final_binned.out[,'Position']==p)
      FBO_tmp <- Final_binned.out[getRows,,drop=F]
      Final_binned.out[getRows,'Group.0'] <- round(as.numeric(FBO_tmp[,'Group.0']) / sum(as.numeric(FBO_tmp[,'Group.0'])), digits=5)
      Final_binned.out[getRows,'Group.1'] <- round(as.numeric(FBO_tmp[,'Group.1']) / sum(as.numeric(FBO_tmp[,'Group.1'])), digits=5)
    }
    A.tmp[['freq']] <- Final_binned.out

  } else {
    Names <- c("Locus","Position","Residue","Group.0","Group.1")
    A.tmp[['freq']] <- Create.Null.Table(Locus,Names, nr=1)
  }

  return(A.tmp)

}

#' Update function for protein aligment upon new IMGT HLA data release
#'
#' This updates the protein aligment used in checking HLA loci and alleles as well as in the amino acid analysis.
#' @param Restore Logical specifying if the original alignment file be restored.
#' @param Force Logical specifiying if update should be forced.
#' @param Output Logical indicating if error reporting should be written to file.
UpdateRelease <- function(Force=F,Restore=F,Output=F) {


  if( !inherits(try(XML::readHTMLTable("http://cran.r-project.org/web/packages/BIGDAWG/index.html",header=F),silent=T),"try-error") ) {

    MainDir <- getwd()
    on.exit(setwd(MainDir), add = TRUE)

    getDir <- path.package('BIGDAWG')
    putDir <- paste(getDir,"/data",sep="")
    if(!dir.exists(putDir)) { dir.create(putDir) }

    if(!Restore) {

      #Check current version against BIGDAWG version
      if(!Force) {

        setwd(putDir)

        # Get IMGT Release Version
        invisible(download.file("ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/version_report.txt",destfile="release_version.txt",method="libcurl"))
        Release <- read.table("version_report.txt",comment.char="",sep="\t")
        RV.current <- Release[2]
        file.remove("version_report.txt")

        # Get BIGDAWG
        UPL <- paste(path.package('BIGDAWG'),"/data/UpdatePtnAlign.RData",sep="")
        UpdatePtnList <- NULL ; rm(UpdatePtnList)
        if( file.exists(UPL) ) {
          load(UPL)
          EPL <- UpdatePtnList
          rm(UpdatePtnList,UPL)
          UPL.flag=T
        } else {
          EPL <- ExonPtnList
          UPL.flag=F }

        RV.BIGDAWG <- EPL$Release.Version

        cat("Versions:\n","IMGT/HLA current: ",RV.current,"\n BIGDAWG version: ",RV.BIGDAWG,"\n")
        if(grepl(RV.current,RV.BIGDAWG)) { Flag <- T } else { Flag <- F }

      } else {

        Flag <- F

      }# End if() for setting Flag

      #Run Update if Flag = T
      if(Flag) {

        cat("\nYour database seems up to date. Use Force = T to force the update.")

      } else {

        # For creating UpdatePtnAlign.RData object
        # Define download directory
          setwd(putDir)
          Safe <- dir()
          Safe <- c(Safe[!grepl(".txt",Safe)],"UpdatePtnAlign.RData")

        #STEP 1: Define Loci and Read in Reference Exon Map Files
          Loci <- c("A","B","C","DPA1","DPB1","DQA1","DQB1","DRB1","DRB3","DRB4","DRB5")

          #Currently DRB1, DRB3, DRB4, DRB5 aligments in single file
          #Remove if split into individual files
          Loci.get <- c("A","B","C","DPA1","DPB1","DQA1","DQB1","DRB")

          #Exon Info
          RefTab <- BIGDAWG::ExonPtnList$RefExons

        #STEP 2: Download protein alignments and other ancillary files
          cat("Updating reference object for the amino acid analysis.\n")
          cat("Downloading alignment files from the IMGT/HLA.\n")
          GetFiles(Loci.get)
          Release <- read.table('Release.txt',sep="\t") # created during GetFiles download

        #STEP 3: Format alignments for exons of interest
          cat("Formatting alignment files.\n")
          for(i in 1:length(Loci)) { Locus <- Loci[i] ; ExonPtnAlign.Create(Locus,RefTab) }

        #STEP 4: Create ExonPtnAlign list object for BIGDAWG package
          AlignObj.Update(Loci,Release,RefTab)

        #STEP 5: Clean up
          cat("Cleaning up.\n")
          invisible(file.remove(dir()[which(dir() %in% Safe!=T)]))

          cat("Updated.\n")
      }

    } else if (Restore) {

      setwd(putDir)
      if(!file.exists('UpdatePtnAlign.RData')) { stop("No prior update to restore.", call.= F) }
      cat("Restoring original alignment reference object for amino acid analysis.\n")
      invisible(file.remove('UpdatePtnAlign.RData'))
      cat("Restored.\n")

    }

  } else {

    Err.Log(Output,"No.Internet")
    stop("Update stopped.",call.=F)

  }

}

#' DRB345 Column Processing
#'
#' Separates DRB345 column pair into separate columns for each locus
#' @param Tab Data frame of sampleIDs, phenotypes, and genotypes
#' @note This function is for internal BIGDAWG use only.
DRB345.parser <- function(Tab) {
  #Tab Dataset Data-frame
  
  getCol <- grep("DRB345",colnames(Tab))
  df <- matrix(data="^",nrow=nrow(Tab),ncol=6)
  colnames(df) <- c("DRB3","DRB3.1","DRB4","DRB4.1","DRB5","DRB5.1")
  tmp.1 <- sapply(Tab[,getCol[1]],FUN=GetField,Res=1) ; tmp.2 <- sapply(Tab[,getCol[2]],FUN=GetField,Res=1)
  
  tmp <- list()
  # DRB3
  tmp[[1]] <- unlist(grep("DRB3",Tab[,getCol[1]])) ; tmp[[2]] <- unlist(grep("DRB3",Tab[,getCol[2]]))
  df[tmp[[1]],1] <- Tab[tmp[[1]],getCol[1]] ; df[tmp[[2]],2] <- Tab[tmp[[2]],getCol[2]]
  df[setdiff(1:nrow(df),tmp[[1]]),1] <- "DRB3*^" ; df[setdiff(1:nrow(df),tmp[[2]]),2] <- "DRB3*^"
  df[which(tmp.1=="00"),1] <- paste("DRB3*",Tab[which(tmp.1=="00"),getCol[1]],sep="")
  df[which(tmp.2=="00"),2] <- paste("DRB3*",Tab[which(tmp.2=="00"),getCol[2]],sep="")
  
  tmp <- list()
  # DRB4
  tmp[[1]] <- unlist(grep("DRB4",Tab[,getCol[1]])) ; tmp[[2]] <- unlist(grep("DRB4",Tab[,getCol[2]]))
  df[tmp[[1]],3] <- Tab[tmp[[1]],getCol[1]] ; df[tmp[[2]],4] <- Tab[tmp[[2]],getCol[2]]
  df[setdiff(1:nrow(df),tmp[[1]]),3] <- "DRB4*^" ; df[setdiff(1:nrow(df),tmp[[2]]),4] <- "DRB4*^"
  df[which(tmp.1=="00"),3] <- paste("DRB4*",Tab[which(tmp.1=="00"),getCol[1]],sep="")
  df[which(tmp.2=="00"),4] <- paste("DRB4*",Tab[which(tmp.2=="00"),getCol[2]],sep="")
  
  tmp <- list()
  # DRB5
  tmp[[1]] <- unlist(grep("DRB5",Tab[,getCol[1]])) ; tmp[[2]] <- unlist(grep("DRB5",Tab[,getCol[2]]))
  df[tmp[[1]],5] <- Tab[tmp[[1]],getCol[1]] ; df[tmp[[2]],6] <- Tab[tmp[[2]],getCol[2]]
  df[setdiff(1:nrow(df),tmp[[1]]),5] <- "DRB5*^" ; df[setdiff(1:nrow(df),tmp[[2]]),6] <- "DRB5*^"
  df[which(tmp.1=="00"),5] <- paste("DRB5*",Tab[which(tmp.1=="00"),getCol[1]],sep="")
  df[which(tmp.2=="00"),6] <- paste("DRB5*",Tab[which(tmp.2=="00"),getCol[2]],sep="")
  
  # NA's
  df[is.na(Tab[,getCol[1]]),] <- NA ; df[is.na(Tab[,getCol[2]]),] <- NA
  
  Tab.sub <- Tab[,-getCol]
  Tab <- cbind(Tab.sub,df)
  
  return(Tab)
  
}

#' DRB345 haplotype zygosity wrapper
#'
#' Checks DR haplotypes for correct zygosity and flags unanticipated haplotypes
#' @param Genotype Row of data set data frame following DRB345 parsing
#' @param Loci.DR DRBx Loci of interest to test for consistency
#' @note This function is for internal use only.
DRB345.Check.Wrapper <- function(Genotype,Loci.DR) {
  
  # Set non-DRB1 Loci
  Loci.DR <- Loci.DR[-grep("DRB1",Loci.DR)]
  
  # Substitute ^ for 00:00
  Genotype[] <- sapply(Genotype,as.character)
  if( sum(grepl("\\^",Genotype)) > 0 ) { Genotype[] <- gsub("\\^","00:00",Genotype) ; Fill.Flag <- T } else { Fill.Flag <- F }
  
  # Apply Function to each DRBx Locus
  tmp <- lapply(Loci.DR,FUN=DRB345.Check.Zygosity,Genotype=Genotype)
  tmp.calls <- lapply( seq(length(tmp)), FUN = function(i) cbind(tmp[[i]]['Locus_1'], tmp[[i]]['Locus_2']) )
  Genotype[,!grepl("DRB1",colnames(Genotype))] <- do.call(cbind, tmp.calls)
  if( Fill.Flag ) { Genotype[] <- gsub("00:00","^",Genotype) }
  
  DR.HapFlag <- unlist(lapply(tmp,'[','Flag'))
  DR.HapFlag <-paste(DR.HapFlag[which(DR.HapFlag!="")],collapse=",")
  
  Genotype <- cbind(Genotype,DR.HapFlag)
  return(Genotype)
  
  
}

#' DRB345 haplotype zygosity checker single locus
#'
#' Checks DR haplotypes for correct zygosity and flags unanticipated haplotypes for a single DRBx
#' @param Locus Locus of interest to test for consistency
#' @param Genotype Row of data set data frame following DRB345 parsing
#' @note This function is for internal use only.
DRB345.Check.Zygosity <- function(Locus,Genotype) {
  
  # Remove Abs Strings
  Genotype <- Filler(Genotype,Type="Remove") ; Genotype <- Genotype[which(Genotype!="")] ;  Genotype <- Genotype[which(Genotype!="")]
  
  DR.out <- data.frame(Locus_1=character(), Locus_2=character(), DR.HapFlag=character(), stringsAsFactors=F)
  Abs <- paste(Locus,"*00:00",sep="")
  
  DR.Locus <- gsub("HLA-","",Locus) ; DR.Calls <- gsub("HLA-","",Genotype)
  DR.Calls <- sapply(DR.Calls,FUN=GetField,Res=1) # get 1 Field Resolution for Genotype Calls
  names(DR.Calls) <- NULL ; Flag <- NULL
  
  #DRB1 - get expected DRB3/4/5 genotypes
  DR345.Exp.Calls <- DRB345.Exp(DR.Calls[grep("DRB1",DR.Calls)])
  
  #DRB345 Check
  getDRB345 <- grep(DR.Locus,DR.Calls) ; DR.obs <- length(getDRB345) ; DR.exp <- sum(grepl(DR.Locus,DR345.Exp.Calls))
  
  # Assign Genotypes
  if( DR.obs != DR.exp ) {
    
    # Inconsistent Genotype Possibilities
    if ( DR.obs==0 && DR.exp>=1 ) {
      # Missing Allele
      DR.out[1, 'Locus_1'] <- Abs ; DR.out[1, 'Locus_2'] <- Abs ; DR.out[1, 'Flag'] <- paste(Locus,"_M",sep="")
    } else if ( DR.obs >=1 && DR.exp==0 ) {
      # Extra Allele
      DR.out[1, 'Locus_1'] <- Genotype[getDRB345[1]] ; DR.out[1, 'Locus_2'] <- Abs ; DR.out[1, 'Flag'] <- paste(Locus,"_P",sep="")
    } else if( DR.obs==1 && DR.exp==2 ) {
      # Presumed Homozygote Missing Allele
      DR.out[1, 'Locus_1'] <- Genotype[getDRB345[1]] ; DR.out[1, 'Locus_2'] <- Genotype[getDRB345[1]] ; DR.out[1, 'Flag'] <- ""
    } else if( DR.obs==2 && DR.exp==1 ) {
      
      if( Genotype[getDRB345[1]] == Genotype[getDRB345[2]] ) {
        # Extra Allele ... False Homozygote Assumption
        DR.out[1, 'Locus_1'] <- Genotype[getDRB345[1]] ; DR.out[1, 'Locus_2'] <- Abs ; DR.out[1, 'Flag'] <- ""
      } else {
        # Extra Allele Present
        DR.out[1, 'Locus_1'] <- Genotype[getDRB345[1]] ; DR.out[1, 'Locus_2'] <-Genotype[getDRB345[2]] ; DR.out[1, 'Flag'] <- paste(Locus,"_P",sep="")
      }
      
    }
    
  } else {
    
    DR.out[1, 'Flag'] <- ""
    
    # Consistent Genotype
    if(  DR.obs==0 ) {
      DR.out[1, 'Locus_1'] <-Abs ; DR.out[1, 'Locus_2'] <- Abs
    } else if( DR.obs==1 ) {
      DR.out[1, 'Locus_1'] <- Genotype[getDRB345[1]] ; DR.out[1, 'Locus_2'] <- Abs
    } else if ( DR.obs==2 ) {
      DR.out[1, 'Locus_1'] <- Genotype[getDRB345[1]] ; DR.out[1, 'Locus_2'] <- Genotype[getDRB345[2]]
    }
    
  }
  
  # Return Result
  return(DR.out)
  
}

#' DRB345 Expected
#'
#' Checks DRB1 Genotype and Returns Expected DR345 Loci
#' @param DRB1.Genotype DRB1 Subject Genotypes
#' @note This function is for internal use only.
DRB345.Exp <- function(DRB1.Genotype) {
  
  #Checks for and fixes certain DRB345 errors that are consistent with known DR haplotypes
  Rules <- list("DRB1*01"="","DRB1*10"="","DRB1*08"="",
                "DRB1*03"="DRB3","DRB1*11"="DRB3","DRB1*12"="DRB3","DRB1*13"="DRB3","DRB1*14"="DRB3",
                "DRB1*04"="DRB4","DRB1*07"="DRB4","DRB1*09"="DRB4",
                "DRB1*15"="DRB5","DRB1*16"="DRB5")
  
  DRB1.Genotype <- gsub("HLA-","",DRB1.Genotype)
  DRB1.Genotype <- sapply(DRB1.Genotype,FUN=GetField,Res=1)
  
  # Allele 1
  DRB1.1 <- DRB1.Genotype[1]
  DR.Gtype <- as.character(Rules[DRB1.1])
  
  # Allele 2
  if(length(DRB1.Genotype)==1) {
    #Consider Homozygote
    DRB1.2 <-  DRB1.Genotype[1]
  } else {
    DRB1.2 <-  DRB1.Genotype[2]
  }
  DR.Gtype <- c(DR.Gtype,as.character(Rules[DRB1.2]))
  DR.Gtype <- DR.Gtype[which(DR.Gtype!="")]
  
  if(length(DR.Gtype)>0) { DR.Gtype <- paste("HLA-",DR.Gtype,sep="") }
  return(DR.Gtype)
  
}

#' Alignment Filter
#'
#' Filter Protein Exon Alignment File for Specific Alleles.
#' @param Align Protein Alignment Object.
#' @param Alleles to be pulled.
#' @param Locus Locus to be filtered against.
#' @note This function is for internal BIGDAWG use only.
AlignmentFilter <- function(Align, Alleles, Locus) {

  getCols <- c(match(c("Trimmed","Unknowns","NullPositions"),
                     colnames(Align)),
               grep("Pos\\.",colnames(Align)))
  getRows <-  Align[,"Trimmed"] %in% Alleles
  Align.sub <- Align[getRows,getCols]
  Align.sub <- unique(Align.sub)

  if(!is.null(nrow(Align.sub))) {

    Alleles.S <- names(which(table(Align.sub[,'Trimmed'])==1))
    Alleles.M <- names(which(table(Align.sub[,'Trimmed'])>1))

    # Removing Duplicates at 2-Field Level
    if( length(Alleles.M > 0 ) ) {

      Align.tmp <- list()
      for( m in 1:length(Alleles.M) ) {

        Allele <- Alleles.M[m]
        Alignsub.Grp <- Align.sub[which(Align.sub[,"Trimmed"]==Allele),]

        Unknowns.Grp <- which(Alignsub.Grp[,'Unknowns']==min(Alignsub.Grp[,'Unknowns']))
        if(length(Unknowns.Grp)>1) { Unknowns.Grp <- Unknowns.Grp[1] }
        Align.tmp[[Allele]] <- Alignsub.Grp[Unknowns.Grp,]

      }
      Align.tmp <- do.call(rbind,Align.tmp)

      if( length(Alleles.S) > 0 ) {
        AlignMatrix <- rbind(Align.tmp, Align.sub[which(Align.sub[,'Trimmed'] %in% Alleles.S==T),,drop=F])
      } else {
        AlignMatrix <- Align.tmp
      }

    } else {

      AlignMatrix <- Align.sub

    }

    AlignMatrix <- cbind(rep(Locus,nrow(AlignMatrix)),AlignMatrix)
    rownames(AlignMatrix) <- NULL
    colnames(AlignMatrix)[1] <- "Locus"
    colnames(AlignMatrix)[which(colnames(AlignMatrix)=="Trimmed")] <- "Allele.2D"
    AlignMatrix <- AlignMatrix[ order(AlignMatrix[,'Allele.2D']), ]

  } else {

    AlignMatrix <- cbind(rep(Locus,nrow(Align.sub)),Align.sub)
    rownames(AlignMatrix) <- NULL
    colnames(AlignMatrix)[1] <- "Locus"
    colnames(AlignMatrix)[which(colnames(AlignMatrix)=="Trimmed")] <- "Allele.2D"
    AlignMatrix <- AlignMatrix[ order(AlignMatrix[,'Allele.2D']), ]

  }

  return(AlignMatrix)
}

#' Amino Acid Contingency Table Build
#'
#' Build Contingency Tables for Amino Acid Analysis.
#' @param x Filtered alignmnet list element.
#' @param y Phenotype groupings.
#' @note This function is for internal BIGDAWG use only.
AAtable.builder <- function(x,y) {
  #x = list element for filtered alignment (TabAA.list)
  #y = HLA_grp (case vs control)

  # Create count Grp 0 v Grp 1 (Control v Case)
  x[,2] <- gsub(" ","Null",x[,2])
  x[,2] <- gsub("\\*","Unknown",x[,2])
  x[,2] <- gsub("\\.","InDel",x[,2])

  Residues <- unique(x[,2])
  AminoAcid.df <- mat.or.vec(nr=length(Residues),2)
  colnames(AminoAcid.df) <- c("Group.0", "Group.1")
  rownames(AminoAcid.df) <- Residues

  y[,2:3] <- apply(y[,2:3],MARGIN=c(1,2),GetField,Res=2)

  # Grp 0 (Control)
  Grp0 <- y[which(y[,'grp']==0),]
  Grp0cnt <- table(c(x[match(Grp0[,2],x[,1]),2],
                     x[match(Grp0[,3],x[,1]),2]))
  PutRange <- match(rownames(AminoAcid.df),names(Grp0cnt))
  AminoAcid.df[,'Group.0'] <- Grp0cnt[PutRange]

  # Grp 1 (Case)
  Grp1 <- y[which(y[,'grp']==1),]
  Grp1cnt <- table(c(x[match(Grp1[,2],x[,1]),2],
                     x[match(Grp1[,3],x[,1]),2]))
  PutRange <- match(rownames(AminoAcid.df),names(Grp1cnt))
  AminoAcid.df[,'Group.1'] <- Grp1cnt[PutRange]

  AminoAcid.df[is.na(AminoAcid.df)] <- 0

  # drop unknowns
  rmRow <- which(row.names(AminoAcid.df)=="Unknown")
  if( length(rmRow) > 0 ) { AminoAcid.df <- AminoAcid.df[-rmRow,,drop=F] }

  return(AminoAcid.df)

}

#' Contingency Table Check
#'
#' Checks amino acid contingency table data frame to ensure required variation exists.
#' @param x contingency table.
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test.
#' @note This function is for internal BIGDAWG use only.
AA.df.check <- function(x,Strict.Bin) {
  # Returns true if insufficient variations exists
  # RunChiSq Flag is true is sufficient variant exists

  if( nrow(x)<2 ) {
    return(FALSE)
  } else if (Strict.Bin) {
    return(!(RunChiSq(x)$Flag))
  } else {
    return(!(RunChiSq_c(x)$Flag))
  }

}

#' Contingency Table Amino Acid ChiSq Testing
#'
#' Runs ChiSq test on amino acid contingency table data frames.
#' @param x contingency table.
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test.
#' @note This function is for internal BIGDAWG use only.
AA.df.cs <- function(x,Strict.Bin) {
  # RunChiSq on data frame

  if( nrow(x) < 2 ) {

    tmp.chisq <- data.frame(rbind(rep("NCalc",4)))
    colnames(tmp.chisq) <- c("X.square", "df", "p.value", "sig")
    row.names(tmp.chisq) <- "X-squared"
    chisq.out <- list(Matrix = x,
                      Binned = NA,
                      Test = tmp.chisq,
                      Flag = FALSE)


    return( chisq.out )

  } else if (Strict.Bin) {

    return( RunChiSq(x) )

  } else {

    return( RunChiSq_c(x) )

  }

}

#' Create Empty Table
#'
#' Creates matrix of NA for no result tables.
#' @param Locus Locus being analyzed.
#' @param Names Column names for final matrix.
#' @param nr Number of rows.
#' @note This function is for internal BIGDAWG use only.
Create.Null.Table <- function(Locus,Names,nr) {
  nc <- length(Names)
  Data <- c( Locus,rep(NA,nc-1) )
  tmp <- matrix(Data,nrow=nr,ncol=nc)
  colnames(tmp) <- Names
  rownames(tmp) <- NULL
  return(tmp)
}

#' Filter Exon Specific Alignment Sections
#'
#' Filters the ExonPtnAlign object by locus and exon.
#' @param Locus Locus being analyzed.
#' @param Exon Exon being analyzed.
#' @param EPL.Locus ExonPtnAlign object filtered by Locus
#' @param RefExons Reference Exon Table
#' @param E.Ptn.Starts Exon Protein Overlay Map
#' @note This function is for internal BIGDAWG use only.
Exon.Filter <- function(Locus,Exon,EPL.Locus,RefExons,E.Ptn.Starts) {

  # Get Reference Protoen Start
  Ref.Start <- as.numeric(RefExons[RefExons[,'Locus']==Locus,'Reference.Start'])

  # Define 5'/3' Boundary Positions
  E.Start <- as.numeric(E.Ptn.Starts[which(E.Ptn.Starts[,'Exon']==Exon),'Start'])
  E.Stop <- as.numeric(E.Ptn.Starts[which(E.Ptn.Starts[,'Exon']==Exon),'Stop'])
  E.Length <- E.Stop - E.Start + 1

  # Ensure Number Shift Due to lack of Position 0
  if( E.Start >= abs(Ref.Start) ) {
    E.Start.Pos <- E.Start + Ref.Start
  } else {
    E.Start.Pos <- E.Start + Ref.Start - 1
  }

  E.Stop.Pos <- E.Start.Pos + E.Length - 1
  if( E.Start.Pos < 0 && E.Stop.Pos > 0 )  { E.Stop.Pos <- E.Start.Pos + E.Length }

  # Find Exon 5' Boundary Position in ExonPtnAlign Object
  E.Start.Pos <- paste0("Pos.",E.Start.Pos)
  getStart <- match(E.Start.Pos,colnames(EPL.Locus))

  # Find Exon 3' Boundary Position
  E.Stop.Pos <- paste0("Pos.",E.Stop.Pos)
  getStop <- match(E.Stop.Pos,colnames(EPL.Locus))
  testStop <- grep(paste0(E.Stop.Pos,"."),colnames(EPL.Locus),fixed=TRUE)
  if( length(testStop)>0 ) { getStop <- max(testStop) }

  # Define Amino Acid Range to Carve Out
  getOverlap <- seq(getStart,getStop)

  # Restructure Final ExnPtnAlign Object
  getEndCol <- seq(ncol(EPL.Locus)-3,ncol(EPL.Locus))
  EPL.Locus.Exon <- EPL.Locus[,c(1:4,getOverlap,getEndCol),drop=F]

  return(EPL.Locus.Exon)

}

#' Condensing Exon Specific Alignments to Single Dataframe
#'
#' Combines multiple Exon Specific Alignments into a single Alignment object
#' @param EPL.Exon Exon-Locus Specific Amino Acid Alignment.
#' @note This function is for internal BIGDAWG use only.
Condense.EPL <- function(EPL.Exon) {

  df.1 <- EPL.Exon[[1]][,1:4]
  getCol <- ncol(EPL.Exon[[1]])
  df.2 <- EPL.Exon[[1]][,seq(getCol-3,getCol)]

  df <- list()
  for( i in 1:length(EPL.Exon) ) {

    totalCol <- ncol(EPL.Exon[[i]]) - 4
    df[[i]] <- EPL.Exon[[i]][,5:totalCol,drop=F]

  }
  df <- do.call(cbind,df)
  df.out <- cbind(df.1,df,df.2)

  return(df.out)

}

#' Check Input Parameters
#'
#' Check input parameters for invalid entries.
#' @param HLA Logical indicating whether data is HLA class I/II genotyping data only.
#' @param Loci.Set Input list defining which loci to use for analyses (combinations permitted).
#' @param Exon Numeric Exon(s) for targeted amino acid analysis.
#' @param All.Pairwise Logical indicating whether all pairwise loci should be analyzed in haplotype analysis.
#' @param Trim Logical indicating if HLA alleles should be trimmed to a set resolution.
#' @param Res Numeric setting what desired resolution to trim HLA alleles.
#' @param EVS.rm Logical indicating if expression variant suffixes should be removed.
#' @param Missing Numeric setting allowable missing data for running analysis (may use "ignore").
#' @param Cores.Lim Integer setting the number of cores accessible to BIGDAWG (Windows limit is 1 core).
#' @param Return Logical Should analysis results be returned as list.
#' @param Output Logical Should analysis results be written to output directory.
#' @param Merge.Output Logical Should analysis results be merged into a single file for easy access.
#' @param Verbose Logical Should a summary of each analysis be displayed in console.
#' @note This function is for internal use only.
Check.Params <- function (HLA,Loci.Set,Exon,All.Pairwise,Trim,Res,EVS.rm,Missing,Cores.Lim,Return,Output,Merge.Output,Verbose) {

  # Logicals: HLA=TRUE, All.Pairwise=FALSE, EVS.rm=FALSE, Trim=FALSE, Return=FALSE, Merge.FALSE, Verbose=TRUE, TRUE,
  # Numerics: Res=2, Missing=2, Cores.Lim=1L
  # Untested: Data, Results.Dir, Run.Tests, Loci.Set

  if( is.na(as.logical(HLA)) ) { Err.Log(FALSE,"P.Error","HLA") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !missing(Loci.Set) && !is.list(Loci.Set) ) { Err.Log(FALSE,"P.Error","Loci.Set") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !missing(Exon) && !is.numeric(Exon) ) { Err.Log(FALSE,"P.Error","Exon") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(All.Pairwise) ) { Err.Log(FALSE,"P.Error","All.Pairwise") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(EVS.rm) ) { Err.Log(FALSE,"P.Error","EVS.rm") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(Trim) ) { Err.Log(FALSE,"P.Error","Trim") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(Return) ) { Err.Log(FALSE,"P.Error","Return") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(Merge.Output) ) { Err.Log(FALSE,"P.Error","Merge.Output") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(Verbose) ) { Err.Log(FALSE,"P.Error","Verbose") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(Output) ) { Err.Log(FALSE,"P.Error","Output") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.numeric(Res) ) { Err.Log(FALSE,"P.Error","Res") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.numeric(Cores.Lim) && !is.integer(Cores.Lim) ) { Err.Log(FALSE,"P.Error","Cores.Lim") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.numeric(Missing) ) { if(Missing!="ignore") { Err.Log(FALSE,"P.Error","Missing") ; stop("Analysis Stopped.",call.=FALSE) } }

}

#' Check Input Parameters for GLS conversion
#'
#' Check input parameters for invalid entries.
#' @param Convert String Direction for conversion.
#' @param File.Output String Type of output.
#' @param System String Genetic system (HLA or KIR) of the data being converted
#' @param HZY.Red Logical Reduction of homozygote genotypes to single allele.
#' @param DRB345.Check Logical Check DR haplotypes for consistency and flag unusual haplotypes.
#' @param Cores.Lim Integer How many cores can be used.
#' @note This function is for internal use only.
Check.Params.GLS <- function (Convert,File.Output,System,HZY.Red,DRB345.Check,Cores.Lim) {

  if( is.na(match(Convert,c("GL2Tab","Tab2GL"))) ) { Err.Log(FALSE,"P.Error","Convert") ; stop("Analysis Stopped.",call.=FALSE) }
  if( is.na(match(File.Output,c("R","txt","csv","pypop"))) ) { Err.Log(FALSE,"P.Error","File.Output") ; stop("Analysis Stopped.",call.=FALSE) }
  if( is.na(match(System,c("HLA","KIR"))) ) { Err.Log(FALSE,"P.Error","System") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(HZY.Red) ) { Err.Log(FALSE,"P.Error","HZY.Red") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.logical(DRB345.Check) ) { Err.Log(FALSE,"P.Error","DRB345.Check") ; stop("Analysis Stopped.",call.=FALSE) }
  if( !is.numeric(Cores.Lim) || !is.integer(Cores.Lim) ) { Err.Log(FALSE,"P.Error","Cores.Lim") ; stop("Analysis Stopped.",call.=FALSE) }

}

#' Check Cores Parameters
#'
#' Check cores limitation for OS compatibility
#' @param Cores.Lim Integer How many cores can be used.
#' @param Output Logical Should analysis results be written to output directory.
Check.Cores <- function(Cores.Lim,Output) {
  if ( Cores.Lim!=1L ) {
    Cores.Max <- as.integer( floor( parallel::detectCores() * 0.9) )
    if(Sys.info()['sysname']=="Windows" && as.numeric(Cores.Lim)>1) {
      Err.Log(Output,"Windows.Cores") ; stop("Analysis Stopped.",call. = F)
    } else if( Cores.Lim > Cores.Max ) { Cores <- Cores.Max
    } else { Cores <- Cores.Lim }
  } else { Cores <- Cores.Lim }
  return(Cores)
}

#' HLA Formatting Check for Amino Acid Analysis
#'
#' Checks data to see if HLA data is properly formatted .
#' @param x All columns of HLA genotyping data.
#' @note This function is for internal BIGDAWG use only.
CheckHLA <- function(x) {
  #Return TRUE if properly formatted HLA

  # temporary reassignment for test
  x[is.na(x)] <- "00:00" # NA cells
  x[x=="^"] <- "00:00" # absent cells
  x[x==""] <- "00:00" # empty cells

  # test for colon delimiters
  test <- apply(x,MARGIN=c(1,2),FUN=function(z) length(unlist(strsplit(as.character(z),split=":"))))
  test <- apply(test,MARGIN=2,FUN=min)
  Flag <- as.logical(min(test)==2)

  return(Flag)
}

#' HLA Loci Legitimacy Check for Amino Acid Analysis
#'
#' Checks available loci against data to ensure complete overlap.
#' @param x Loci available in exon protein list alignment object.
#' @param y Unique column names
#' @note This function is for internal BIGDAWG use only.
CheckLoci <- function(x,y) {
  #Returns TRUE if absent locus(loci) encountered
  #x=Loci available in ExonPtnList
  #y=Loci.Set from data

  Output <- list()

  y <- unique(unlist(y))
  y <- gsub("HLA-","",y)

  Flag <- ( !sum(y %in% x) == length(y) )
  Output[['Flag']] <- Flag
  if(Flag) {
    Output[['Loci']] <- paste(y[!y %in% x],collapse=",")
  } else {
    Output[['Loci']] <- NA
  }

  return(Output)
}

#' HLA Allele Legitimacy Check for Amino Acid Analysis
#'
#' Checks available alleles against data to ensure complete overlap.
#' @param x Exon protein list alignment object.
#' @param y Genotypes from data file
#' @note This function is for internal BIGDAWG use only.
CheckAlleles <- function(x,y) {

  # Returns TRUE if unknown allele(s) encountered
  # Checks at 2 levels of resolution: Full, 3-Field, 2-Field, 1-Field

  # Define Loci
  Loci <- unique( gsub("\\.1|\\.2|\\_1|\\_2","",colnames(y)) )

  Output <- list()
  for(i in Loci ) {

    # Database Alleles
    x.locus <- x[[i]][,'Allele']
    x.locus[] <- sapply(x.locus, FUN = gsub, pattern="[[:alpha:]]", replacement="")

    # Current Data Alleles
    y.locus <- y[,grep(i,colnames(y))]
    y.locus <- unique(c(y.locus[,1],y.locus[,2]))
    y.locus[] <- sapply(y.locus, FUN = gsub, pattern="[[:alpha:]]", replacement="")
    y.locus <- na.omit(y.locus)
    y.locus <- y.locus[y.locus!="^"]
    y.locus <- y.locus[y.locus!=""]


    # Check Each Allele against Database at defined resolution
    Resolution <- c("Full",3,2,1) ; r = 1

    repeat{

      Res <- Resolution[r]
      #cat(r,":",Res,"\n")

      if( Res=="Full" ) {
        y.locus.sub <- y.locus ; x.locus.sub <- x.locus
      } else {
        y.locus.sub <- sapply(y.locus,GetField,Res=Res)
        x.locus.sub <- sapply(x.locus,GetField,Res=Res)
      }

      A.check <- y.locus.sub %in% x.locus.sub

      if( sum(A.check)==length(y.locus.sub) ) { A.Flag <- FALSE ; break } else { r <- r + 1 ; A.Flag <- TRUE }
      if( r > length(Resolution) ) { break }

    }

    if(A.Flag) { Alleles <- y.locus[!A.check] ; Alleles <- paste(Alleles,collapse=",") }

    Output[[i]] <- list( Flag = ifelse(A.Flag,TRUE,FALSE),
                         Alleles = ifelse(A.Flag,Alleles,"") )

  }

  Flags <- unlist(lapply(Output,"[","Flag")) ; Alleles <-lapply(Output,"[","Alleles")
  if( sum(Flags)>0 ) {

    getFlags <- which(Flags==TRUE)
    Alleles.Flagged <- sapply(getFlags,FUN= function(z) paste(Loci[z], unlist(Alleles[[z]]) , sep="*" )  )

    Out <- list( Flag =  TRUE,
                 Alleles =  Alleles.Flagged )
  } else {
    Out <- list( Flag=FALSE ,
                 Alleles="" )
  }

  return(Out)

}

#' Data Summary Function
#'
#' Summary function for sample population within data file.
#' @param Tab Loci available in exon protein list alignment object.
#' @param All.ColNames Column names from genotype data.
#' @param rescall HLA resolution set for analysis.
#' @param HLA HLA BIGDAWG argument passed to function
#' @param Verbose Summary display carryover from BIGDAWG function.
#' @param Output Data output carryover form BIGDAWG function
#' @note This function is for internal BIGDAWG use only.
PreCheck <- function(Tab,All.ColNames,rescall,HLA,Verbose,Output) {

  Grp0 <- which(Tab[,2]==0)
  Grp1 <- which(Tab[,2]==1)
  nGrp0 <- length(Tab[Grp0,2])
  nGrp1 <- length(Tab[Grp1,2])

  if(min(nGrp0,nGrp1)==0) {
    Err.Log(Output,"Case.Con")
    stop("Analysis Stopped.",call. = F)
  }

  Loci <- as.list(unique(All.ColNames[3:length(All.ColNames)]))
  nLoci <- length(Loci)
  GTYPE <- Tab[,3:ncol(Tab)]
  colnames(GTYPE) <- All.ColNames[3:length(All.ColNames)]
  nGTYPE <- unlist(lapply(Loci,function(x) length(unique(unlist(GTYPE[,which(colnames(GTYPE)==x)])))))
  Grp0un <- unlist(lapply(Loci,function(x) length(unique(unlist(GTYPE[Grp0,which(colnames(GTYPE)==x)])))))
  Grp1un <- unlist(lapply(Loci,function(x) length(unique(unlist(GTYPE[Grp1,which(colnames(GTYPE)==x)])))))

  nMissing <- unlist(lapply(Loci,function(x) sum(is.na(GTYPE[,which(colnames(GTYPE)==x)]))))
  Grp0miss <- unlist(lapply(Loci,function(x) sum(is.na(GTYPE[Grp0,which(colnames(GTYPE)==x)]))))
  Grp1miss <- unlist(lapply(Loci,function(x) sum(is.na(GTYPE[Grp1,which(colnames(GTYPE)==x)]))))

  if(Verbose) {
    cat("  Sample Summary\n")
    cat("    Sample Size (n):",nrow(Tab),"\n")
    cat("    ...Number of Controls/Cases:",paste(paste(nGrp0,nGrp1,sep="/"),collapse=", "),"\n")
    cat("    Allele Count (2n):",nrow(Tab)*2,"\n")
    cat("    Total loci in file:",nLoci,"\n")
    cat("    Unique loci:",paste(Loci,collapse=", "),"\n")
    cat("    Unique alleles per locus:",paste(nGTYPE,collapse=", "),"\n")
    cat("    ...Unique in Controls/Cases:",paste(paste(Grp0un,Grp1un,sep="/"),collapse=", "),"\n")
    cat("    Missing alleles per locus:",paste(nMissing,collapse=", "),"\n")
    cat("    ...Missing in Controls/Cases:",paste(paste(Grp0miss,Grp1miss,sep="/"),collapse=", "),"\n")
    cat("\n")
  }

  if(HLA) {

    Grp0res <- max(unlist(lapply(Loci,function(x) max(unlist(lapply(strsplit(unlist(GTYPE[Grp0,which(colnames(GTYPE)==x)]),split=":"),length))))))
    Grp1res <- max(unlist(lapply(Loci,function(x) max(unlist(lapply(strsplit(unlist(GTYPE[Grp1,which(colnames(GTYPE)==x)]),split=":"),length))))))

    if(max(Grp0res,Grp1res)>4) {
      Err.Log(Output,"High.Res")
      stop("Analysis Stopped.",call. = F)
    }

    if(Verbose){
      cat("  Observed Allele Resolution\n")
      cat("    Max Resolution Controls:",paste(Grp0res,"-Field",sep=""),"\n")
      cat("    Max Resolution Cases:",paste(Grp1res,"-Field",sep=""),"\n")
      cat("    Defined Resolution:",rescall,"\n")
      if(Grp0res!=Grp1res){ cat("  ***** Warning. \n") }
      if(Grp0res!=Grp1res){ cat("  ***** There may exist a Case-Control field resolution imbalance.\n") }
      if(Grp0res!=Grp1res){ cat("  ***** Considering trimming to",paste(min(Grp0res,Grp1res),"-Field resolution.",sep=""),"\n") }
      cat("\n")
    }
  }

  if(HLA) {
    Out <- list(Sample.Size=nrow(Tab),
                   No.Controls=nGrp0,
                   No.Cases=nGrp1,
                   Allele.Count=nrow(Tab)*2,
                   Total.Loci=nLoci,
                   Loci=paste(Loci,collapse=", "),
                   AllelePerLocus=paste(nGTYPE,collapse=", "),
                   MissingPerLocus=paste(nMissing,collapse=", "),
                   MaxResGrp0=paste(Grp0res,"-Field",sep=""),
                   MaxResGrp1=paste(Grp1res,"-Field",sep=""),
                   Suggested.Res=paste(min(Grp0res,Grp1res),"-Field",sep=""),
                   SetRes=rescall)
  } else {
    Out <- list(Sample.Size=nrow(Tab),
                   No.Controls=nGrp0,
                   No.Cases=nGrp1,
                   Allele.Count=nrow(Tab)*2,
                   Total.Loci=nLoci,
                   Loci=paste(Loci,collapse=", "),
                   AllelePerLocus=paste(nGTYPE,collapse=", "),
                   MissingPerLocus=paste(nMissing,collapse=", "),
                   SetRes=rescall)
  }

  return(do.call(rbind,Out))

}

#' Check Data Structure
#'
#' Check data structure for successful conversion.
#' @param Data String Type of output.
#' @param System Character Genetic system HLA or KIR
#' @param Convert String Direction for conversion.
#' @note This function is for internal use only.
Check.Data <- function (Data,System,Convert) {

  if(Convert=="Tab2GL") {

    # Check for column formatting consistency
    if( ncol(Data) < 3 ) { Err.Log(FALSE,"Table.Col") ; stop("Analysis Stopped.",call.=F) }

    # Check for GL string field delimiters Presence
    if ( sum(grepl("\\+",Data[,ncol(Data)])) > 0 || sum(grepl("\\^",Data[,ncol(Data)])) > 0 || sum(grepl("\\|",Data[,ncol(Data)])) > 0 ) {
      Err.Log(FALSE,"Tab.Format") ; stop("Analysis Stopped.",call.=F)
    }

    # Check for repeating column names
    colnames(Data) <- sapply(colnames(Data),FUN=gsub,pattern="\\.1|\\.2|\\_1|\\_2",replacement="")
    DataCol <- which(table(colnames(Data))==2)
    if( length(DataCol)==0 ) { Err.Log(FALSE,"Table.Pairs") ; stop("Analysis Stopped.",call.=F) }

  }

  if(Convert=="GL2Tab") {

    LastCol <- ncol(Data)

    #Check for System Name in GL String
    test <- na.omit(Data[,LastCol])
    test <- test[-which(sapply(test,nchar)==0)]
    if(length(grep(System,test))!=length(test)) {
      Err.Log(FALSE,"GL.Format") ; stop("Analysis Stopped.",call.=F)
    }


    # Check for GL string field delimiters Absence
    if ( sum(grepl("\\+",Data[,LastCol])) == 0 && sum(grepl("\\^",Data[,LastCol])) == 0 && sum(grepl("\\|",Data[,LastCol])) == 0 ) {
      Err.Log(FALSE,"GL.Format") ; stop("Analysis Stopped.",call.=F)
    }

    # Check for ambiguous data at genotype "|"
    if( sum(grepl("\\|",Data[,LastCol]))>0 ) {
      Check.Rows <- paste(grep("\\|",Data[,LastCol]),collapse=",")
      Err.Log(FALSE,"GTYPE.Amb",Check.Rows) ; stop("Analysis Stopped.",call.=F) }
  }

}

#' GL String Locus Check
#'
#' Check GL string for loci appearing in multiple gene fields.
#' @param x GL String to check against
#' @param Loci Loci to check
#' @note This function is for internal use only.
CheckString.Locus <- function(x,Loci) {

  Calls <- sapply(x,FUN=function(x) strsplit(x,"\\+"))
  Calls.loci <- lapply(Calls,FUN=function(x) unlist(lapply(strsplit(x,"\\*"),"[",1)))

  Calls.loci.1 <- unlist(lapply(Calls.loci,"[",1))
  Calls.loci.1 <- colSums(sapply(Loci, FUN = function(z) Calls.loci.1 %in% z))

  Calls.loci.2 <- as.character(unlist(lapply(Calls.loci,"[",2)))
  Calls.loci.2 <- colSums(sapply(Loci, FUN = function(z) Calls.loci.2 %in% z))

  test.CS <- colSums(rbind(Calls.loci.1,Calls.loci.2))
  if( max(test.CS)>2 ) {

    Loci.Err <- paste(Loci[which(test.CS>2)],collapse=",")
    GLS <- paste(x,collapse="^")
    Err.Log(FALSE,"Locus.MultiField",GLS,Loci.Err)
    stop("Analysis Stopped.",call.=FALSE)

  }

  return("ok")

}

#' GL String Allele Check
#'
#' GL String check for allele ambiguity formatting
#' @param x  GL String to check against
#' @note This function is for internal use only.
CheckString.Allele <- function(x) {

  x <- as.character(x)

  if(grepl("/",x)) {
    tmp <- strsplit(unlist(strsplit(x,"/")),"\\*")
    tmp.len <- length(unique(lapply(tmp,length)))
    if( tmp.len > 1 ) {
      Err.Log(FALSE,"Allele.Amb.Format",x)
      stop("Analysis Stopped.",call.=FALSE)
    }
  }

  return("ok")

}

#' Function to Check Release Versions
#'
#' This updates the protein aligment used in checking HLA loci and alleles as well as in the amino acid analysis.
#' @param Package Logical to check for BIGDAWG package versions
#' @param Alignment Logical to check the IMGT/HLA database version for the alignment bundled with BIGDAWG.
#' @param Output Should any error be written to a file
#' @note Requires active internet connection.
CheckRelease <- function(Package=T,Alignment=T,Output=F) {

  if( !inherits(try(XML::readHTMLTable("http://cran.r-project.org/web/packages/BIGDAWG/index.html",header=F),silent=T),"try-error") ) {

    if(Package) {

      CranR <- as.character(XML::readHTMLTable("http://cran.r-project.org/web/packages/BIGDAWG/index.html",header=F)[[1]][1,2])
      GitHubR <- read.table("https://raw.githubusercontent.com/IgDAWG/BIGDAWG/master/DESCRIPTION",sep="\t",stringsAsFactors=F,nrows=4)
      GitHubR <- unlist(strsplit(GitHubR[4,],split=" "))[2]
      CurrR <- as.character(packageVersion('BIGDAWG') )

    }

    if(Alignment) {

      # Get IMGT Release Version

      # release_version not updated consistently
      #download.file("ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/release_version.txt",destfile="release_version.txt",method="libcurl")
      #Release <- read.table("release_version.txt",comment.char="",sep="\t")
      #Release <- apply(Release,MARGIN=1,FUN= function(x) gsub(": ",":",x))
      #RV.current <- unlist(strsplit(Release[3],split=":"))[2]

      URL=file("ftp://ftp.ebi.ac.uk/pub/databases/ipd/imgt/hla/Allele_status.txt",method=getOption("url.method", "libcurl"))
      df <- read.table(URL,sep="\t",nrows=3,comment.char="")
      df.v <- unlist(strsplit(df[3,],split=" "))
      RV.current <- paste(df.v[3:4],collapse=" ")

      # Get BIGDAWG
      UPL <- paste(path.package('BIGDAWG'),"/data/UpdatePtnAlign.RData",sep="")
      UpdatePtnList <- NULL ; rm(UpdatePtnList)
      if( file.exists(UPL) ) {
        load(UPL)
        EPL <- UpdatePtnList
        rm(UpdatePtnList,UPL)
        UPL.flag=T
      } else {
        EPL <- ExonPtnList
        UPL.flag=F }

      RV.BIGDAWG <- EPL$Release.Version

    }

    cat("\n")
    if(Package) { cat("BIGDAWG Package Versions:\n","Installed Version: ",CurrR,"\n CRAN Release Version: ",CranR,"\n Developmental version: ",GitHubR,"\n") }
    if(Package & Alignment) { cat("\n") }
    if(Alignment) {
      if(UPL.flag) {
        cat("IMGT/HLA Versions:\n","IMGT/HLA Version: ",RV.current,"\n BIGDAWG version (from update): ",RV.BIGDAWG,"\n")
      } else {
        cat("IMGT/HLA Versions:\n","IMGT/HLA Version: ",RV.current,"\n BIGDAWG version: ",RV.BIGDAWG,"\n")
      }
    }
    cat("\n")

  } else {

    Err.Log(Output,"No.Internet")
    stop("Analysis stopped.",call.=F)

  }

}

#' Genotype List String to Tabular Data Conversion
#'
#' Expands GL strings to columns of adjacent locus pairs.
#' @param df Data frame containing GL strings
#' @param System Character Genetic system HLA or KIR
#' @param HZY.Red Logical Should homozygote genotypes be a single allele for non-DRB345.
#' @param Abs.Fill Logical Should absent loci special designations be used
#' @param Cores Integer How many cores can be used.
#' @note This function is for internal use only.
Tab2GL.wrapper <- function(df,System,HZY.Red,Abs.Fill,Cores) {
  
  # Define data locus columns assuming Locus columns come in pairs
  colnames(df) <- sapply(colnames(df),FUN=gsub,pattern="\\.1|\\.2|\\_1|\\_2",replacement="")
  DataCol <- which(colnames(df) %in% names(which(table(colnames(df))==2))==TRUE)
  MiscCol <- setdiff(1:ncol(df),DataCol)

  # Check for identical rows of miscellanous information from non-data columns. Ambiguous Data Flag.
  Misc.tmp <- apply(df[,MiscCol],MARGIN=1,FUN=paste,collapse=":")
  if( length(which(table(Misc.tmp)>1))>0 ) {
    Err.Log(FALSE,"Table.Amb") ; stop("Conversion stopped.",call.=F)
  }; rm(Misc.tmp)
  
  # Remove empty data rows
  rmRows <- which(rowSums(apply(df[,DataCol],MARGIN=c(1,2),FUN=nchar))==0)
  if( length(rmRows)!=0 ) { df <- df[-rmRows,] ; rownames(df) <- NULL }
  
  # Pre-format data to SystemLoci*Allele if necessary
  if( sum(grepl(System,colnames(df)[DataCol]))==0 ) { colnames(df)[DataCol] <- paste(System,colnames(df)[DataCol],sep="") }
  for(i in DataCol) {
    if(sum(grepl(colnames(df)[i],df[,i]))==0) {
      df[,i] <- sapply(df[,i], FUN = Append.System, df.name=colnames(df)[i] )
    }
  }

  # Pad Absent Calls for DRBx?
  if( System=="HLA-") {
    getCol <- grep("DRB3|DRB4|DRB5",colnames(df))
    if(length(getCol)>0) {
      if(Abs.Fill) {
        df[,getCol] <- sapply(getCol,FUN=function(i) Filler(df[,i], colnames(df)[i], Type="Fill"))
      } else {
        df[,getCol] <- sapply(getCol,FUN=function(i) Filler(df[,i], Type="Remove"))
      }
    }
  }

  # Run Conversion
  df.list <- lapply(seq(1,nrow(df)), FUN=function(k) df[k,DataCol])
  GL <- parallel::mclapply(df.list,FUN=Tab2GL.Sub,System=System,HZY.Red=HZY.Red,mc.cores=Cores)
  GL <- do.call(rbind,GL)

  if(ncol(GL)==1) { colnames(GL) <- "GL.String" } else if(ncol(GL)==2) { colnames(GL) <- c("GL.String","DR.HapFlag") }
  GL <- cbind(df[,MiscCol],GL)

  return(GL)

}

#' Genotype List String Condenser
#'
#' Condenses column of loci into a GL string using "^"
#' @param x Row of loci to condense
#' @param System Character Genetic system HLA or KIR
#' @param HZY.Red Logical Should homozygote genotypes be a single allele for non-DRB345.
#' @note This function is for internal use only.
Tab2GL.Sub <- function(x,System,HZY.Red) {

  # Identify Loci in data and for HLA-DRB1 expected DRB345 Loci
  x <- x[which(x!="")]
  colnames(x) <- sapply(colnames(x),FUN=gsub,pattern="\\.1|\\.2|\\_1|\\_2",replacement="")
  Loci <- unique(colnames(x))
  if(System=="HLA-") {
    if( sum(grepl("DRB1",Loci))>0 ) { Loci <- c(Loci,DRB345.Exp(x[grep("DRB1",colnames(x))])) }
    if( sum(grepl("\\^",Loci))>0 ) { Loci <- Loci[-grep("\\^",Loci)] }
    Loci <- unique(Loci)
  }

  # Append Locus to ambiguous Allele/Allele calls
  x[] <- sapply(x,Format.Allele,Type="on")

  # Condense Alleles (+)
  GLS <- lapply(Loci,Tab2GL.Loci,Genotype=x,System=System,HZY.Red=HZY.Red)
  GLS <- do.call(rbind,GLS)
  GLS[,1] <- sapply(GLS[,1],FUN=gsub,pattern="NA+NA|\\+NA|NA\\+",replacement="")
  GLS[GLS=="OK"] <- ""

  # Condense Chromosomes (^)
  Out <- paste(as.character(na.omit(GLS[,1])),collapse="^")
  Flag <- paste(GLS[which(GLS[,2]!=""),2],collapse="")

  Out <- c(Out,Flag)

}

#' Locus Condenser for Tab2GL
#'
#' Condenses alleles calls of a single locus string using "+"
#' @param Locus Locus to condense
#' @param Genotype Row of loci to condense
#' @param System Character Genetic system HLA or KIR
#' @param HZY.Red Logical Should homozygote genotypes be a single allele for non-DRB345.
#' @note This function is for internal use only.
Tab2GL.Loci <- function(Locus,Genotype,System,HZY.Red) {

  Alleles <- Genotype[grep(Locus,Genotype)]

  if(System=="HLA-") {
    if(Locus=="HLA-DRB3" || Locus=="HLA-DRB4" || Locus=="HLA-DRB5") {
      if( sum(grepl("DRB1",Genotype))>0 ) {
        # Assumptions for DRB345
        DRB.GTYPE <- DRB345.Check.Zygosity(Locus, Genotype[grep("DRB",Genotype)] )
        DRB.GTYPE[1,grepl("\\^",DRB.GTYPE)] <- NA
        Alleles <- c(DRB.GTYPE[,'Locus_1'],DRB.GTYPE[,'Locus_2'])
        # for inconsistent DR haplotypes
        DRB345.Flag <- DRB.GTYPE[,'Flag']
      } else if( sum(grepl(grep("DRB",Genotype)))>0 ) {
        # DRB345 but no DRB1 (ZYgosity Check Not Determined)
        DRB345.Flag <- "DRB345_ND"
      } # fi no DRB1 but DRB345
    } else { DRB345.Flag <- NULL } # fi DRB345
  } # fi HLA


  if( sum(is.na(Alleles))==0 && HZY.Red && Alleles[1]==Alleles[2] ) {

    # Homozygous Reduction
    GLS <- Alleles[1]

  } else {

    # Remove NA Strings and Collapse
    Alleles <- Alleles[!is.na(Alleles)]
    GLS <- paste(Alleles,collapse="+")

  }

  if(System=="HLA-") {
    DR.HapFlag <- ifelse(!is.null(DRB345.Flag), paste(unlist(DRB345.Flag),collapse=",") , "")
    Out <- c(GLS,DR.HapFlag)
  } else {
    Out <- GLS
  }

  return(Out)

}

#' Locus Wrapper
#'
#' Wrapper for main L function
#' @param nloci Number of loci being analyzed.
#' @param loci Loci being analyzed.
#' @param loci.ColNames The column names of the loci being analyzed.
#' @param genos Genotype table
#' @param grp Case/Control or Phenotype groupings.
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test
#' @param Output Data return carryover from main BIGDAWG function
#' @param Verbose Summary display carryover from main BIGDAWG function
#' @note This function is for internal BIGDAWG use only.
L.wrapper <- function(nloci,loci,loci.ColNames,genos,grp,Strict.Bin,Output,Verbose) {

  cat("\n>>>> STARTING LOCUS LEVEL ANALYSIS...\n")

  Allele.binned <- list() # Alleles binned during chi-square test
  Allele.freq <- list() # Alleles Frequencies
  overall.chisq <- list() # Chi-Square Table
  ORtable <- list() # Odds Ratio Table
  Final_binned <- list() # Contingency Table

  for(j in 1:nloci) {

    # Get Locus
    Locus <- loci[j]

    # Run Locus Level Analysis
    L.list <- L(loci.ColNames,Locus,genos,grp,Strict.Bin)

    # Build Output Lists
    Allele.binned[[Locus]] <- L.list[['binned']]
    Allele.freq[[Locus]] <- L.list[['freq']]
    overall.chisq[[Locus]] <- L.list[['chisq']]
    ORtable[[Locus]] <- L.list[['OR']]
    Final_binned[[Locus]] <- L.list[['table']]

  }# END locus loop

  Out <- list()
  Out[['AB']] <- do.call(rbind,Allele.binned)
  Out[['AF']] <- do.call(rbind,Allele.freq)
  Out[['CS']] <- do.call(rbind,overall.chisq)
  Out[['OR']] <- do.call(rbind,ORtable)
  Out[['FB']] <- do.call(rbind,Final_binned)

  if(Output) {
    ## write to file
    write.table(Out[['AF']], file = paste("Locus_freqs.txt",sep=""), sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['FB']], file = paste("Locus_table.txt",sep=""), sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['AB']], file = paste("Locus_binned.txt",sep=""), sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['OR']], file = paste("Locus_OR.txt",sep=""), sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['CS']], file = paste("Locus_chisq.txt",sep=""), sep="\t", row.names = F, col.names=T, quote = F)
  }

    cat("> LOCUS LEVEL ANALYSIS COMPLETED","\n")
  if(Verbose) {
    print(as.data.frame(Out[['CS']]),row.names=F)
    cat("\n")
  }

  return(Out)

}

#' File Fetcher
#'
#' Download Protein Alignment and Accessory Files
#' @param Loci HLA Loci to be fetched. Limited Loci available.
#' @note This function is for internal BIGDAWG use only.
GetFiles <- function(Loci) {
  #downloads *_prot.txt alignment files
  #downloads hla_nom_p.txt file

  # Get P-Groups Files
  download.file("https://raw.githubusercontent.com/ANHIG/IMGTHLA/Latest/wmda/hla_nom_p.txt",destfile="hla_nom_p.txt",method="libcurl")

  # Get Release Version
  df <- readLines(con="hla_nom_p.txt", n=3)
  RD <- unlist(strsplit(df[2],split=" "))[3]
  RV <- paste(unlist(strsplit(df[3],split=" "))[3:4],collapse=" ")
  write.table(c(RD,RV),file="Release.txt",quote=F,col.names=F,row.names=F)

  # Get Locus Based Alignments
  for(i in 1:length(Loci)) {
    Locus <- Loci[i]
    FileName <- paste(Locus,"_prot.txt",sep="")
    URL <- paste("https://raw.githubusercontent.com/ANHIG/IMGTHLA/Latest/alignments/",FileName,sep="")
    download.file(URL,destfile = FileName,method="libcurl")
  }

}

#' HLA P group File Formatter
#'
#' Format the hla_nom_p.txt read table object for a specific locus.
#' @param x P group object from read.table command.
#' @param Locus Locus to be filtered on.
#' @note This function is for internal BIGDAWG use only.
PgrpFormat <- function(x,Locus) {

  # Identify for Locus ... change necessary if DRB
  x.sub <- x[which(x[,1]==Locus),]
  rownames(x.sub) <- NULL
  x.sub[,2] <- sapply(x.sub[,2],function(i) paste(paste(Locus,"*",unlist(strsplit(i,"/")),sep=""),collapse="/"))
  colnames(x.sub) <- c("Locus","Allele","P.Group")

  #Expand
  x.list <- list()
  for(i in 1:nrow(x.sub)) {
    if(grepl("/",x.sub[i,'Allele'],fixed=T)) {
      tmp <- unlist(strsplit(x.sub[i,'Allele'],"/"))
      tmp <- cbind(rep(Locus,length(tmp)),tmp,rep(x.sub[i,'P.Group'],length(tmp)))
      colnames(tmp) <- colnames(x.sub)
      x.list[[i]] <- tmp
    } else {
      x.list[[i]] <- x.sub[i,]
    }
  }
  x.list <- do.call(rbind,x.list)
  x.list <- x.list[order(x.list[,'Allele']),]
  rownames(x.list) <- NULL
  colnames(x.list) <- c("Locus","Allele","P.Group")
  return(x.list)
}

#' HLA P group Finder
#'
#' Identify P group for a given allele if exists.
#' @param x Allele of interest.
#' @param y Formatted P groups.
#' @note This function is for internal BIGDAWG use only.
PgrpExtract <- function(x,y) {
  getRow <- grep(x,y[,'Allele'],fixed=T)
  if(length(getRow)>=1) {
    if(length(getRow)>1) { getRow <- getRow[which(sapply(as.character(y[getRow,'Allele']),nchar)==nchar(x))] }
    return(as.character(y[getRow,'P.Group']))
  } else { return("") }
}

#' Protein Exon Alignment Formatter
#'
#' Dynamically creates an alignmnet of Allele exons for Analysis.
#' @param Locus Locus alignment to be formatted.
#' @param RefTab Reference exon protein information for alignment formatting.
#' @note This function is for internal BIGDAWG use only.
ExonPtnAlign.Create <- function(Locus,RefTab) {

  #########################################################################
  # Need to remove if DRB split into single locus files
  if(grepl("DRB",Locus)) { Locus.get <- "DRB" } else { Locus.get <- Locus }
  #########################################################################

  AlignMatrix <- NULL; rm(AlignMatrix)

  #Read in P-Groups
  Pgrps <- read.table("hla_nom_p.txt",fill=T,header=F,sep=";",stringsAsFactors=F,strip.white=T,colClasses="character")
  Pgrps[,1] <- gsub("\\*","",Pgrps[,1])
  Pgrps <- PgrpFormat(Pgrps,Locus)

  #Read in Alignment
  Name <- paste0(Locus.get,"_prot.txt")
  Align <- read.table(Name,fill=T,header=F,sep="\t",stringsAsFactors=F,strip.white=T,colClasses="character")

  #Trim
  Align <- as.matrix(Align[-nrow(Align),]) #Remove Footer

  #Begin Formatting
  Align <- as.matrix(Align[-grep("\\|",Align[,1]),1]) #Remove Pipes
  Align[,1] <- sapply(Align[,1],FUN=sub,pattern=" ",replacement="~")
  Align[,1] <- sapply(Align[,1],FUN=gsub,pattern=" ",replacement="")
  Align <- strsplit(Align[,1],"~")
  Align <- as.matrix(do.call(rbind,Align))

  #Adjust rows to blank where Sequence column == Allele Name
  Align[which(Align[,1]==Align[,2]),2] <- ""

  # Remove Prot Numbering Headers
  Align <- Align[-which(Align[,1]=="Prot"),]

  # Get Unique Alleles
  Alleles <- unique(Align[,1])

  # Loop Through and Build Alignment Block
  Block <- list()
  for(i in Alleles) {
    getRows <- which(Align[,1]==i)
    Block[[i]] <- paste(Align[getRows,2],collapse="")
  }
  Block <- cbind(Alleles,do.call(rbind,Block))

  #Fill end gaps with * to make char lengths even
  Block.len <- max(as.numeric(sapply(Block[,2],FUN=nchar)))
  for( i in 1:nrow(Block) ) {
    Block.miss <- Block.len - nchar(Block[i,2])
    if( Block.miss > 0 ) {
      Block[i,2] <- paste0(as.character(Block[i,2]), paste(rep(".",Block.miss),collapse=""))
    }
  }; rm(i)

  #Split Allele name into separate Locus and Allele, Send Back to Align object
  AlignAlleles <- do.call(rbind,strsplit(Block[,1],"[*]"))
  AlignAlleles <- cbind(AlignAlleles,apply(AlignAlleles,MARGIN=c(1,2),FUN=GetField,Res=2)[,2])
  rownames(AlignAlleles) <- NULL

  Align <- cbind(AlignAlleles,Block)
  colnames(Align) <- c("Locus","Allele","Trimmed","FullName","Sequence")

  #Split Sub Alignment into composite elements and Extract relevant positions
  Align.split <- strsplit(Align[,'Sequence'],"")
  Align.split <- do.call(rbind,Align.split)
  AlignMatrix <- cbind(Align[,1:4],Align.split)
  rownames(AlignMatrix) <- NULL

  #Ensure Reference in Row 1
  RefAllele <- paste(RefTab[which(RefTab[,'Locus']==Locus),'Reference.Locus'],
                     RefTab[which(RefTab[,'Locus']==Locus),'Reference.Allele'],
                     sep="*")
  if( !AlignMatrix[1,'FullName']==RefAllele ) {

    Align.tmp <- rbind(AlignMatrix[which(AlignMatrix[1,'Allele']==RefAllele),],
                       AlignMatrix[-which(AlignMatrix[1,'Allele']==RefAllele),])
    AlignMatrix <- Align.tmp
    rm(Align.tmp)

  }

  #Save Reference Row
  RefSeq <- AlignMatrix[1,]

  #Ensure Locus Specific Rows
  AlignMatrix <- AlignMatrix[which(AlignMatrix[,'Locus']==Locus),]

  #Rebind Reference if removed (only for DRB3, DRB4, and DRB5)
  if( !AlignMatrix[1,'FullName']==RefAllele ) { AlignMatrix <- rbind(RefSeq,AlignMatrix) }

  #Remove columns with no amino acids positions (only for DRB3, DRB4, and DRB5)
  #Count occurence of "." and compare to nrow of AlignMatrix
  rmCol <- which( apply(AlignMatrix,MARGIN=2, FUN=function(x) length(which(x=="."))) == nrow(AlignMatrix) )
  if( length(rmCol)>0 ) { AlignMatrix <- AlignMatrix[,-rmCol] }

  #Propagate Consensus Positions
  for( i in 5:ncol(AlignMatrix) ) {
    x <- AlignMatrix[,i]
    x[which(x=="-")] <- x[1]
    AlignMatrix[,i] <- x
  }

  #Rename amino acid positions based on reference numbering
  #Deletions are named according to the preceding position with a .1,.2,etc.
  RefStart <- as.numeric(RefTab[which(RefTab[,'Locus']==Locus),'Reference.Start'])
  RefArray <- AlignMatrix[1,5:ncol(AlignMatrix)]
  Names <- NULL ; RefPos <- RefStart
  for(i in 1:length(RefArray) ) {

    if(RefArray[i]==".") {
      Names <- c(Names, paste0("Pos.",RefPos-1,".",Iteration) )
      Iteration = Iteration + 1
    } else {
      Iteration=1
      Names <- c(Names, paste0("Pos.",RefPos))
      RefPos <- RefPos + 1
      if (RefPos==0) { RefPos <- 1 }
    }

  }
  colnames(AlignMatrix)[5:ncol(AlignMatrix)] <- Names
  rownames(AlignMatrix) <- NULL

  #Add Absent Allele (Absence due to lack of allele and not lack of typing information)
  AlignMatrix <- rbind(c(Locus,"00:00:00:00","00:00",paste(Locus,"*00:00:00:00",sep=""),rep("^",ncol(AlignMatrix)-4)),
                       AlignMatrix)

  #Assign P groups
  AlignMatrix <- cbind(AlignMatrix, sapply(AlignMatrix[,'FullName'],PgrpExtract,y=Pgrps) )
  colnames(AlignMatrix)[ncol(AlignMatrix)] <- "P.group"

  #Tally Unknowns as separate column
  AlignMatrix <- cbind(AlignMatrix,
                       apply(AlignMatrix[,5:(ncol(AlignMatrix)-1)],MARGIN=1,FUN=function(x) length(which(unlist(grep("*",x,fixed=T))>0))) )
  colnames(AlignMatrix)[ncol(AlignMatrix)] <- "Unknowns"

  #Tally Null Positions as separate column
  AlignMatrix <- cbind(AlignMatrix,
                       apply(AlignMatrix[,5:(ncol(AlignMatrix)-2)],MARGIN=1,FUN=function(x) length(which(unlist(grep("-",x,fixed=T))>0))) )
  colnames(AlignMatrix)[ncol(AlignMatrix)] <- "NullPositions"

  #Tally InDels
  AlignMatrix <- cbind(AlignMatrix,
                       apply(AlignMatrix[,5:(ncol(AlignMatrix)-3)],MARGIN=1,FUN=function(x) length(which(unlist(grep(".",x,fixed=T))>0))) )
  colnames(AlignMatrix)[ncol(AlignMatrix)] <- "InDels"

  rownames(AlignMatrix) <- NULL
  FileName <- paste("ExonPtnAlign_",Locus,".obj",sep="")

  save(AlignMatrix,file=FileName)

}

#' Alignment Object Creator
#'
#' Create Object for Exon Protein Alignments.
#' @param Loci Loci to be bundled.
#' @param Release IMGT/HLA database release version.
#' @param RefTab Data of reference exons used for protein alignment creation.
#' @note This function is for internal BIGDAWG use only.
AlignObj.Create <- function(Loci,Release,RefTab) {

  AlignMatrix <- NULL; rm(AlignMatrix)

  ExonPtnList <- list()
  for(i in 1:length(Loci)) {
    Locus <- Loci[i]
    FileName <- paste("ExonPtnAlign_",Locus,".obj",sep="")
    load(FileName) #Loads AlignMatrix
    ExonPtnList[[Locus]] <- AlignMatrix
  }

  ExonPtnList[['Release.Version']] <- as.character(Release[2,])
  ExonPtnList[['Release.Date']] <- as.character(Release[1,])
  ExonPtnList[['RefExons']] <- RefTab
  save(ExonPtnList,file="ExonPtnAlign.obj")

}

#' Updated Alignment Object Creator
#'
#' Synthesize Object for Exon Protein Alignments.
#' @param Loci Loci to be bundled.
#' @param Release IMGT/HLA database release version.
#' @param RefTab Data of reference exons used for protein alignment creation.
#' @note This function is for internal BIGDAWG use only.
AlignObj.Update <- function(Loci,Release,RefTab) {

  AlignMatrix <- NULL; rm(AlignMatrix)

  UpdatePtnList <- list()
  for(i in 1:length(Loci)) {
    Locus <- Loci[i]
    FileName <- paste("ExonPtnAlign_",Locus,".obj",sep="")
    load(FileName) #Loads AlignMatrix
    UpdatePtnList[[Locus]] <- AlignMatrix
  }
  UpdatePtnList[['Release.Version']] <- as.character(Release[2,])
  UpdatePtnList[['Release.Date']] <- as.character(Release[1,])
  UpdatePtnList[['RefExons']] <- RefTab
  save(UpdatePtnList,file="UpdatePtnAlign.RData")

}

#' BIGDAWG Main Wrapper Function v1.1 Livia Tran March 26, 2026
#'
#' This is the main wrapper function for each analysis.
#' @param Data Name of the genotype data file.
#' @param HLA Logical Indicating whether data is HLA class I/II genotyping data only.
#' @param Run.Tests Specifics which tests to run.
#' @param Loci.Set Input list defining which loci to use for analyses (combinations permitted).
#' @param Exon Numeric Exon(s) for targeted amino acid analysis.
#' @param All.Pairwise Logical indicating whether all pairwise loci should be analyzed in haplotype analysis.
#' @param Trim Logical indicating if HLA alleles should be trimmed to a set resolution.
#' @param Res Numeric setting what desired resolution to trim HLA alleles.
#' @param EVS.rm Logical indicating if expression variant suffixes should be removed.
#' @param Missing Numeric setting allowable missing data for running analysis (may use "ignore").
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test.
#' @param Cores.Lim Integer setting the number of cores accessible to BIGDAWG (Windows limit is 1 core).
#' @param Results.Dir Optional, string of full path directory name for BIGDAWG output.
#' @param Return Logical Should analysis results be returned as list.
#' @param Output Logical Should analysis results be written to output directory.
#' @param Merge.Output Logical Should analysis results be merged into a single file for easy access.
#' @param Verbose Logical Should a summary of each analysis be displayed in console.
#' @param Data.Type String describing the data type in the provided dataset. The
#' default is set to 'Locus'. Options are 'Locus' or 'Motif'.
#' @examples
#' \dontrun{
#' ### The following examples use the synthetic data set bundled with BIGDAWG
#'
#' # Haplotype analysis with no missing genotypes for two loci sets
#' # Significant haplotype association with phenotype
#' # BIGDAWG(Data="HLA_data", Run.Tests="H", Missing=0, Loci.Set=list(c("DRB1","DQB1")))
#'
#' # Hardy-Weinberg and Locus analysis ignoring missing data
#' # Significant locus associations with phenotype at all but DQB1
#' # BIGDAWG(Data="HLA_data", Run.Tests="L", Missing="ignore")
#'
#' # Hardy-Weinberg analysis trimming data to 2-Field resolution with no output to files (console only)
#' # Significant locus deviation at DQB1
#' BIGDAWG(Data="HLA_data", Run.Tests="HWE", Trim=TRUE, Res=2, Output=FALSE)
#' }

BIGDAWG <- function(Data, HLA=TRUE, Run.Tests, Loci.Set, Exon, All.Pairwise=FALSE, Trim=FALSE, Res=2, EVS.rm=FALSE, Missing=2, Strict.Bin=FALSE, Cores.Lim=1L, Results.Dir, Return=FALSE, Output=TRUE, Merge.Output=FALSE, Verbose=TRUE, Data.Type = 'Locus') {

  options(warn=-1)

  MainDir <- getwd()
  on.exit(setwd(MainDir), add = TRUE)

  # CHECK PARAMETERS
  if( missing(Data) ) { Err.Log("P.Missing","Data") ; stop("Analysis Stopped.",call.=FALSE) }
  HLA <- as.logical(HLA)
  Check.Params(HLA, Loci.Set, Exon, All.Pairwise, Trim, Res, EVS.rm, Missing, Cores.Lim, Return, Output, Merge.Output, Verbose)

  # MULTICORE LIMITATIONS
  Cores <- Check.Cores(Cores.Lim,Output)

  cat(rep("=",40))
  cat("\n          BIGDAWG: Bridging ImmunoGenomic Data Analysis Workflow Gaps\n")
  cat(rep("=",40),"\n")
  cat("\n>>>>>>>>>>>>>>>>>>>>>>>>> BEGIN Analysis <<<<<<<<<<<<<<<<<<<<<<<<<\n\n")

  # Define Output object
  BD.out <- list()

# ===================================================================================================================================== ####
# Read in Data ________________________________________________________________________________________________________________________ ####

  NAstrings=c("NA","","****","-","na","Na")

  if(is.character(Data)) {

    if (Data=="HLA_data") {

      # Using internal synthetic set
      Tab <- BIGDAWG::HLA_data
      Data.Flag <- "Internal Synthetic Data Set"

    } else {

      # Read in data file entered as string
      if(!file.exists(Data)) { Err.Log(Output,"Bad.Filename", Data) ; stop("Analysis stopped.",call.=F) }
      Tab <- read.table(Data, header = T, sep="\t", stringsAsFactors = F, na.strings=NAstrings, fill=T, comment.char = "#", strip.white=T, blank.lines.skip=T, colClasses="character", check.names=FALSE)
      Data.Flag <- Data

    }

  } else {

    # Using R object
    Tab <- Data
    Data.Flag <- deparse(substitute(Data))

    # Convert Empty Cells to NA
    for ( i in 3:ncol(Tab) ) {
      putCell <- which( sapply( Tab[,i], nchar )==0 )
      if( length(putCell) > 0 ) { Tab[putCell,i] <- NA }
    }

  }

  # Declare Data Input Parameter
  cat("Data Input:",Data.Flag,"\n\n\n")

  # Convert GLS data
  if( ncol(Tab) == 3 ) { GLSFLAG = TRUE } else { GLSFLAG = FALSE }
  if( GLSFLAG && !HLA ) { Err.Log(Output,"notHLA.GLS") }
  if( GLSFLAG && HLA ) {
    cat("Converting Gene List Strings to Tabular Format...\n\n")
    Tab <- GLSconvert(Tab,Convert="GL2Tab",System="HLA",File.Output="R",Strip.Prefix=T,Abs.Fill=T,Cores.Lim=Cores)
  }

  # Prep Data for processing and checks
  Tab <- prepData(Tab, Data.Type)

  # Define and Change to the required output directory
  if (Output) {
    if(missing(Results.Dir)) {
      OutDir <- paste(MainDir,"/output ",format(Sys.time(), "%d%m%y %H%M%S"),sep="")
      dir.create(OutDir)
    } else {
      OutDir <- Results.Dir
    }
  }
  if(Output) { setwd(OutDir) }

# ===================================================================================================================================== ####
# Data Processing and Sanity Checks ___________________________________________________________________________________________________ ####

  cat(">>>> DATA PROCESSING AND CHECKS.\n")

  #### General processing and checks for all data

  # Define Data Columns
  Data.Col <- seq(3,ncol(Tab))

  # RUN TESTS DEFINITIONS
  if ( missing(Run.Tests) ) { Run <- c("HWE","H","L","A") } else { Run <- Run.Tests }
  if(!HLA) {
    if("A" %in% Run) {
      cat("Not HLA data. Skipping Amino Acid Analysis.\n")
      Run <- Run[-which(Run=="A")]
    }
  }

  # BAD DATA DEFINITIONS - No 1's or 0's
  if( length(which(Tab[,Data.Col]==0))>0 || length(which(Tab[,Data.Col]==0))>1 ) {
    Err.Log(Output,"Bad.Data")
    stop("Analysis Stopped.",call. = F)
  }

  # MISSING DATA
  if(Missing == "ignore") {
    cat("Ignoring any missing data.\n")
    Err.Log(Output,"Ignore.Missing")
    rows.rm <- NULL
  } else {
    if (Missing > 2) {
      if ("H" %in% Run) { Err.Log(Output,"Big.Missing") }
    }
    cat("Removing any missing data. This will affect Hardy-Weinberg Equilibrium test.\n")
    geno.desc <- summaryGeno.2(Tab[,Data.Col], miss.val=NAstrings)
    test <- geno.desc[,2] + 2*geno.desc[,3]
    rows.rm <- which(test > Missing)
    if( length(rows.rm) > 0 ) {
      rows.rm <- which(test > Missing)
      ID.rm <- Tab[rows.rm,1]
      Tab <- Tab[-rows.rm,]
      if(Output) { write.table(ID.rm, file="Removed_SampleIDs.txt", sep="\t", row.names=F, col.names=F, quote=F) }
      rm(ID.rm)
    }
    rm(geno.desc,test)
    if(nrow(Tab)==0) { Err.Log(Output,"TooMany.Missing") ; stop("Analysis Stopped.",call. = F) }
  }

  # MULTIPLE SETS AND ANALYSIS DUPLICATION
  if(!missing(Loci.Set)) {
    if( length(Loci.Set)>1 && (All.Pairwise | "L" %in% Run | "A" %in% Run ) ) { Err.Log(Output,"MultipleSets") }
  }

  # DATA MERGE AND NUMBER OF LOCI
  if(Output && Merge.Output && All.Pairwise) {
    if(ncol(Tab)>52) { Err.Log(Output,"AllPairwise.Merge") }
  }

  ##### HLA specific checks

  #Check for the updated ExonPtnList 'UpdatePtnList' and use if found.
  UpdatePtnList <- NULL
  UPL <- paste(path.package('BIGDAWG'),"/data/UpdatePtnAlign.RData",sep="")
  if( file.exists(UPL) ) {
    load(UPL)
    EPL <- UpdatePtnList
    rm(UpdatePtnList)
    UPL.flag=T
  } else {
    rm(UpdatePtnList,UPL)
    EPL <- BIGDAWG::ExonPtnList
    UPL.flag=F }

  if(Trim & !HLA) { Err.Log(Output,"NotHLA.Trim") }
  if(EVS.rm & !HLA) { Err.Log(Output,"NotHLA.EVS.rm") }
  if(!HLA) { DRBFLAG <- NULL }  else { DRB345.test <- length(grep("DRB345",colnames(Tab)))>0 }

  if(HLA) {

    if(Trim | EVS.rm | "A" %in% Run | DRB345.test ) { cat("Running HLA specific check functions...\n") }

    # Check Locus*Allele Formatting across all loci
    CheckCol <- sum( unlist( apply(Tab[,Data.Col], MARGIN=c(1,2), FUN = function(x) grepl("\\*",na.omit(x))) ) )
    TotalCol <-  ( dim(Tab[,Data.Col])[1] * dim(Tab[,Data.Col])[2] ) - ( length(which(Tab[,Data.Col]=="^")) + sum(is.na(Tab[,Data.Col])) )

    if( CheckCol>0 && CheckCol!=TotalCol ) {
      Err.Log(Output,"Bad.Format.HLA")
      stop("Analysis Stopped.",call. = F)
    }

    # Separate DRB345 if exists as single column pair and check zygosity
    if(DRB345.test) {

      cat("Processing DRB345 column data.\n")

      DRBFLAG <- T

      # Expand DRB3/4/5 to separate column pairs
      Tab <- DRB345.parser(Tab)
      colnames(Tab) <- sapply(colnames(Tab),FUN=gsub,pattern="\\.1",replacement="")

      # Redefine Data Columns
      Data.Col <- seq(3,ncol(Tab))

      # Define DR Loci to Process
      getCol <- grep("DRB",colnames(Tab))
      Loci.DR <- unique(colnames(Tab)[getCol])

      # Process Loci
      Tab.list <- lapply(seq_len(nrow(Tab)), FUN=function(z) Tab[z,getCol])
      Tab.tmp <- mclapply(Tab.list,FUN=DRB345.Check.Wrapper,Loci.DR=Loci.DR,mc.cores=Cores)
      Tab.tmp <- do.call(rbind,Tab.tmp)
      Tab[,getCol] <- Tab.tmp[,grep("DRB",colnames(Tab.tmp))]
      Tab <- cbind(Tab,Tab.tmp[,'DR.HapFlag']) ; colnames(Tab)[ncol(Tab)] <- "DR.HapFlag"

      #Identify DR345 flagged haplotypes and Write to File
      DR.Flags <- Tab[which(Tab[,'DR.HapFlag']!=""),c(1,2,getCol,ncol(Tab))] ; row.names(DR.Flags) <- NULL

      if(Output) {
        if(!is.null(DR.Flags)) {
          Err.Log(Output,"Bad.DRB345.hap") ; cat("\n")
          write.table(DR.Flags,file="Flagged_DRB345_Haplotypes.txt",sep="\t",quote=F,row.names=F,col.names=T)
        }
      }

      cat("\n")
    } else { DRBFLAG <- F }

    # Separate locus and allele names if data is formatted as Loci*Allele
    Tab[,Data.Col] <- apply(Tab[,Data.Col],MARGIN=c(1,2),FUN=Stripper)

    # Sanity Check for Resolution if Trim="T" and Trim Data
    if(Trim & CheckHLA(Tab[,Data.Col])) {
      cat("--Trimming Data.\n")
      #Tab.untrim <- Tab
      Tab[,Data.Col] <- apply(Tab[,Data.Col],MARGIN=c(1,2),GetField,Res=Res)
      rownames(Tab) <- NULL
    } else if (Trim) {
      Err.Log(Output,"Bad.Format.Trim")
      stop("Analysis Stopped.",call. = F)
    }

    # Sanity Check for Expression Variant Suffix Stripping
    if(EVS.rm & CheckHLA(Tab[,Data.Col])) {

      cat("--Stripping Expression Variants Suffixes.\n")
      Tab[,Data.Col] <- apply(Tab[,Data.Col],MARGIN=c(1,2),gsub,pattern="[[:alpha:]]",replacement="")
      EVS.loci <- as.list(names(EPL))
      EPL <- lapply(EVS.loci,EVSremoval,EPList=EPL)
      names(EPL) <- EVS.loci ; rm(EVS.loci)

    } else if (EVS.rm) {

      Err.Log(Output,"Bad.Format.EVS")
      stop("Analysis Stopped.",call. = F)

    }

    # Sanity Check for Amino Acid Test Feasibility
    if ("A" %in% Run) {

      cat("Running Amino Acid Analysis specific checks functions...\n")

      Release <- EPL$Release.Version

      # Sanity Check for Known HLA loci in Bundled Database Release
      cat(paste("--Checking loci against database version",Release,".\n",sep=""))
      test <- CheckLoci(names(EPL),unique(colnames(Tab)[Data.Col]))
      if( test$Flag  ) { Err.Log(Output,"Bad.Locus.HLA",test$Loci) ; stop("Analysis stopped.",call. = F) }

      # Sanity Check for Known HLA alleles in Bundled Database Release
      cat(paste("--Checking alleles against database version",Release,".\n",sep=""))
      test <- CheckAlleles(EPL, Tab[,Data.Col])
      if( test$Flag ) { Err.Log(Output,"Bad.Allele.HLA",test$Alleles) ; stop("Analysis stopped.",call. = F) }

      # Sanity Check for Analysis and HLA Allele Resolution (MUST perform THIS STEP AFTER TRIM!!!!)
      if(Res<2 | !CheckHLA(Tab[,Data.Col]))  {
        Err.Log(Output,"Low.Res")
        cat("You have opted to run the amino acid analysis.\n")
        stop("Analysis stopped.",call. = F)
      }

    } # End A if statement

  } # End HLA if statement and HLA specific functionalities

  # LOCI SET COLUMN DEFINITIONS
  # This section MUST follow DRB345 processing (above) on the chance that DRB345 is formatted as single column
  # and DRB3, DRB4, or DRB5 is defined in Loci.Set.
  if(missing(Loci.Set)) {
    Set <- list(Data.Col)
  } else {
    Loci.Set <- lapply(Loci.Set,FUN=function(x) sapply(x,toupper))
    Set <- lapply(Loci.Set,FUN=function(x) seq(1,ncol(Tab))[colnames(Tab) %in% x])
  }

  # LOCUS SET DEFINED DOES NOT EXIST IN DATA
  if(!missing(Loci.Set)) {
    Loci.Set <- unique(unlist(Loci.Set))
    Loci.Data <- colnames(Tab)[Data.Col]
    if ( sum(Loci.Set %in% Loci.Data) != length(Loci.Set) ) { Err.Log(Output,"PhantomSets") ; stop("Analysis Stopped.",call. = F) }
  }


# ===================================================================================================================================== ####
# Case-Control Summary ________________________________________________________________________________________________________________ ####

cat("\n>>>> CASE - CONTROL SUMMARY STATISTICS\n")
#cat(paste(rep("_",50),collapse=""),"\n")
if (Trim) { rescall <- paste(Res,"-Field",sep="") } else { rescall <- "Not Defined" }
Check <- PreCheck(Tab,colnames(Tab),rescall,HLA,Verbose,Output)
if(Output) { write.table(Check,file="Data_Summary.txt",sep=": ",col.names=F,row.names=T,quote=F); rm(Check,rescall) }


# ===================================================================================================================================== ####
# Write to Parameter File _____________________________________________________________________________________________________________ ####

  if(Output) {

    if(HLA && !is.null(DRBFLAG)) { DRB345.tmp <- DRBFLAG } else { DRB345.tmp <- NULL }
    if(HLA) { Trim.tmp <- Trim } else { Trim.tmp <- NULL }
    if(HLA && Trim) { Res.tmp <- Res } else { Res.tmp <- NULL }
    if(HLA) { EVS.rm.tmp <- EVS.rm } else { EVS.rm.tmp <- NULL }
    if( !missing(Exon) ) { Exon.tmp <- paste(unique(unlist(Exon)),collapse=",") } else { Exon.tmp <- NULL }

    Params.Run <- list(Time = format(Sys.time(), "%a %b %d %X %Y"),
                       BD.Version = as.character(packageVersion("BIGDAWG")),
                       Cores.Used = Cores,
                       File = Data.Flag,
                       Output.Results = Output,
                       Merge = Merge.Output,
                       Return.Object = Return,
                       Display.Results = Verbose,
                       HLA.Data = HLA,
                       Exon = Exon.tmp,
                       DRB345.Parsed = DRB345.tmp,
                       Tests = paste(Run,collapse=","),
                       All.Pairwise = All.Pairwise,
                       Trim = Trim.tmp,
                       Resolution = Res.tmp,
                       Suffix.Stripping = EVS.rm.tmp,
                       Missing.Allowed = Missing,
                       Strict.Binning = Strict.Bin,
                       Samples.Removed = length(rows.rm))

    Params.Run <- do.call(rbind,Params.Run)
    write.table(Params.Run,file="Run_Parameters.txt",sep=": ", row.names=T, col.names=F, quote=F)
  }

# ===================================================================================================================================== ####
# Hardy Weignberg Equilibrium 'HWE' ___________________________________________________________________________________________________ ####

  if ("HWE" %in% Run) {

    cat("\n>>>> STARTING HARDY-WEINBERG ANALYSIS...\n")
    #cat(paste(rep("_",50),collapse=""),"\n")
    if(HLA && Trim) {
      cat("HWE performed at user defined resolution.\n")
    } else if (HLA) {
      cat("HWE performed at maximum available resolution.\n")
    }

    HWE <- HWE.wrapper(Tab,Output,Verbose)
    BD.out[['HWE']] <- HWE
    rm(HWE)

  } #END HARDY-WEINBERG

# ===================================================================================================================================== ####
# Set Loop Begin (loop through each defined locus/loci set) ___________________________________________________________________________ ####

  if ( sum( c("H","L","A") %in% Run ) > 0 ) {

    cat("\n>>>>>>>>>>>>>>>>>>>>>>>>> Begin Locus Sets <<<<<<<<<<<<<<<<<<<<<<<<<\n\n")
    if(length(Set)==1) {
      cat("Your analysis has 1 set to analyze.\n")
    } else {
      cat(paste("Your analysis has ", length(Set), " sets to analyze.", sep=""),"\n")
    }

    for(k in 1:length(Set)) {
      cat("\n")
      cat(paste(rep(">",35),collapse=""),"Running Set",k,"\n")

      cols <- Set[[k]]
      Tabsub <- Tab[,c(1,2,cols)]

      #Set Specific Global Variables
      SID <- Tabsub[,1] # sample IDs
      genos <- Tabsub[,3:ncol(Tabsub)] # genotypes
      genos[genos==""] <- NA
      grp <- Tabsub[, 2] # phenotype
      #nGrp0 <- length(which(grp==0))*2 #nalleles
      #nGrp1 <- length(which(grp==1))*2 #nalleles

      loci.ColNames <- gsub(".1","",colnames(genos),fixed=T)

      # the previous line will sub out the first insertion position for an
      # insertion block
      # for example, if an insertion block sequence is 300.1, 300.2, and 300.3,
      # the column names will would be 300.1, 300.1.1, 300.2, 300.2.1, 300.3, and 300.3.1.
      # using sub removes the first occurrence of '.1' in a string, which affects
      # the first insertion position for an insertion block
      # for these cases, find the first insertion position index for any block of
      # insertions (these positions will still have '.1' attached to them) and
      # subtract one to find the affected position and paste the '.1' back to
      # the position name

      if(Data.Type == 'Motif'){
        insertion_position_start <- which(grepl('.1.1', colnames(genos), fixed = TRUE))-1

        for(i in insertion_position_start){
          loci.ColNames[i]<-paste(loci.ColNames[i], '.1', sep = '')
          loci.ColNames[i+1]<-paste(loci.ColNames[i+1], '.1', sep = '')
        }
      }

      loci <- unique(loci.ColNames) # name of loci

      nloci <- as.numeric(length(loci)) # number of loci
      SetName <- paste('Set',k,sep="")

      if(HLA==T) { genos[genos=='^'] <- "00:00" }

      if(Output) {

        OutSetDir <- paste(OutDir,"/Set",k,sep="")
        dir.create(OutSetDir)
        setwd(OutSetDir)

        Params.set <- list(Set = paste("Set",k),
                           Loci.Run = paste(loci,collapse=",")
                           )

        Params.set <- do.call(rbind,Params.set)
        write.table(Params.set,file="Set_Parameters.txt",sep=": ", row.names=T, col.names=F, quote=F)
      }

      SAFE <- c(ls(),"SAFE")

# ===================================================================================================================================== ####
# Haplotype Analysis 'H' ______________________________________________________________________________________________________________ ####

      if ("H" %in% Run) {

        #cat(paste(rep("_",50),collapse="","\n"))

        # Sanity check for set length and All.Pairwise=T
        if (nloci<2) {
          Err.Log(Output,"Loci.No")
          stop("Analysis Stopped.", call. = F)
        } else if (All.Pairwise & nloci<=2)  {
          Err.Log(Output,"Loci.No.AP")
          stop("Analysis Stopped.", call. = F) }

        Haps.list <- H.MC.wrapper(SID,Tabsub,loci,loci.ColNames,genos,grp,All.Pairwise,Strict.Bin,Output,Verbose,Cores)

        if(All.Pairwise) {
          if(length(BD.out[['H']])>0) { BD.out[['H']] <- c(BD.out[['H']],Haps.list) } else { BD.out[['H']] <- Haps.list }
        } else {
          BD.out[['H']][[SetName]] <- Haps.list
        }

        rm(list=ls()[!(ls() %in% SAFE)])

      } #END HAPLOTYPE

# ===================================================================================================================================== ####
# Locus Level 'L' _____________________________________________________________________________________________________________________ ####

      if ("L" %in% Run) {

        #cat(paste(rep("_",50),collapse=""))

        L.list <- L.wrapper(nloci,loci,loci.ColNames,genos,grp,Strict.Bin,Output,Verbose)
        BD.out[['L']][[SetName]] <- list(binned=L.list[['AB']],
                                         freq=L.list[['AF']],
                                         OR=L.list[['OR']],
                                         chisq=L.list[['CS']],
                                         table=L.list[['FB']])

        rm(list=ls()[!(ls() %in% SAFE)])

      } #END LOCUS

# ===================================================================================================================================== ####
# Amino Acid Level 'A' ________________________________________________________________________________________________________________ ####

      if(HLA) {
        if ("A" %in% Run) {

          #cat(paste(rep("_",50),collapse=""))

          if(UPL.flag) { cat("Using updated protein exon alignments for amino acid analysis.\n") }

          A.list <- A.wrapper(loci,loci.ColNames,genos,grp,Exon,EPL,Cores,Strict.Bin,Output,Verbose)

          if(Output) {
            ## write to file
            write.table(Release, file = "Set_Parameters.txt", sep="\t", row.names = F, col.names=F, quote = F, append=T)
          }

          BD.out[['A']][[SetName]] <- list(log=A.list[['AL']],
                                           binned=A.list[['AB']],
                                           freq=A.list[['AF']],
                                           OR=A.list[['OR']],
                                           chisq=A.list[['CS']],
                                           table=A.list[['FB']])

          rm(list=ls()[!(ls() %in% SAFE)])

        } #END AMINO ACID
      }#END if(HLA)

# ===================================================================================================================================== ####
# End Analyses ________________________________________________________________________________________________________________________ ####

    }; rm(k)

 }# END SET LOOP

  if(Output) {

    if(Merge.Output) {

      cat("\nMerging data files ...\n")
      if("HWE" %in% Run) { Run <- Run[-which(Run=="HWE")] }
      if( length(Run)>=1 ) { MergeData_Output(BD.out,Run,OutDir) }

    }

  }

# ===================================================================================================================================== ####
  cat("\n>>>>>>>>>>>>>>>>>>>>>>>>>> End Analysis <<<<<<<<<<<<<<<<<<<<<<<<<<\n")


  if(Output) { setwd(OutDir); save(BD.out, file="Analysis.RData") }
  options(warn=0)

  if(Return) { return(BD.out) }

}# END FUNCTION

#' Prepare imported data v 1.1 10 December 2025
#'
#' Prepare imported data for processing, checks, and analysis.
#' @param Tab Genotypes dataframe.
#' @param data_type The type of data being processed. Options are 'Locus' or 'Motif'.'
#' @note This function is for internal BIGDAWG use only.
prepData <- function(Tab, data_type) {

  Tab[] <- lapply(Tab, as.character)

  colnames(Tab) <- gsub( "HLA-","",colnames(Tab) )

  # a dataframe for motif level analysis consists of amino acid positions as the
  # column name, and amino acid motifs as the content.
  # insertion positions, indicated by sequential increments of .1 following
  # the real amino acid position (example: 200.1, 200.1, 200.3) can be column
  # names, and would be impacted by the following gsub() code. thus, it should
  # not be executed if data_type = 'Motif'.

  if(data_type != 'Motif'){
    colnames(Tab) <- gsub( "\\.1|\\.2|\\_1|\\_2","",colnames(Tab) )
  }

  colnames(Tab) <- toupper(colnames(Tab))
  colnames(Tab) <- gsub( "DRB3.4.5|DRB3/4/5","DRB345",colnames(Tab) )
  rownames(Tab) <- NULL
  Tab <- rmABstrings(Tab)

  return(Tab)

}

#' Replace absent allele strings
#'
#' Replaces allowable absent allele strings with ^ symbol.
#' @param df Genotypes dataframe.
#' @note This function is for internal BIGDAWG use only.
rmABstrings <- function(df) {
  df[] <- apply(df, MARGIN=c(1,2), FUN=function(x) gsub("ABSENT|Absent|absent|Abs|ABS|ab|Ab|AB","^",x) )
  df[df=="00"] <- "^"
  df[df=="00:00"] <- "^"
  df[df=="00:00:00"] <- "^"
  df[df=="00:00:00:00"] <- "^"
  return(df)
}

#' Replace or Fill 00:00 allele strings
#'
#' Replaces or Fills absent allele strings.
#' @param x Genotype
#' @param Locus Locus column to adjust.
#' @param Type String specifying whether to pad ('Fill') or leave blank ('Remove') absent calls
#' @note This function is for internal use only.
Filler <- function(x,Locus=NULL,Type) {

  if (Type=="Fill") {
    which(x=="")
    Locus <- gsub("_1|_2","",Locus)
    x[which(x=="")] <- paste(Locus,"*00:00",sep="")

  }

  if (Type=="Remove") {

    x[] <- sapply(x, FUN=function(x) gsub("ABSENT|Absent|absent|Abs|ABS|ab|Ab|AB","",x) )
    x[grep("\\*00",x)] <- ""

  }

  if (Type=="Sub") {

    x[] <- sapply(x, FUN=function(x) gsub("ABSENT|Absent|absent|Abs|ABS|ab|Ab|AB","^",x) )
    x[grep("\\*00",x)] <- "^"

  }

  return(x)

}

#' Removes System and Locus from Alleles
#'
#' Removes the System and Locus designations for alleles calls in GL2Tab
#' @param x Allele
#' @note This function is for internal use only.
Stripper <- function(x) {

  if( grepl("\\*",x) ) {
    if( is.na(x) ) { Fix <- x
      } else if ( x!="" ) { Fix <- unlist(strsplit(x,"\\*"))[2]
      } else { Fix <- x }
  } else { return (x) }

  return(Fix)

}

#' Expression Variant Suffix Removal
#'
#' Removes expression variant suffixes from HLA alleles in the exon protein alignment object.
#' @param Locus Locus to be filtered against.
#' @param EPList Exon Protein Alignment Object
#' @note This function is for internal BIGDAWG use only.
EVSremoval <- function(Locus,EPList) {

  if( Locus=='Release.Date' ||
      Locus=='Release.Version' ||
      Locus=='RefExons' ||
      Locus=='ExonPtnMap' ) {

    tmp <- EPList[[Locus]]
    return(tmp)

  } else {

    tmp <- EPList[[Locus]]
    tmp[,'Trimmed'] <- sapply(tmp[,'Trimmed'],gsub,pattern="[[:alpha:]]",replacement="")
    return(tmp)

  }

}

#' HLA trimming function
#'
#' Trim a properly formatted HLA allele to desired number of fields.
#' @param x HLA allele.
#' @param Res Resolution desired.
#' @note This function is for internal BIGDAWG use only.
GetField <- function(x,Res) {
  Tmp <- unlist(strsplit(as.character(x),":"))
  if (length(Tmp)<2) {
    return(x)
  } else if (Res==1) {
    return(Tmp[1])
  } else if (Res > 1) {
    Out <- paste(Tmp[1:Res],collapse=":")
    return(Out)
  }
}

#' Haplotype missing Allele summary function
#'
#' Summary function for identifying missing alleles in a matrix of genotypes.
#' @param geno Matrix of genotypes.
#' @param miss.val Vector of codes for allele missing values.
#' @note This function is for internal BIGDAWG use only and is ported from haplo.stats.
summaryGeno.2 <- function (geno, miss.val = 0) {
  # Ported from R package haplo.stats v 1.7.7
  # Authors: Sinnwell JP, Schaid DJ
  # URL: https://cran.r-project.org/web/packages/haplo.stats/index.html
  n.loci <- ncol(geno)/2
  nr <- nrow(geno)
  geno <- haplo.stats::setupGeno(geno, miss.val)
  loc0 <- numeric(nr)
  loc1 <- numeric(nr)
  loc2 <- numeric(nr)
  for (i in 1:nr) {
    first.indx <- seq(1, (2 * n.loci - 1), by = 2)
    miss.one <- is.na(geno[i, first.indx]) | is.na(geno[i,
                                                        first.indx + 1])
    miss.two <- is.na(geno[i, first.indx]) & is.na(geno[i,
                                                        first.indx + 1])
    loc2[i] <- sum(miss.two)
    loc1[i] <- sum(miss.one - miss.two)
    loc0[i] <- sum(!miss.one)
  }
  tbl <- data.frame(missing0 = loc0, missing1 = loc1, missing2 = loc2)
  return(tbl)
}

#' Data Object Merge and Output
#'
#' Whole data set table construction of per haplotype for odds ratio, confidence intervals, and pvalues
#' @param BD.out Output of analysis as list.
#' @param Run Tests that are to be run as defined by Run.Tests.
#' @param OutDir Output directory defined by Results.Dir or default.
#' @note This function is for internal BIGDAWG use only.
MergeData_Output <- function(BD.out,Run,OutDir) {

  FM.out <- data.frame(Analysis=character(),
                       Locus=character(),
                       Allele=character(),
                       Group.0=numeric(),
                       Group.1=numeric())

  CN.out <- data.frame(Analysis=character(),
                       Locus=character(),
                       Allele=character(),
                       Group.0=numeric(),
                       Group.1=numeric())

  OR.out <- data.frame(Analysis=character(),
                       Locus=character(),
                       Allele=character(),
                       OR=numeric(),
                       CI.Lower=numeric(),
                       CI.Upper=numeric(),
                       p.value=numeric(),
                       sig=character())

  CS.out <- data.frame(Analysis=character(),
                       Locus=character(),
                       x.square=numeric(),
                       df=numeric(),
                       p.value=numeric(),
                       sig=character())

  for(i in Run) {

    switch(i,
           H= { TestName <- "Haplotype" },
           L= { TestName <- "Locus" },
           A= { TestName <- "AminoAcid" } )

    Test <- BD.out[[i]]

    for(k in 1:length(Test)) {

      Test.sub <- Test[[k]]

      #Frequencies
      tmp <- Test.sub$freq
      if(i=="A") { Allele <- paste(tmp[,'Position'],tmp[,'Residue'],sep="::") }
      switch(i,
             H = { tmp <- cbind(rep(TestName,nrow(tmp)),rep(colnames(tmp)[1],nrow(tmp)),tmp) },
             L = { tmp <- cbind(rep(TestName,nrow(tmp)),tmp) },
             A = { tmp <- cbind(rep(TestName,nrow(tmp)),tmp[,'Locus'],Allele,tmp[,c('Group.0','Group.1')]) })
      colnames(tmp) <- c("Analysis","Locus","Allele","Group.0","Group.1")
      FM.out <- rbind(tmp,FM.out) ; rm(tmp)

      #Counts
      tmp <- Test.sub$table
      if(i=="A") { Allele <- paste(tmp[,'Position'],tmp[,'Residue'],sep="::") }
      switch(i,
             H = { tmp <- cbind(rep(TestName,nrow(tmp)),rep(colnames(tmp)[1],nrow(tmp)),tmp) },
             L = { tmp <- cbind(rep(TestName,nrow(tmp)),tmp) },
             A = { tmp <- cbind(rep(TestName,nrow(tmp)),tmp[,'Locus'],Allele,tmp[,c('Group.0','Group.1')]) })
      colnames(tmp) <- c("Analysis","Locus","Allele","Group.0","Group.1")
      CN.out <- rbind(tmp,CN.out) ; rm(tmp)

      #Odds Ratios
      tmp <- Test.sub$OR
      if(i=="A") { Allele <- paste(tmp[,'Position'],tmp[,'Residue'],sep="::") }
      switch(i,
             H = { tmp <- cbind(rep(TestName,nrow(tmp)),rep(colnames(tmp)[1],nrow(tmp)),tmp) },
             L = { tmp <- cbind(rep(TestName,nrow(tmp)),tmp) },
             A = { tmp <- cbind(rep(TestName,nrow(tmp)),tmp[,'Locus'],Allele,tmp[,c("OR","CI.lower","CI.upper","p.value","sig")]) })
      colnames(tmp) <- c("Analysis","Locus","Allele","OR","CI.Lower","CI.Upper","p.value","sig")
      OR.out <- rbind(tmp,OR.out) ; rm(tmp)

      #ChiSq
      tmp <- Test.sub$chisq
      if(i=="A") { Locus <- paste(tmp[,'Locus'],tmp[,'Position'],sep="::") }
      switch(i,
             H = { tmp <- cbind(rep(TestName,nrow(tmp)), rep(names(Test)[k],nrow(tmp)), tmp) },
             L = { tmp <- cbind(rep(TestName,nrow(tmp)), tmp) },
             A = { tmp <- cbind(rep(TestName,nrow(tmp)), Locus, tmp[,c('X.square','df','p.value','sig')] ) } )
      colnames(tmp)[1:2] <- c("Analysis","Locus")
      rownames(tmp) <- NULL
      CS.out <- rbind(tmp,CS.out); rm(tmp)

    }; rm(k)

  }; rm(i)

  setwd(OutDir)

  # Remove redundant entries
  # Especially relevant to multi-set runs
  FM.out <- unique(FM.out)
  CN.out <- unique(CN.out)
  CS.out <- unique(CS.out)

  OR.out <- apply(OR.out,MARGIN=c(1,2),as.character)
  OR.out <- unique(OR.out)

  write.table(FM.out,file="Merged_Frequencies.txt",sep="\t",col.names=T,row.names=F,quote=F)
  write.table(CN.out,file="Merged_Counts.txt",sep="\t",col.names=T,row.names=F,quote=F)
  write.table(CS.out,file="Merged_ChiSq.txt",sep="\t",col.names=T,row.names=F,quote=F)
  write.table(OR.out,file="Merged_OddsRatio.txt",sep="\t",col.names=T,row.names=F,quote=F)

}

#' File Name Extraction
#'
#' Function to extract file path.
#' @param x File name.
#' @note This function is for internal use only.
getFileName <- function(x) {

  tmpDir <- dirname(x)
  tmpName <- basename(x)

  if(basename(x)==x) {
    outName <- paste("Converted_",x,sep="")
  } else {
    outName <- paste(tmpDir,"/Converted_",tmpName,sep="")
  }

  outName <- gsub(".txt","",outName)
  return(outName)

}

#' Build Output Matrix for GL2Tab Conversion
#'
#' Initializes output matrix format for GL2Tab conversion
#' @param System Character Genetic system HLA- or KIR
#' @param Loci The loci for header names
#' @note This function is for internal use only.
Build.Matrix <- function(System,Loci) {

  Loci.Grp <- rep(Loci,each=2)

  if(System=="HLA-") {
    Out <- mat.or.vec(nr=1,nc=length(Loci.Grp)+1) ; colnames(Out) <- c(Loci.Grp,"DR.HapFlag")
  } else {
    Out <- mat.or.vec(nr=1,nc=length(Loci.Grp)) ; colnames(Out) <- Loci.Grp
  }
  colnames(Out)[seq(1,length(Loci.Grp),by=2)] <- paste(Loci,"_1",sep="")
  colnames(Out)[seq(2,length(Loci.Grp),by=2)] <- paste(Loci,"_2",sep="")

  return(Out)

}

#' Tabular Data Locus Format Tool
#'
#' Correctly orders the expanded GL string
#' @param x Single row of converted GL string
#' @param Order Single row data frame for mapping converted GL strings
#' @note This function is for internal use only.
Format.Tab <- function(x,Order) {

  Order[,match(colnames(x),colnames(Order))] <- x
  return(Order)

}

#' Ambiguous Alleles Locus Name Formatting
#'
#' Remove or Append Locus name from/to allele in an ambiguous allele string
#' @param x Allele String
#' @param Type String specifying whether to strip ('off') or append ('on') locus prefix
#' @note This function is for internal use only.
Format.Allele <- function(x,Type) {

  if(Type=="off") {
    if(grepl("/",x)) {
      tmp <- strsplit(unlist(strsplit(x,"/")),"\\*")
      Fix <- paste(unlist(lapply(tmp,"[",1)[1]),
                   paste(unlist(lapply(tmp,"[",2)),collapse="/"),
                   sep="*")
    } else {  Fix <- x }
  }

  if(Type=="on"){
    if(grepl("/",x)) {
      Locus <- unlist(strsplit(x,"\\*"))[1]
      Fix <- paste(
        paste(
          Locus,unlist(strsplit(unlist(strsplit(x,"\\*"))[2],"/"))
          ,sep="*")
        ,collapse="/")
    } else { Fix <- x }
  }

  return(Fix)
}

#' Append Genetic System Locus Designation to Allele String
#'
#' Adds genetic system (HLA/KIR) to each allele name
#' @param x Vector Column genotypes to append
#' @param df.name String SystemLocus name for each allele.
#' @note This function is for internal use only.
Append.System <- function(x,df.name) {

  getAllele <- which(x!="")
  x[getAllele] <- paste(df.name,x[getAllele],sep="*")
  return(x)

}

#' Error Code Display and Logging
#'
#' Displays error codes attributable to data formatting and Locus/Allele naming. Writes to log file.
#' @param Output Logical indicating if Error logging should be written to a file.
#' @param x Log Code.
#' @param y Misc information relevant to error.
#' @param z Misc information relevant to error.
#' @note This function is for internal BIGDAWG use only.
Err.Log <- function (Output, x, y=NULL, z=NULL) {

  cat("*****ERROR!******\n")
  switch(x,
         #Parameters
         P.Missing = { Error <- paste("\nNo ",y," specified. This parameter is not optional. Please see vignette.",sep="") },
         P.Error = { Error <- paste("\nInvalid ",y," parameter. Please see vignette.",sep="") },
         Windows.Cores = { Error <- "\nYou have exceed the maximum allowable cores for Windows. Please see vignette." },

         #Formatting
         Bad.Data = { Error <- "\nYou seem to have subject data that are 0's or 1's, replace these with another value. Please see vignette." },
         Bad.DRB345.hap =  { Error <- "\nWe have encountered unanticipated DR haplotypes. Please see the 'Flagged_DRB345_Haplotypes.txt' output file." },
         Uneven.Prefix =  { Error <- "\nIt seems some (not all) of your loci are formatted as Locus*Allele. Please ensure all loci share a similar format." },
         Bad.Format.HLA = { Error <- "\nYour HLA data includes Locus*Allele genotype formatting. Please ensure all genotypes follow this format." },
         Bad.Format.Trim = { Error <- "\nYour HLA data does not appear to be formatted properly for trimming. Please see vignette." },
         Bad.Format.EVS = { Error <- "\nYour HLA data does not appear to be formatted properly for EVS stripping. Please see vignette." },
         Case.Con = { Error <- "\nYour data does not appear to contain both cases and controls. Please see vignette." },
         Loci.No = { Error <- "\nYou have opted to run the haplotype analysis with too few loci. Please check Set definitions." },
         Loci.No.AP = { Error <- "\nYou have set All.Pairwise to 'True' but one or more your defined locus sets contain too few loci. Please check Set definitions." },
         Low.Res = { Error <- "\nThe resolution of your HLA data is less than 2 or does not appear to be formatted properly. Please see vignette." },
         High.Res = { Error <- "\nYour HLA does not appear to be formatted properly, >4 fields detected. Please see vignette" },

         #Names
         Bad.Filename = {  Error <- paste("\nBIGDAWG could not locate a file labeled: ",y," in the specificied working directory.",sep="") },
         Bad.Locus.NA = { Error <- "\nYou seem to have specified a locus in the Loci.Set that is not present in your data file." },
         Bad.Locus.HLA = { Error <- paste("\nThere may be a discrepancy with HLA loci names. Unrecognized locus name(s) encountered: ",y,".",sep="") },
         Bad.Allele.HLA = { Error <- paste("\nThere may be a discrepancy with allele names. Unrecognized allele name(s) encountered: ",y,".",sep="") },

         #Other
         PhantomSets = { Error <- "\nYou have defined a locus set (Loci.Set) that does not exist in the sample data. Please check the defined locus set." },
         MultipleSets = { Error <- "\nWARNING!!! You have opted to run multiple sets with overlapping loci. To avoid duplication of effort and results from the all pairwise haplotype tests, the locus test, and/or the amino acid test(!!!), it is suggested you run these tests separately on either the largest loci set possible or all loci in a given data set." },
         No.Internet = { Error <- "\nYou do not seem to be connected to the internet. CheckRelease() or UpdateRelease() cannot proceed." },
         TooMany.Missing = { Error <- "\nYour data is missing too many values at each locus. Try using Missing='ignore' when running BIGDAWG and avoid haplotype test." },         #Notifications
         Ignore.Missing = { Error <- "\nConsider setting a missing threshold or running without the haplotype ('H') analysis. A large number of missing data in the haplotype analysis will affect performance, require large amounts of RAM, cause long wait times, and in the worst case crash your computer." },
         Big.Missing = { Error <- "\nThe number of allowable missing will affect performance.\nConsider running with a smaller 'Missing' value or without the haplotype ('H') analysis.\ncontinuing......" },
         AllPairwise.Merge = { Error <- "\nYou have opted to run all pairwise combinations and merge the final data tables. For a large number of loci, this could take a long time. You have been warned!" },
         NotHLA.Trim = { Error <- "\nTrimming only relevant to HLA data, no trimming performed." },
         NotHLA.EVS.rm = { Error <- "\nExpression variant suffix stripping only relevant to HLA data, no stripping performed." },
         Exon = { Error <- paste("\n You have defined an exon that does not exist in locus ",y,". Please adjust exons or loci.set.",sep="") },

         #GLS Notifications
         Tab.Format = { Error <- "\nThe conversion tool encountered GL string delimiters. This isn't valid data for Tab2GL converion. Please see vignette." },
         GL.Format = { Error <- "\nYour GL strings may not be properly formatted. Please see vignette." },
         File.Error = { Error <- paste("\nThe conversion tool could not locate a file labeled ",y," in the specified working directory.",sep="") },
         GTYPE.Amb = { Error <- paste("\nThis appears to contain genotype list piping ('|') for genotype ambiguity strings (data rows: ",y,"). This is not supported in GLSconversion.",sep="") },
         Table.Col = { Error <- "\nThe table for Tab2GL conversion is not properly formatted, too few columns. Please see vignette." },
         Table.Pairs = { Error <- "\nThe table for Tab2GL conversion is not properly formatted, no locus column pairs encountered. Please see vignette." },
         Table.Amb = { Error <- "\nYour data has duplicate identifying information rows, perhaps due to data genotype ambiguity." },
         Locus.MultiField = { Error <- paste("\nYour GL string may be invalid. A locus cannot appear in multiple gene fields! ",z,ifelse(grepl(",",z)," appear"," appears")," in multiple fields of the GL string: ", y, ". Please see vignette.",sep="") },
         Allele.Amb.Format = { Error <- paste("\nYour GL string may be invalid. The ambiguous allele ",y," is not properly formatted. Please see vignette.", sep="") },
         notHLA.GLS = { Error <- paste("\nYou may want GLS conversion for non-HLA data. Currently, BIGDAWG only supports HLA for automatic GLS conversion. Please see vignette.", sep="") }

  )

  cat(Error,"\n",file=stderr())
  if(Output) { write.table(Error,file="Error_Log.txt",sep="\t",quote=F,col.names=F,row.names=F,append=T) }

}

#' Genotype List String Conversion
#'
#' Main Workhorse wrapper for cross converting columnar table to GL string representaion.
#' @param Data String File name or R Data Frame.
#' @param Convert String Direction for conversion.
#' @param File.Output String Type of File.Output.
#' @param System String Genetic system (HLA or KIR) of the data being converted
#' @param HZY.Red Logical Reduction of homozygote genotypes to single allele.
#' @param DRB345.Check Logical Check DR haplotypes for consistency and flag unusual haplotypes.
#' @param Strip.Prefix Logical Should System/Locus prefixes be stripped from table data.
#' @param Abs.Fill Logical Should absent loci special designations be used.
#' @param Cores.Lim Integer How many cores can be used.
GLSconvert <- function(Data,Convert,File.Output="txt",System="HLA",HZY.Red=FALSE,DRB345.Check=FALSE,Strip.Prefix=TRUE,Abs.Fill=FALSE,Cores.Lim=1L) {

  # Check Parameters
  if( missing(Data) ) { Err.Log(FALSE,"P.Missing","Data") ; stop("Conversion Stopped.",call.=FALSE) }
  if( missing(Convert) ) { Err.Log(FALSE,"P.Missing","Convert") ; stop("Conversion Stopped.",call.=FALSE) }
  Check.Params.GLS(Convert,File.Output,System,HZY.Red,DRB345.Check,Cores.Lim)

  # MultiCore Limitations
  Cores <- Check.Cores(Cores.Lim,FALSE)

  # Set nomenclature system and Prefix stripping for pypop output
  if( System == "HLA" ) { System <- "HLA-" }
  if( File.Output == "pypop" ) { Strip.Prefix <- TRUE }

  # Read in Data and Set File.Output File Name
  if( is.character(Data) ) {
    if( file.exists(Data) ) {
      df <- read.table(file=Data,header=T,sep="\t", stringsAsFactors=FALSE, fill=T, comment.char = "#", strip.white=T, blank.lines.skip=T, colClasses="character")
      colnames(df) <- gsub("HLA.","HLA-",colnames(df))
      fileName <- getFileName(Data)
    } else { Err.Log(FALSE,"File.Error",Data) ; stop("Conversion Stopped.",call.=FALSE) }
  } else { df <- Data ; fileName <- "Converted" }
  df[] <- lapply(df, as.character)
  df[is.na(df)] <- ""

  # Check Data Structure/Formatting
  Check.Data(df,System,Convert)

  # Run Data Conversion
  switch(Convert,
         GL2Tab = { data.out <- GL2Tab.wrapper(df,System,Strip.Prefix,Abs.Fill,Cores) } ,
         Tab2GL = { data.out <- Tab2GL.wrapper(df,System,HZY.Red,Abs.Fill,Cores) } )

  # Output DR.HapFlag for HLA data
  if( System=="HLA-" && !DRB345.Check ) { data.out <- data.out[,-grep('DR.HapFlag',colnames(data.out))]  }

  # File Name Ouput Options
  switch(File.Output,
         txt = { fileName <- paste(fileName,".txt",sep="") },
         csv = { fileName <- paste(fileName,".csv",sep="") },
         pypop = { fileName <- paste(fileName,".pop",sep="") } )

  # File.Output Final Converted File
  switch(File.Output,
         R = return(data.out),
         txt = write.table(data.out,file=fileName,sep="\t",quote=F,col.names=T,row.names=F),
         csv = write.csv(data.out,file=fileName,quote=F,col.names=T,row.names=F),
         pypop = write.table(data.out,file=fileName,sep="\t",quote=F,col.names=T,row.names=F) )

}

#' Example HLA Dataset
#'
#' A synthetic dataset of HLA genotypes for using bigdawg.
#'
#' @format A data frame with 2000 rows and 14 variables
"HLA_data"

#' Exon protein alignments.
#'
#' Alignment object for use in the amino acid analysis.
#'
#' @format A list where each element is an alignment dataframe for a single locus.
"ExonPtnList"

#' Case-Control Odds ratio calculation and graphing
#'
#' cci function port epicalc version 2.15.1.0 (Virasakdi Chongsuvivatwong, 2012)
#' @param caseexp Number of cases exposed
#' @param controlex Number of controls exposed
#' @param casenonex Number of cases not exosed
#' @param controlnonex Number of controls not exposed
#' @param cctable A 2-by-2 table. If specified, will supercede the outcome and exposure variables
#' @param graph If TRUE (default), produces an odds ratio plot
#' @param design Specification for graph; can be "case control","case-control", "cohort" or "prospective"
#' @param main main title of the graph
#' @param xlab label on X axis
#' @param ylab label on Y axis
#' @param xaxis two categories of exposure in graph
#' @param yaxis two categories of outcome in graph
#' @param alpha level of significance
#' @param fisher.or whether odds ratio should be computed by the exact method
#' @param exact.ci.or whether confidence limit of the odds ratio should be computed by the exact method
#' @param decimal number of decimal places displayed
#' @note This function is for internal BIGDAWG use only.
cci <- function (caseexp, controlex, casenonex, controlnonex, cctable = NULL, graph = FALSE, design = "cohort", main, xlab, ylab, xaxis, yaxis, alpha = 0.05, fisher.or = TRUE, exact.ci.or = TRUE, decimal = 2) {

  if (is.null(cctable)) {
    frame <- cbind(Outcome <- c(1, 0, 1, 0), Exposure <- c(1, 1, 0, 0), Freq <- c(caseexp, controlex, casenonex, controlnonex))
    Exposure <- factor(Exposure)
    expgrouplab <- c("Non-exposed", "Exposed")
    levels(Exposure) <- expgrouplab
    Outcome <- factor(Outcome)
    outcomelab <- c("Negative", "Positive")
    levels(Outcome) <- outcomelab
    table1 <- xtabs(Freq ~ Outcome + Exposure, data = frame)
  }
  else {
    table1 <- as.table(get("cctable"))
  }

  fisher <- fisher.test(table1)
  caseexp <- table1[2, 2]
  controlex <- table1[1, 2]
  casenonex <- table1[2, 1]
  controlnonex <- table1[1, 1]
  se.ln.or <- sqrt(1/caseexp + 1/controlex + 1/casenonex + 1/controlnonex)

  if (!fisher.or) {
    or <- (caseexp * controlnonex) / (casenonex * controlex)
    #p.value <- chisq.test(table1, correct = FALSE)$p.value
    p.value <- chisq.test(table1,correct=TRUE)$p.value
  } else {
    or <- fisher$estimate
    p.value <- fisher$p.value
  }

  if (exact.ci.or) {
    ci.or <- as.numeric(fisher$conf.int)
  } else {
    #ci.or <- or * exp(c(-1, 1) * qnorm(1 - alpha/2) * se.ln.or)
    ci.or <- c( exp(log(or) - ( qnorm(1 - alpha/2) * se.ln.or) ), exp(log(or) + ( qnorm(1 - alpha/2) * se.ln.or) ) )
  }

  if (graph == TRUE) {
    caseexp <- table1[2, 2]
    controlex <- table1[1, 2]
    casenonex <- table1[2, 1]
    controlnonex <- table1[1, 1]
    if (!any(c(caseexp, controlex, casenonex, controlnonex) <
             5)) {
      if (design == "prospective" || design == "cohort" ||
          design == "cross-sectional") {

        if (missing(main))
          main <- "Odds ratio from prospective/X-sectional study"
        if (missing(xlab))
          xlab <- ""
        if (missing(ylab))
          ylab <- paste("Odds of being", ifelse(missing(yaxis),
                                                "a case", yaxis[2]))
        if (missing(xaxis))
          xaxis <- c("non-exposed", "exposed")
        axis(1, at = c(0, 1), labels = xaxis)
      }
      else {

        if (missing(main))
          main <- "Odds ratio from case control study"
        if (missing(ylab))
          ylab <- "Outcome category"
        if (missing(xlab))
          xlab <- ""
        if (missing(yaxis))
          yaxis <- c("Control", "Case")
        axis(2, at = c(0, 1), labels = yaxis, las = 2)
        mtext(paste("Odds of ", ifelse(xlab == "", "being exposed",
                                       paste("exposure being", xaxis[2]))), side = 1,
              line = ifelse(xlab == "", 2.5, 1.8))
      }
      title(main = main, xlab = xlab, ylab = ylab)
    }
  }

  if (!fisher.or) {
    results <- list(or.method = "Asymptotic", or = or, se.ln.or = se.ln.or,
                    alpha = alpha, exact.ci.or = exact.ci.or, ci.or = ci.or,
                    table = table1, decimal = decimal, p.value = p.value)
  } else {
    results <- list(or.method = "Fisher's", or = or, alpha = alpha,
                    exact.ci.or = exact.ci.or, ci.or = ci.or, table = table1,
                    decimal = decimal, p.value = p.value)
  }

  class(results) <- c("cci", "cc")
  return(results)

}

#' Creation of a 2x2 table using the indicated orientation.
#'
#' make2x2 function port epicalc version 2.15.1.0 (Virasakdi Chongsuvivatwong, 2012)
#' @param caseexp Number of cases exposed
#' @param controlex Number of controls exposed
#' @param casenonex Number of cases not exosed
#' @param controlnonex Number of controls not exposed
#' @note This function is for internal BIGDAWG use only.
make2x2 <- function (caseexp, controlex, casenonex, controlnonex)  {

  table1 <- c(controlnonex, casenonex, controlex, caseexp)
  dim(table1) <- c(2, 2)
  rownames(table1) <- c("Non-diseased", "Diseased")
  colnames(table1) <- c("Non-exposed", "Exposed")
  attr(attr(table1, "dimnames"), "names") <- c("Outcome", "Exposure")
  table1

}

#' Table Maker
#'
#' Table construction of per haplotype for odds ratio, confidence intervals, and pvalues
#' @param x Contingency table with binned rare cells.
#' @note This function is for internal BIGDAWG use only.
TableMaker <- function(x) {
  grp1_sum <- sum(x[,'Group.1'])
  grp0_sum <- sum(x[,'Group.0'])
  grp1_exp <- x[,'Group.1']
  grp0_exp <- x[,'Group.0']
  grp1_nexp <- grp1_sum - grp1_exp
  grp0_nexp <- grp0_sum - grp0_exp
  cclist <- cbind(grp1_exp, grp0_exp, grp1_nexp, grp0_nexp)
  tmp <- as.data.frame(t(cclist))
  names(tmp) <- row.names(x)
  return(tmp)
}

#' Case Control Odds Ratio Calculation from Epicalc
#'
#' Calculates odds ratio and pvalues from 2x2 table
#' @param x List of 2x2 matrices for calculation, output of TableMaker.
#' @note This function is for internal BIGDAWG use only.
cci.pval <- function(x) {
  tmp <- list()
  caseEx <- x[1]
  controlEx <- x[2]
  caseNonEx <- x[3]
  controlNonEx <- x[4]
  table1 <- make2x2(caseEx, controlEx, caseNonEx, controlNonEx)
  tmp1 <- cci(cctable=table1, design = "case-control")
  tmp[['OR']] <- round(tmp1$or,digits=2)
  tmp[['CI.L']] <- round(tmp1$ci.or[1],digits=2)
  tmp[['CI.U']] <- round(tmp1$ci.or[2],digits=2)
  tmp[['p.value']] <-  format.pval(tmp1$p.value)
  tmp[['sig']] <- ifelse(tmp1$p.value <= 0.05,"*","NS")
  return(tmp)
}

#' Case Control Odds Ratio Calculation from Epicalc list variation
#'
#' Variation of the cci.pval function
#' @param x List of 2x2 matrices to apply the cci.pval function. List output of TableMaker.
#' @note This function is for internal BIGDAWG use only.
cci.pval.list <- function(x) {
  tmp <- lapply(x, cci.pval)
  tmp <- do.call(rbind,tmp)
  colnames(tmp) <- c("OR","CI.lower","CI.upper","p.value","sig")
  return(tmp)
}

#' Strict Chi-squared Contingency Table Test
#'
#' Calculates chi-squared contingency table tests and bins all rare cells.
#' @param x Contingency table.
#' @note This function is for internal BIGDAWG use only.
RunChiSq <- function(x) {

  ### get expected values for cells
  ExpCnts <- chisq.test(as.matrix(x))$expected

  ## pull out cells that don't need binning, bin remaining
  #unbinned
  OK.rows <- as.numeric(which(apply(ExpCnts,min,MARGIN=1)>=5))

  if(length(OK.rows)==0) {

    # All rows have cells with expected less than 5.
    tmp.chisq <- data.frame(rbind(rep("NCalc",4)))
    colnames(tmp.chisq) <- c("X.square", "df", "p.value", "sig")
    chisq.out <- list(Matrix = NA,
                      Binned = NA,
                      Test = tmp.chisq,
                      Flag = FALSE)

  } else {

    if(length(OK.rows)>=2) {
      unbinned <- x[OK.rows,]
    } else {
      unbinned <- do.call(cbind,as.list(x[OK.rows,]))
      rownames(unbinned) <- rownames(x)[OK.rows]
    }

    #binned
    Rare.rows <- as.numeric(which(apply(ExpCnts,min,MARGIN=1)<5))
    if(length(Rare.rows)>=2) {
      binned <- x[Rare.rows,]
      New.df <- rbind(unbinned,colSums(x[Rare.rows,]))
      rownames(New.df)[nrow(New.df)] <- "binned"
    } else {
      binned <- cbind(NA,NA)
      colnames(binned) <- c("Group.0","Group.1")
      New.df <- x
    }

    if(nrow(New.df)>1) {

      # flag if final matrix fails Cochran's rule of thumb (more than 20% of exp cells are less than 5)
      # True = OK ; False = Not good for Chi Square
      ExpCnts <- chisq.test(New.df)$expected
      if(sum(ExpCnts<5)==0){
        # all expected are greater than 5
        flag <- TRUE
      } else if( sum(ExpCnts<5)/sum(ExpCnts>=0)<=0.2 && sum(ExpCnts>=1)==length(ExpCnts) ){
        # expected counts < 5 are greater than or equal to 20% of cells
        # all individual counts are >= 1
        flag <- TRUE
      } else {
        # else flag contingency table
        # invalid
        flag <- FALSE
      }

      ## chi square test on binned data
      df.chisq <- chisq.test(New.df)
      Sig <- if(df.chisq$p.value > 0.05) { "NS" } else { "*" }


      ## show results of overall chi-square analysis
      tmp.chisq <- data.frame(cbind(round(df.chisq$statistic,digits=4),
                                    df.chisq$parameter,
                                    format.pval(df.chisq$p.value),
                                    Sig))
      colnames(tmp.chisq) <- c("X.square", "df", "p.value", "sig")

      chisq.out <- list(Matrix = New.df,
                        Binned = binned,
                        Test = tmp.chisq,
                        Flag = flag)


    } else {

      tmp.chisq <- data.frame(rbind(rep("NCalc",4)))
      colnames(tmp.chisq) <- c("X.square", "df", "p.value", "sig")
      chisq.out <- list(Matrix = New.df,
                        Binned = binned,
                        Test = tmp.chisq,
                        Flag = FALSE)

    }

  }

  return(chisq.out)

}

#' Contextual Binning Chi-squared Contingency Table Test
#'
#' Calculates chi-squared contingency table tests and bins rare cells at 20% capture rate.
#' @param x Contingency table.
#' @note This function is for internal BIGDAWG use only.
RunChiSq_c <- function(x) {

  ### get expected values for cells
  ExpCnts <- chisq.test(as.matrix(x))$expected

  # Order Counts
  getOrder <- order(ExpCnts[,1],ExpCnts[,2],decreasing=T)
  ExpCnts <- ExpCnts[getOrder,]
  x.sub <- x[getOrder,]

  # Define Rows
  Safe.cells.rows <- as.numeric(which(apply(ExpCnts,min,MARGIN=1)>=5))
  Rare.cells.rows <- as.numeric(which(apply(ExpCnts,min,MARGIN=1)<5))

  # Define Flags
  Check.Rebinned <- FALSE
  No.Bin <- FALSE

  if(length(Safe.cells.rows)==0) {

    # All rows have cells with expected less than 5.
    tmp.chisq <- data.frame(rbind(rep("NCalc",4)))
    colnames(tmp.chisq) <- c("X.square", "df", "p.value", "sig")
    chisq.out <- list(Matrix = NA,
                      Binned = NA,
                      Test = tmp.chisq,
                      Flag = FALSE)

  } else {

    ### pull out cells that don't need binning, bin remaining
    #unbinned
    if(length(Safe.cells.rows)>=2) {

        unbinned <- x.sub[Safe.cells.rows,]

    } else {

        unbinned <- do.call(cbind,as.list(x.sub[Safe.cells.rows,]))
        rownames(unbinned) <- rownames(x.sub)[Safe.cells.rows]

    }

    unbinned.tmp <- unbinned

    # Iterate through rows -- adding back rows until threshold exceeds 0.2 (20%)
    if( length(Rare.cells.rows)>=3 ) {


      threshold=0 ; i=1
      repeat {

        # Process through adding back rows until threshold exceeds 0.2 (20%)
        get.putRow <- Rare.cells.rows[seq(1,i)]
        get.binRow <- Rare.cells.rows[seq(i+1,length(Rare.cells.rows))]

        if ( length(get.binRow)==1 ) { Stop = i - 1 ; break }

        unbinned.test <- rbind(unbinned.tmp,
                               x.sub[get.putRow,],
                               rbind(colSums(x.sub[get.binRow,]))
        )

        unbinned.test.cs <- chisq.test(unbinned.test)$expected
        threshold <- sum(unbinned.test.cs<5)/ length(unbinned.test.cs)

        if( threshold<=0.2 ) { i = i + 1 } else { Stop = i - 1 ; break }

      }# End repeat

      if( Stop>0 ) {

        # Set up which rows to rescue and bin
        getRescued <- Rare.cells.rows[1:Stop]
        putBinned <- Rare.cells.rows[seq(i,length(Rare.cells.rows))]

        # binning must be more than 1 row
        if( length(putBinned)==1 ) {
          putBinned <- c(getRescued[length(getRescued)],putBinned)
          getResuced <- getRescued[-length(getRescued)]
        }

        # Reclaim any rescued rows to unbinned matrix
        if( length(getRescued) > 1 ) {
          unbinned <- rbind(unbinned, x.sub[getRescued,])
          rownames(unbinned)[getRescued] <- rownames(x.sub)[getRescued]
        } else {
          rebin.tmp <- do.call(cbind,as.list(x.sub[getRescued,]))
          rownames(rebin.tmp) <- rownames(x.sub)[getRescued]
          unbinned <- rbind(unbinned, rebin.tmp)
        }

        # Bin remaining rows
        binned <- x.sub[putBinned,]
        rownames(binned) <- rownames(x.sub)[putBinned]

        Check.Rebinned <- TRUE

      } else {

        # Stop == 0
        # No rows identified to rescue, bin all rare cell containing rows
        binned <- x.sub[Rare.cells.rows,]
        rownames(binned) <- rownames(x.sub)[Rare.cells.rows]

      }

    } else if ( length(Rare.cells.rows)==2 ) {

      # For Rare cells in only 2 rows
      threshold <- sum(ExpCnts<5) / length(x.sub)
      if( threshold > 0.2 ) {

        # must bin both
        binned <- x.sub[Rare.cells.rows,]
        rownames(binned) <- rownames(x.sub)[Rare.cells.rows]

      } else {

        # no binning required
        No.Bin <- TRUE

      }

    } else {

      # Rare.cells.rows == 1
      # No binning possible
      No.Bin <- TRUE


    }

    # Playing no favorites
    # Check if rescued cell expected counts overlap binned expected counts
    if(Check.Rebinned) {

      # If check.rebinned = T
      # getRescued = rescued rows ... can be 1 row
      # putBinned = binned rows ... must be greater than 1 row


      # Rescued rows expected counts
      if(length(getRescued)>1) {
        rescue.expcnts <- apply(ExpCnts[getRescued,],MARGIN=1,paste,collapse=":")
      } else {
        rescue.expcnts <- paste(ExpCnts[getRescued,],collapse=":")
      }

      # Binned rows expected counts
      bin.expcnts <- apply(ExpCnts[putBinned,],MARGIN=1,paste,collapse=":")
      bin.expcnts.rev <- apply(ExpCnts[putBinned,c(2,1)],MARGIN=1,paste,collapse=":")

      rebin.hits <- unique(c(which((rescue.expcnts %in% bin.expcnts)==T),
                             which((rescue.expcnts %in% bin.expcnts.rev)==T)))

      if ( length(rebin.hits)>0 ) {

        rebin.names <- names(rescue.expcnts[rebin.hits])
        rebin.rows <- which((row.names(unbinned) %in% rebin.names)==T)
        binned <- rbind(binned,unbinned[rebin.rows,,drop=F])
        unbinned <- unbinned[-rebin.rows,]

      }

    }

    # Create final matrix New.df
    if ( No.Bin || nrow(unbinned)==0 ) {

      binned <- cbind(NA,NA)
      colnames(binned) <- c("Group.0","Group.1")
      New.df <- x.sub

    } else {

      # merge unbinned and column sums of binned
      New.df <- rbind(unbinned,colSums(binned))
      rownames(New.df)[nrow(New.df)] <- "binned"

      # Reorder binned by row names
      binned <- binned[order(rownames(binned)),]

    }

    # Reorder New.df by row names
    putOrder <- order(row.names(New.df))
    New.df <- New.df[putOrder,]


    if(nrow(New.df)>1) {

      ExpCnts <- chisq.test(New.df)$expected
      # flag if final matrix fails Cochran's rule of thumb (more than 20% of exp cells are less than 5)
      # True = OK ; False = Not good for Chi Square
      if(sum(ExpCnts<5)==0){
        # all expected are greater than 5
        flag <- TRUE
      } else if( sum(ExpCnts<5)/sum(ExpCnts>=0)<=0.2 && sum(ExpCnts>=1)==length(ExpCnts) ){
        # expected counts < 5 are greater than or equal to 20%
        # all individual counts are >= 1
        flag <- TRUE
      } else {
        # else flag contingency table
        flag <- FALSE
      }

      ## chi square test on binned data
      df.chisq <- chisq.test(New.df)
      Sig <- if(df.chisq$p.value > 0.05) { "NS" } else { "*" }


      ## show results of overall chi-square analysis
      tmp.chisq <- data.frame(cbind(round(df.chisq$statistic,digits=4),
                                    df.chisq$parameter,
                                    format.pval(df.chisq$p.value),
                                    Sig))
      colnames(tmp.chisq) <- c("X.square", "df", "p.value", "sig")

      chisq.out <- list(Matrix = New.df,
                        Binned = binned,
                        Test = tmp.chisq,
                        Flag = flag)


    } else {

      flag <- FALSE
      tmp.chisq <- data.frame(rbind(rep("NCalc",4)))
      colnames(tmp.chisq) <- c("X.square", "df", "p.value", "sig")
      chisq.out <- list(Matrix = New.df,
                        Binned = binned,
                        Test = tmp.chisq,
                        Flag = FALSE)
    }


  }

return(chisq.out)

}

#' Genotype List String to Tabular Data Conversion
#'
#' Expands GL strings to columns of adjacent locus pairs.
#' @param df Data frame containing GL strings
#' @param System Character Genetic system HLA or KIR
#' @param Strip.Prefix Logical Should System/Locus prefixes be stripped from table data.
#' @param Abs.Fill Logical Should absent loci special designations be used.
#' @param Cores Integer How many cores can be used
#' @note This function is for internal use only
GL2Tab.wrapper <- function(df,System,Strip.Prefix,Abs.Fill,Cores) {

  # Data column
  LastCol <- ncol(df)
  MiscCol <- seq(1,ncol(df)-1)

  # Remove empty data rows
  df <- na.omit(df)
  rmRows <- which(nchar(df[,LastCol])==0)
  if( length(rmRows)!=0 ) { df <- df[-rmRows,] }
  
  # Run Conversion
  df.list <- strsplit(df[,LastCol],"\\^")
  Tab <- parallel::mclapply(df.list,FUN=GL2Tab.Sub,System=System,mc.cores=Cores)
    Loci <- sort(unique(gsub("_1|_2","",unlist(lapply(Tab,colnames)))))
    if( sum(grepl('DR.HapFlag',Loci)) > 0 ) { Loci <- Loci[-grep('DR.HapFlag',Loci)] }
    Order <- Build.Matrix(System,Loci)

  Tab <- parallel::mclapply(Tab,FUN=Format.Tab,Order=Order,mc.cores=Cores)
    Tab <- do.call(rbind,Tab)
    Tab[Tab==0] <- ""
    Tab[grepl("\\^",Tab)] <- ""

  # Pad Absent Calls for DRBx?
  if( System=="HLA-") {
    getCol <- grep("DRB3|DRB4|DRB5",colnames(Tab))
    if(length(getCol)>0) {
      if(Abs.Fill) {
        Tab[,getCol] <- sapply(getCol,FUN=function(i) Filler(Tab[,i], colnames(Tab)[i], Type="Fill"))
      } else {
        Tab[,getCol] <- sapply(getCol,FUN=function(i) Filler(Tab[,i], Type="Remove"))
      }
    }
  }

  # Strip Prefixes?
  if(Strip.Prefix) { Tab[,seq(1,ncol(Tab)-1)] <- apply(Tab[,seq(1,ncol(Tab)-1)],MARGIN=c(1,2),FUN=Stripper) }

  # Final Table with Misc Information Appended
  Tab <- cbind(df[,MiscCol],Tab)

  return(Tab)

}

#' Genotype List String Expander
#'
#' Expands GL string into a table of adjacent loci
#' @param x Character GL string to expand
#' @param System Character Genetic system HLA or KIR
#' @note This function is for internal use only.
GL2Tab.Sub <- function(x,System) {

  # Break GL String and Remove Any Absent Call Type Strings (00:00)
  Calls <- unlist(sapply(x,FUN=function(x) strsplit(x,"\\+"))) ; names(Calls) <- NULL

  # Check GL String For Locus*Allele/Locus*Allele Ambiguity Formatting
  invisible(sapply(Calls,CheckString.Allele))

  # Collapse Ambiguous allele names to remove locus prefix
  if( sum(grepl("/",Calls)>0 ) ) {
    Calls <- unlist(lapply(Calls,Format.Allele,Type="off"))
  }

  # Get loci and initialize table
  Loci <- unique(unlist(lapply(strsplit(Calls,"\\*"),"[",1)))
  if(System=="HLA-") {
    if( sum(grepl("DRB1",Loci))>0 ) { Loci <- c(Loci,DRB345.Exp(Calls[grep("DRB1",Calls)])) }
    Loci <- unique(Loci)
  }
  Tab <- Build.Matrix(System,Loci)

  # Check GL String For Locus^Gene Field Consistency
  invisible(CheckString.Locus(x,Loci))

  # Populate table
  tmp <- lapply(Loci,GL2Tab.Loci,Genotype=Calls,System=System)
  tmp.calls <- lapply( seq(length(tmp)), FUN = function(i) cbind(tmp[[i]]['Locus_1'], tmp[[i]]['Locus_2']) )
  tmp.calls <- do.call(cbind, tmp.calls)

  DR.HapFlag <- unlist(lapply(tmp,'[','DR.HapFlag'))
  DR.HapFlag <-paste(DR.HapFlag[which(DR.HapFlag!="")],collapse=",")

  Tab[1,] <- cbind(tmp.calls,DR.HapFlag)

  return(Tab)

}

#' Locus Ordering for GL2Tab
#'
#' Orders Locus Calls
#' @param Locus Locus to condense
#' @param Genotype Row of loci to condense
#' @param System Character Genetic system HLA or KIR
#' @note This function is for internal use only.
GL2Tab.Loci <- function(Locus,Genotype,System) {

  Alleles <- Genotype[grep(Locus,Genotype)]

  if( length(Alleles) == 1 && System=="HLA-" ) {
   if( Locus!="HLA-DRB3" || Locus!="HLA-DRB4" || Locus!="HLA-DRB5" ) {
    # Homozygous Assumption for HLA non-DRB345
    Alleles <- c(Alleles,Alleles)
   }
  } else if ( length(Alleles) == 1 ) {
    Alleles <- c(Alleles,"")
  } else if ( length(Alleles) == 0 ) {
    Alleles <- c("","")
  }
  names(Alleles) <- c('Locus_1','Locus_2')

  if(System=="HLA-") {
    if(Locus=="HLA-DRB3" || Locus=="HLA-DRB4" || Locus=="HLA-DRB5") {
      if( sum(grepl("DRB1",Genotype))>0 ) {
        # Assumptions for DRB345
        DRB.GTYPE <- DRB345.Check.Zygosity(Locus,Genotype[grep("DRB",Genotype)])
        DRB.GTYPE[1,grepl("\\^",DRB.GTYPE)] <- ""
        Alleles[] <- c(DRB.GTYPE[,'Locus_1'],DRB.GTYPE[,'Locus_2'])
        # for inconsistent DR haplotypes
        DRB345.Flag <- DRB.GTYPE[,'Flag']
      } else {
        # No DRB1 but DBR345 (ZYgosity Check Not Determined)
        DRB345.Flag <- "DRB345_ND"
      } # fi DRB1
     } else { DRB345.Flag <- NULL } # fi DRB345
    } # fi HLA

  if(System=="HLA-") {
    DR.HapFlag <- ifelse(!is.null(DRB345.Flag), paste(unlist(DRB345.Flag),collapse=",") , "")
    Out <- c(Alleles,DR.HapFlag)
    names(Out)[length(Out)] <- "DR.HapFlag"
  } else {
    Out <- Alleles
  }

 return(Out)

}

#' Genotype Combination Maker
#'
#' Make data frame of possible genotype combinations
#' @param x Number of alleles.
#' @note This function is for internal BIGDAWG use only.
makeComb <- function(x) {
  if(x >= 2) {
    tmp <- t(combn(x,2))
    tmp <- rbind(tmp,t(matrix(rep(1:x,2),byrow=T,ncol=x)))
    tmp <- tmp[do.call(order, as.data.frame(tmp)),]
    return(tmp)
  } else ( return(NA) )
}

#' Observed Frequency
#'
#' Get observed frequency of genotypes
#' @param x Single genotype.
#' @param genos.locus Locus genotypes.
#' @note This function is for internal BIGDAWG use only.
getObsFreq <- function(x,genos.locus) {
  
  if(x[1]==x[2]) {
    length(which(genos.locus[,1]==x[1] & genos.locus[,2]==x[2]))
  } else {
    return(sum(length(which(genos.locus[,1]==x[1] & genos.locus[,2]==x[2])),
               length(which(genos.locus[,1]==x[2] & genos.locus[,2]==x[1]))))
  }
}

#' Chi square matrices
#'
#' Chi Square contingency matrix builder with rare cell binning
#' @param Locus Locus of interest.
#' @param genos.sub Genotypes for locus of interest.
#' @param Allele.Freq Allele frequencies.
#' @param Allele.Combn Allele combinations.
#' @note This function is for internal BIGDAWG use only.
getCS.Mat <- function(Locus,genos.sub,Allele.Freq,Allele.Combn) {
  
  GTYPES <- Allele.Combn[[Locus]]
  
  if(!is.na(GTYPES)[1]) {
  
    nSID <- nrow(genos.sub)
    ColNames <- gsub(".1","",colnames(genos.sub),fixed=T) # column names
    genos.locus <- genos.sub[,which(ColNames==Locus)]
    freq <- Allele.Freq[[Locus]]
    GTYPES <- Allele.Combn[[Locus]]  
    GTYPES <- lapply(seq_len(nrow(GTYPES)), function(x) GTYPES[x,])
    
    #Expected Counts
    freq.Exp <- lapply(GTYPES,FUN=function(x) ifelse(x[1]==x[2],prod(freq[x])*nSID,2*prod(freq[x])*nSID))
    
    #Observed Counts
    GTYPES <- lapply(GTYPES,FUN=function(x) names(freq[x]))
    freq.Obs <- lapply(GTYPES,getObsFreq,genos.locus=genos.locus)
    
    freq.mat <- cbind(do.call(rbind,GTYPES),
                      do.call(rbind,freq.Obs),
                      do.call(rbind,freq.Exp))
    colnames(freq.mat) <- c("Allele.1","Allele.2","Obs","Exp")
    
    #bin rare cells
    freq.bin <- freq.mat[which(as.numeric(freq.mat[,'Exp'])<5),]
    freq.bin <- matrix(data=freq.bin,ncol=ncol(freq.mat),dimnames=dimnames(freq.mat))
    if(nrow(freq.bin)>0) {
      freq.bin <- matrix(c("binned.1","binned.2",sum(as.numeric(freq.bin[,'Obs'])),sum(as.numeric(freq.bin[,'Exp']))),
                         ncol=ncol(freq.bin),
                         dimnames=dimnames(freq.bin))
    }
    
    #Final Matrix for ChiSq
    if(nrow(freq.bin)>0) {
      freq.final <- rbind(freq.mat[which(as.numeric(freq.mat[,'Exp'])>=5),],freq.bin)
    } else {
      freq.final <- freq.mat
    }
    
    #Calculate (Obs - Exp)^2 / Exp
    if(nrow(freq.final)>1) {
      freq.final <- cbind(freq.final,
                          apply(freq.final[,c('Obs','Exp')],
                                MARGIN=1,
                                FUN=function(x) ((as.numeric(x['Obs']) - as.numeric(x['Exp']))^2)/as.numeric(x['Exp'])))
    } else {
      freq.final <- cbind(freq.final,0)
    }
    colnames(freq.final)[ncol(freq.final)] <- "O-E2|E"
    
    return(freq.final)
    
  } else { return(NA) }
  
}

#' Chi square test statistic
#'
#' Calculate chi square test statistic
#' @param Locus Locus of interest.
#' @param Freq.Final Contingency Matrix getCS.Mat output.
#' @note This function is for internal BIGDAWG use only.
getCS.stat <- function(Locus,Freq.Final) {
  
  df <- Freq.Final[[Locus]]
  if(!is.null(nrow(df))) {
    return(sum(as.numeric(df[,'O-E2|E'])))
  } else { return(NA) }
  
}

#' Recompute number of alleles
#'
#' Using Freq.Final, recompute number of alleles
#' @param x Locus specific contingency matrix getCS.Mat output.
#' @note This function is for internal BIGDAWG use only.
getAllele.Count <- function(x) {
  
  if(!is.null(nrow(x))) {
    return( length(unique(c(x[,'Allele.1'],x[,'Allele.2']))) )
  } else { return(NA) }
  
}

#' Hardy Weinbergy Equilibrium Function
#'
#' This is the workhorse function for each group analysis.
#' @param genos.sub data frame of genotype files post processing.
#' @param loci list of loci.
#' @param nloci number of loci in list
#' @note This function is for internal BIGDAWG use only.
HWE.ChiSq <- function(genos.sub,loci,nloci) {
  
  #Format genotypes
  df.1 <- data.frame(genos.sub[,seq(1,nloci*2,2)])
  df.2 <- data.frame(genos.sub[,seq(2,nloci*2,2)])
  colnames(df.2) <- colnames(df.1)
  df <- rbind(df.1,df.2)
  colnames(df) <- do.call(rbind,loci)
  rm(df.1,df.2)
  
  #Allele info
  Alleles <- lapply(loci,FUN=function(x) sort(unique(df[,x]))); names(Alleles) <- loci # unique allele names
  nAlleles <- lapply(loci,FUN=function(x) length(na.omit(unique(df[,x])))); names(nAlleles) <- loci # no. unique alleles
  nAlleles.tot <- lapply(loci,FUN=function(x) length(df[,x])); names(nAlleles.tot) <- loci # total no. alleles
  
  #Possible Genotypes
  Allele.Combn <- lapply(nAlleles,makeComb); names(Allele.Combn) <- loci
  
  #Get Allele Counts and Frequencies
  Allele.cnts <- lapply(loci,FUN=function(x) table(df[,x])); names(Allele.cnts) <- loci
  Allele.Freq <- lapply(loci,FUN=function(x) Allele.cnts[[x]]/nAlleles.tot[[x]]); names(Allele.Freq) <- loci
  
  #Get Observed and Expected Frequencies Matrix for genotypes
  Freq.Final <- lapply(loci,FUN=getCS.Mat,genos.sub=genos.sub,Allele.Freq=Allele.Freq,Allele.Combn=Allele.Combn)
  names(Freq.Final) <- loci
  
  #Calculate Chi Square Statistic for each Locus
  Freq.chisq <- lapply(loci,FUN=getCS.stat,Freq.Final=Freq.Final)
  names(Freq.chisq) <- loci
  
  #Recompute number of alleles and genotypes at each locus from binned contingency matrices (Freq.Final)
  nAlleles.bin <- lapply(Freq.Final,FUN=getAllele.Count)
  names(nAlleles.bin) <- loci
  nGenotypes.bin <- lapply(Freq.Final,nrow)
  names(nGenotypes.bin) <- loci
  nGenotypes.bin[which(as.numeric(lapply(nGenotypes.bin,FUN=is.null))==1)] <- NA
  
  #Get degrees of freedom for each locus
  #Alleles = a ; possible genotypes =g ; df = g - (a - 1)
  Allele.dof <- lapply(loci,FUN=function(x) nGenotypes.bin[[x]] - (nAlleles.bin[[x]] - 1) ); names(Allele.dof) <- loci
  
  #Get P.values from Chi Square distribution
  Freq.pvals <- lapply(loci,FUN=function(x) 1-pchisq(as.numeric(Freq.chisq[[x]]), as.numeric(Allele.dof[[x]])))
  names(Freq.pvals) <- loci
  
  #Format Output
  Test.out <- cbind(loci,
                    do.call(rbind,Freq.chisq),
                    do.call(rbind,Allele.dof),
                    do.call(rbind,Freq.pvals),
                    rep('NS',nloci))
  colnames(Test.out) <- c("Locus","X.square","df","p.value","sig")
  rownames(Test.out) <- NULL
  
  Test.out[which(as.numeric(Test.out[,'p.value'])<0.05),"sig"] <- "*"
  Test.out <- matrix(unlist(Test.out),ncol=ncol(Test.out),dimnames=dimnames(Test.out))
  rownames(Test.out) <- NULL
  
  Test.out[,'X.square'] <- sapply(as.numeric(Test.out[,'X.square']),FUN=round,digits=4)
  Test.out[,'p.value'] <- sapply(as.numeric(Test.out[,'p.value']),FUN=function(x) format.pval(x))
  
  #Flag for invalid degrees of freedom
  flagLoci <- which(as.numeric(Test.out[,'df'])<1)
  
  #Flag for invalid chi square matrices
  Freq.Flag <- lapply(loci,FUN=function(x) ifelse(nrow(Freq.Final[[x]])>2,0,1))
  flagLoci <- unique(c(flagLoci,which(Freq.Flag==1)))
  
  #Flag for invalid chi square matrices
  flagLoci <- unique(c(flagLoci,which(is.na(Test.out[,'X.square']))))
  
  if(length(flagLoci)>0){
    Test.out[Test.out[,'Locus'] %in% unlist(loci[flagLoci]),2:ncol(Test.out)] <- "NCalc"
  }  
  
  return(Test.out)
  
}

#' Amino Acid Wrapper
#'
#' Wrapper function for amino acid analysis.
#' @param loci Loci being analyzed.
#' @param loci.ColNames The column names of the loci being analyzed.
#' @param genos Genotype table.
#' @param grp Case/Control or Phenotype groupings.
#' @param Exon Exon(s)for targeted analysis.
#' @param EPL Protein Alignment List.
#' @param Cores Number of cores to use for analysis.
#' @param Strict.Bin Logical specify if strict rare cell binning should be used in ChiSq test
#' @param Output Data return carryover from main BIGDAWG function
#' @param Verbose Summary display carryover from main BIGDAWG function
#' @note This function is for internal BIGDAWG use only.
A.wrapper <- function(loci,loci.ColNames,genos,grp,Exon,EPL,Cores,Strict.Bin,Output,Verbose) {

  cat("\n>>>> STARTING AMINO ACID LEVEL ANALYSIS...\n")

  # Define Lists for Per Loci Running Tallies
  AAlog <-  list()
  AminoAcid.binned <- list()
  AminoAcid.freq <- list()
  overall.chisq <- list()
  ORtable <- list()
  Final_binned <- list()

  cat("Processing Locus: ")

  # Loop Through Loci
  for(x in 1:length(loci)) {

    # Get Locus
    Locus <- as.character(loci[x])
    cat(Locus,".. ")

    # Read in Locus Alignment file for Locus specific alignments
    if( !missing(Exon) ) {

      Exon <- as.numeric(unique(unlist(Exon)))

      # Get ExonPtnAlign for Locus
      EPL.Locus <- EPL[[Locus]]
      RefExons <- EPL[["RefExons"]]
      E.Ptn.Starts <- EPL[["ExonPtnMap"]][[Locus]]

      EPL.Exon <- list() ; p <- NULL
      for (e in 1:length(Exon)) {
        getExon <- Exon[e]
        if( getExon %in% E.Ptn.Starts[,'Exon'] ) {
          if ( is.null(p) ) { p=1 } else { p = p + 1 }
          EPL.Exon[[p]] <- Exon.Filter(Locus,getExon,EPL.Locus,RefExons,E.Ptn.Starts)
        } else {
          Err.Log(Output,"Exon",Locus)
          stop("Analysis Stopped.",call. = F)
        }
      }
      ExonAlign <- Condense.EPL(EPL.Exon)
      #cbind(colnames(ExonAlign))

    } else {

      ExonAlign <- EPL[[Locus]]

    }

    # Run Amino Acid Analysis
    A.list <- A(Locus,loci.ColNames,genos,grp,Strict.Bin,ExonAlign,Cores)

    # Build Output Lists
    AAlog[[Locus]] <- A.list[['log']]
    AminoAcid.binned[[Locus]] <- A.list[['binned']]
    overall.chisq[[Locus]] <- A.list[['chisq']]
    ORtable[[Locus]] <- A.list[['OR']]
    Final_binned[[Locus]] <- A.list[['table']]
    AminoAcid.freq[[Locus]] <- A.list[['freq']]

  }; rm(x) #locus loop

  cat("\n\n")

  Out <- list()
  Out[['AL']] <- do.call(rbind,AAlog)
  Out[['AB']] <- do.call(rbind,AminoAcid.binned)
  Out[['AF']] <- do.call(rbind,AminoAcid.freq)
  Out[['CS']] <- do.call(rbind,overall.chisq)
  Out[['OR']] <- do.call(rbind,ORtable)
  Out[['FB']] <- do.call(rbind,Final_binned)

  if(Output) {
    ## write to file
    write.table(Out[['AL']], file = "AA_log.txt", sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['AF']], file = "AA_freqs.txt", sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['AB']], file = "AA_binned.txt", sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['OR']], file = "AA_OR.txt", sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['CS']], file = "AA_chisq.txt", sep="\t", row.names = F, col.names=T, quote = F)
    write.table(Out[['FB']], file = "AA_table.txt", sep="\t", row.names = F, col.names=T, quote = F)
  }

  cat("> AMINO ACID ANALYSIS COMPLETED\n")

  if(Verbose){
    cat("Significant Amino Acid Position(s):","\n")
    tmp <- do.call(rbind,overall.chisq); rownames(tmp) <- NULL
    tmp.sig <- tmp[which(tmp[,'sig']=="*"),]; rownames(tmp.sig) <- NULL
    if(nrow(tmp.sig)>0) { print(as.data.frame(tmp.sig),row.names=F) }
  }


  return(Out)

}

#' Hardy Weinbergy Equilibrium Function
#'
#' This is the main function for the HWE analysis.
#' @param Tab data frame of genotype files post processing.
#' @note This function is for internal BIGDAWG use only.
HWE <- function(Tab) {

  HWE.out <- list()

  All.ColNames <- colnames(Tab)
  loci <- as.list(unique(All.ColNames[3:length(All.ColNames)]))
  nloci <- length(loci)

  #HWE Controls / Group 0
  genos.sub <- Tab[which(Tab[,2]==0),3:ncol(Tab)]
  HWE.out[["controls"]] <- HWE.ChiSq(genos.sub,loci,nloci)

  #HWE Cases / Group 1
  genos.sub <- Tab[which(Tab[,2]==1),3:ncol(Tab)]
  HWE.out[["cases"]] <- HWE.ChiSq(genos.sub,loci,nloci)

  return(HWE.out)

}

---
title: "GLSconvert"
author: "Derek Pappas, Ph.D. (dpappas@chori.org)"
date: "2020-02-10"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{GLSconvert}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---

## Overview

GLSconvert represents a suite of tools for cross converting HLA or KIR genotyping data from gene list text strings to multi-column tabular format as desribed in Milius RP, Mack SJ, Hollenbach JA, et al. 2013. Genotype List String: a grammar for describing HLA and KIR genotyping results in a text string. [Tissue Antigens. 82:106-112](https://pubmed.ncbi.nlm.nih.gov/23849068/). 

### Anatomy of a GL String

The figure below depicts a genotype List (GL) String representation of a multilocus unphased genotype. A GL String representing HLA-A genotype (A*02:69 and A*23:30, or A*02:302 and, either A*23:26 or A*23:39) and HLA-B genotype (B*44:02:13 and B*49:08) for a single individual is shown. GL String delimiters are parsed hierarchically starting from the locus delimiter (^), proceeding to the genotype delimiter (|), then the chromosome delimiter (+), and ending with the allele delimiter (/). A GL String should include the genetic system name (HLA or KIR) as part of the locus name.


![](https://www.ncbi.nlm.nih.gov/pmc/articles/PMC3715123/bin/tan0082-0106-f1.jpg)
  
### Input Data

Data may be passed to GLSconvert() as a tab delimited text file name (full path recommended) or as a R object (data frame). Whether a text file or an R object, the first row must be a header line and include column names for the GL string/locus genotypes. Any column preceeding the genotyping information is considered to be identifying/miscellanous information. This would generally include at least the sample id. While there is no limit to the number of columns, the direction of the conversion may dictate a specific column order. Empty rows will be excluded from final output.

_**GL String to Table**_  
Formatting for GL string conversion requires that the last column of the data table must contain the GL string.

|SubjectID |Exp ID  |GLString                                       |
|----------|:------:|:---------------------------------------------:|
|Subject1  |Center1 |HLA-A\*01:01+HLA-A\*02:01\^HLA-B\*08:01+HLA-B\*44:02\^HLA-DRB1\*01:01+HLA-DRB1\*03:01 |


_**Table to GL String**_  
Formatting for table conversion requires at least three columns. One (or more) column(s) of identifying information followed by column pairs for each locus. Genotype locus pairs must be located in adjacent columns. Column names for a given locus may use (not required) '_1', '.1','_2','.2' to distinguish each locus pair. Only columns defining genotypes names for each locus may repeat, all other column names must be unique. You may format your alleles as Locus*Allele or Allele following defined HLA and KIR naming conventions.

|SubjectID |Exp ID  |   A   |   A   |   B   |   B   | DRB1  | DRB1  | DRB3  | DRB3  |
|----------|:------:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|
|Subject1  |Center1 |01:01  |02:01  |08:01  |44:02  |01:01  |04:01  |       |       |

**Ambiguity**  
Only ambiguity at the allele level is compatible with the GL conversion tool (separated by "/"). Ambiguity at the genotype (separated by "|") cannot be used with the GL conversion tool and will terminate the script. This includes tables submitted for conversion to GL strings containing rows of identical non-genotype identifying information (sample ID, experiment ID, etc.), these will be considered to be ambiguous genotypes in the table and the conversion tool will stop.  

**Homozygosity**  
Homozygous allele calls can be represented as single alleles in the GL string. For example, HLA-A\*01:01:01:01 + HLA-A\*01:01:01:01 can be written as HLA-A*01:01:01:01. This only applies to Tab2GL conversions. When a locus is represented by a single allele in a GL string, that allele will be reported in both fields for that locus in the converted table  

**HLA-DRB3, HLA-DRB4, and HLA-DRB5**  
HLA-DRB3, HLA-DRB4, and HLA-DRB5 are parsed for homozygous or hemizygous status based on the DRB1 haplotype as defined by Andersson, 1998 (Andersson G. 1998. Evolution of the HLA-DR region. [Front Biosci. 3:d739-45](https://pubmed.ncbi.nlm.nih.gov/9675159/)) and can be flagged for inconsistency. Inconsistent haplotypes will be indicated in a separate column called "DR.HapFlag" with the locus or loci that are inconsistent with the respective DRB1 status. You may choose not to have haplotypes flagged using the 'DRB345.Check' parameter (see below).  

**Missing Information**  
For HLA-DRB3, HLA-DRB4, and HLA-DRB5 (HLA-DRBx) When there is missing information, either for lack of genotyping calls or absence of genotyped loci, GLSconvert allows for a convention to differentiate data missing due to genomic structural variation (i.e., locus absence). The acceptable indicator of locus absence is the 2-Field designation HLA-DRBx*00:00 (x = 3,4,5). For example, HLA-DRB5\*00:00+HLA-DRB5\*00:00 would indicate absence of a HLA-DRB5 locus and not a failed or missing genotype call. You may choose to have GLSconvert fill in absent calls for these loci. For Tab2GL conversion, a NA can be used to indicate missing due to lack of genotyping call, however a NA is not compatible with GL2Tab conversion and should be avoided.


## Data Output

Data can be output to either a text file (tab or comma delimitted) or R object (sent to data frame). See Output parameters below. When running the GL2Tab conversion, all adjacent pairs of loci will include '_1' and '_2' to distinguish each chromosome. Please note, subsequent programs used to analyze the data table such as BIGDAWG or Pypop may not accept files with ambiguous genotyping data.


## Parameters

`GLSconvert(Data,Convert,Output="txt",System="HLA",HZY.Red=FALSE,DRB345.Check=FALSE,Strip.Prefix=TRUE,Cores.Lim=1L)`

**Data**

Class: String/Object. (No Default).

e.g., Data="/your/path/to/file/foo.txt" -or- Data="foo.txt" -or- Data=foo (No Default)

Specifies data file name or data object. File name is either full file name path to specify file location (recommended) or name of file within a set working directory. See Data Input section for details about file formatting. **This parameter is required for the conversion utility.**  

**Convert**

Class: String. Options: "GL2Tab" -or- "Tab2GL" (No Default).

Specifies data file name or data object. May use file name within working directory or full file name path to specify file location (recommended). See Data Input section for details about file formatting. **This parameter is required for the conversion utility.**  

**File.Output**

Class: String. Options: "R" -or- "txt" -or- "csv" -or- "pypop" (Default = "txt").

Specifies the type of output for the converted genotypes. For file writing, if you specified the full path for a file name then the resultant file will be written to the same directory. Otherwise the file will be written to whichever working directory was defined at initiation of conversion. The converted file name will be of the form "Converted_foo.txt" depending on output setting. If the data was an R object, the file name will be "Converted.txt" if output to file is desired. To output as R object will require an assignment to some object (see examples below).

**System**

Class: String. Options: "HLA" or "KIR" (Default="HLA").

Defines the genetic system of the data being converted. This parameter is required for Tab2GL conversion and is ignored for GL2Tab. The default system is HLA.

**HZY.Red**

Class: Logical (Default=FALSE).

Homozygous reduction: Indicates if non-DRBx homozygotes should be represented by a single allele name in GL string. For example: HLA-A*01:01:01:01+HLA-A*01:01:01:01 as HLA-A*01:01:01:01. The default behavior is to keep both allele names in the GL string. This parameter is only used when Convert = Tab2GL, and only applies to non-DRBx genotype data

**DRB345.Check**

Class: Logical (Default=FALSE).

Indicates whether DR haplotypes should be parsed for correct zygosity and unusual DR haplotypes flagged. Inconsistent loci will appear flagged in a separate column labeled 'DR.HapFlag' that follows the genotype columns. The default behavior will flag unusual haplotypes. HLA-DRBx alleles without a respective HLA-DRB1 will remain unchanged and the flag will say 'ND' for not determined.

**Strip.Prefix**

Class: Logical (Default=TRUE).

Applies only to Convert="GL2Tab" conversions. Indicates whether alleles should be stripped of System/Locus prefixes in the final data when converting from GL strings to tabular format. For example, should HLA-A*01:01:01:01 be recorded as 01:01:01:01 in the final table. Required when outputting to a PyPop compatible file. The default will strip prefixes.

**Abs.Fill**

Class: Logical (Default=FALSE).

Relevant only to data containing one or more of the loci: HLA-DRB3, HLA-DRB4, or HLA-DRB5. Directs GLSconvert to fill in missing information with the 2-Field designation HLA-DRBx\*00:00. 

For example, when data contain HLA-DRB5 typing, those subjects with no HLA-DRB5 will be given the designation HLA-DRB5\*00:00 or HLA-DRB5\*00:00+HLA-DRB5\*00:00 depending on the situation. If you have absent locus designations already present in your data, then GLconverion will remove them in the final output.


## Examples

These are examples only and need not be run as defined below.

```
# Run the GL2Tab conversion on a data file with default output to text file and no prefix stripping
GLSconvert(Data="/your/path/to/file/foo.txt", Convert="GL2Tab", Strip.Prefix=FALSE)

# Run the Tab2GL conversion on a R object outputting to a R object with DRB345 Flagging
foo.tab <- GLSconvert(Data=foo, Convert="Tab2GL", File.Output="R", DRB345.Check=TRUE)

# Run the Tab2GL conversion on a text file outputting to a csv file and with homozygous allele reduction of non-DRB345 alleles
GLSconvert(Data=foo, Convert="Tab2GL", File.Output="csv", HZY.Red=TRUE)

# Run the GL2Tab conversion on a data file without the full path name
setwd("/your/path/to/file")
GLSconvert(Data="foo.txt", Convert="GL2Tab")

```

*End of vignette.*

---
title: "BIGDAWG"
author: "Derek Pappas, Ph.D. (djpappas75@gmail.com)"
date: "2026-04-29"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{BIGDAWG}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Overview

'Bridging ImmunoGenomic Data-Analysis Workflow Gaps' ('BIGDAWG') is an integrated analysis system that automates the manual data-manipulation and trafficking steps (the gaps in an analysis workflow) normally required for analyses of highly polymorphic genetic systems (e.g., the immunological human leukocyte antigen (HLA) and killer-cell Immunoglobulin-like receptor (KIR) genes) and their respective genomic data (immunogenomic) (Pappas DJ, Marin W, Hollenbach JA, Mack SJ. 2016. 'Bridging ImmunoGenomic Data Analysis Workflow Gaps (BIGDAWG): An integrated case-control analysis pipeline.' [Human Immunology. 77:283-287](https://pubmed.ncbi.nlm.nih.gov/26708359/)). Starting with unambiguous genotype data for case-control groups, 'BIGDAWG' performs tests of Hardy-Weinberg equilibrium, and carries out case-control association analyses for haplotypes, individual loci, specific HLA exons, and HLA amino acid positions. For HLA amino acid positions, analyses are currently limited to the loci HLA-A, B, C, DPA1, DPB1, DQA1, DQB1, DRB1, DRB3, DRB4, and DRB5.

## Input Data

Data for BIGDAWG should be in a tab delimited text format (UTF-8 encoding). The first row must be a header line and must include column names for genotype data. The first two columns must contain subject IDs and phenotypes (0 = control, 1 = case), respectively. A phenotype is not limited to disease status and may include other phenotypes such as onset, severity, ancestry, etc. However, phenotype designatons in the dataset are restricted to the use of 0s and 1s. Genotype pairs must be located in adjacent columns. Column names for a given locus may use '_1', '.1','_2','.2' to distinguish each locus pair. Genotype calls may include any text (numeric or character) except the numbers 1 and 0.

Data may also be passed to BIGDAWG as an R object (dataframe) following the same formatting as above for text files. You may also choose to run a synthetic HLA data set (see below) to observe a typical BIGDAWG analysis and experiment with parameter settings.

For HLA alleles, you may choose to format your genotype calls with our without the locus prefix. For example, for HLA-A, a given genotype call maybe 01:01:01:01 or A\*01:01:01:01 or HLA-A\*01:01:01:01. Allele names can include any level of resolution, from a single field up to the full length name. For HLA-DRB3,-DRB4,-DRB5 genotype calls, you may choose to represent these as a single pair of columns or as separate pairs of columns for each locus. However, when submitted as a single pair of columns, all genotypes must be formatted as Locus*Allele (including non-DRB loci). The single pair column names may be  DRB345, DRB3.4.5 or DRB3/4/5. Homozygous or hemizygous status for DRB3, DRB4 and DRB5 genotypes is based on the DRB1 haplotype as defined by Andersson, 1998 (Andersson G. 1998. Evolution of the HLA-DR region. [Front Biosci. 3:d739-45](https://pubmed.ncbi.nlm.nih.gov/9675159/)). If you wish to define your own zygosity, it is suggested you split them into separate pairs of columns for each locus manually.

**Missing Information**  
When there is missing information, either for lack of genotyping information or absence of genotyped loci, BIGDAWG allows for conventions to differentiate the type of data that is missing.

Data missing due to lack of a molecular genotyping result is considered not available (NA). Acceptable NA strings include: NA, ****, -, na and Na. Empty data cells will be considered NA. If your data is formatted as Locus*Allele, please include this formatting for all absent alleles as well (e.g., DRB1*NA).

Data missing due to genomic structural variation (i.e., no locus present) is considered absence. Acceptable absence strings include: Absent, absent, Abs, ABS, ab, Ab, AB, @. The last symbol is the unicode at sign. BIGDAWG allows for a special allele name that indicates absence of an HLA locus: 00, 00:00, 00:00:00 and 00:00:00:00 are all acceptable indicators of HLA locus absence. When choosing to use 00's (zeros) to populate allele name fields, use similar or higher levels of resolution [https://hla.alleles.org](https://hla.alleles.org/pages/nomenclature/naming_alleles/) and follow the same naming convention as with other genotype calls (either with or without locus prefix). If using a single column pair for DRB3/4/5 and the "00" absence indicator, then do **NOT** affix a locus prefix for the absent calls. In this case, only include the locus prefix for known DRB345 genotypes (i.e., DRB3/4/5*00:00 is **NOT** an acceptable name). For HLA data, the 00:00 naming convention is preferred and absent designations will be converted to allow the amino acid analysis to test phenotypic associations with locus absence (see below).

Finally, when missing alleles (due to lack of a genotype call) for a locus are included in the haplotype analysis, the haplotype estimation method may impute the identity of the missing alleles for that subject. If such imputation is not desired, the "Missing"" parameter should be set to 0.

**Genotype List Strings**  
For for HLA alleles, you may submit your data formatted as a genotype list strings (GL strings) and BIGDAWG can automatically convert the data to a tabular format. The data should be 3-columns with the GL string in the third column (see table below). Data is restricted to **00:00** for absent designations when using GL strings, you should NOT use any other indicator of absence. Utilizing NA is not compatible with GL2Tab conversion.

BIGDAWG also has a built-in function for converting between GL strings and tabular formatting using the GLSconvert() function. Please see the GLSconvert vignette for more detail.

**Novel Alleles**  
BIGDAWG will accept novel allele names. However, it is suggested you follow the same naming convention for novel alleles as with other genotypes calls in your data, either with or without the locus prefix. For example, novel alleles could be submitted as follows: Novel, 01:Novel, or A*01:Novel. Unfortunately, the BIGDAWG amino acid analysis cannot accept novel allele designations and will display an error. If you would like to run the amino acid analysis, you should replace the novel allele with NA or omit the subject entirely. 

**Example of data architecture and acceptable values:**

*Tabular*

|SubjectID |Disease |   A   |   A   |   B   |   B   | DRB1  | DRB1  | DRB3  | DRB3  |
|----------|:------:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|:-----:|
|subject1  |0       |01:01  |02:01  |08:01  |44:02  |01:01  |08:01  |Abs    |Abs    |
|subject2  |1       |02:01  |24:02  |51:01  |51:01  |11:01  |14:01  |02:02  |02:11  |
|subject3  |0       |03:01  |26:02  |NA     |NA     |10:01  |08:01  |00:00  |00:00  |

*Genotype List String*

|SubjectID |Disease |GLString  |
|----------|:------:|:-------------------------------------------------------------:|
|Subject1  |0       |HLA-A\*01:01+HLA-A\*02:01\^HLA-B\*08:01+HLA-B\*44:02\^HLA-DRB1\*01:01+HLA-DRB1\*03:01^HLA-DRB3\*00:00+HLA-DRB3\*00:00 |
|subject2  |1       |HLA-A\*02:01+HLA-A\*24:02\^HLA-B\*51:01+HLA-B\*51:01\^HLA-DRB1\*11:01+HLA-DRB1\*14:01^HLA-DRB3\*02:02+HLA-DRB3\*02:11 |
|subject3  |0       |HLA-A\*01:01+HLA-A\*02:01\^HLA-DRB1\*01:01+HLA-DRB1\*03:01^HLA-DRB3\*00:00+HLA-DRB3\*00:00 |


## Data Output

After the package is run, BIGDAWG will create a new folder entitled 'output hhmmss ddmmyy' in the working directory (unless otherwise specified by Results.Dir parameter, see below). Within the output folder will be a precheck file ('Data_Summary.txt') detailing the summary statistics of the dataset and the results of the Hardy-Weinberg equilibrium test ('HWE.txt'). If any errors are present, a log file ('Error_Log.txt') will be written. If no locus subsets are specified (see parameters section), a single subfolder entitled ‘Set1’ will contain the outputs of each association analysis run. If multiple locus subsets are defined, subfolders for each locus set will be created containing the respective analytic results for that subset. Within each set subfolder, a parameter file will detail the parameters that are relevant to that subset.

When all pairwise combinations are run in the haplotype analysis, each pairwise set will be written to a single file. A separate file called "haplotype_PairwiseSets.txt" will be written to the corresponding set's directory and will breakdown the locus make up for each PairwiseSet.

Data output to both the console and text files can be suppressed with Verbose=F and Output=F respectively. This is particularly useful when the user prefers to send the results to an R object (Return=T, see below) rather than to text files for further analysis. Finally, when multiple analyses are run (i.e., HWE, H, L, A) the data for each analysis (Chi Squares, Odds Ratios, Allele Frequencies, Allele Counts, etc.) can be written as set of files labeled 'Merge' for convenient access (Merge.Ouput=T).

*Output As List Object*  
With the parameter "Return=T", the result is returned as a list with indices for each analysis result (HWE, H, L, A). Defined loci sets will exists as list sub-elements under each respective analysis. If no Loci.Sets were specified, only one list element will exist for Set1.
  
For an example. If BIGDAWG outputs to an object called 'BD' in R (see examples below).  

BD  (e.g., 3 loci sets defined)  
..\$HWE - Results of the the Hardy-Weinberg equilibrium test  
..\$H\$Set1 - Results of the 'Haplotype' analysis for Set1
..\$H\$Set2 - Results of the 'Haplotype' analysis for Set2  
..\$H\$Set3 - Results of the 'Haplotype' analysis for Set3  
..\$L\... - Results of the 'Locus' analysis  
..\$A\... - Results of the 'Amino Acid' analysis  

or when "All.Pairwise=T" (e.g., 3 loci, 3 pairwise comparisons possible, single locus set)  
..\$HWE - Results of the the Hardy-Weinberg equilibrium test  
..\$H\$Set1.PairwiseSet1 - Results of the 'Haplotype' analysis for Set1 Pairwise Set 1  
..\$H\$Set1.PairwiseSet2 - Results of the 'Haplotype' analysis for Set1 Pairwise Set 2  
..\$H\$Set1.PairwiseSet3 - Results of the 'Haplotype' analysis for Set1 Pairwise Set 3  
..\$L\$Set1 - Results of the 'Locus' analysis for Set1  
..\$A\$Set1 - Results of the 'Amino Acid' analysis for Set1  

names(BD) - Display complete list of available sets to index. For a complete list of available pairwise results, use names(BD\$H). This results list is written to the results directory as an R object called 'Analysis.RData' for later use.


## Error Messages and Codes

BIGDAWG has a few built-in checks to ensure data format consistency and compatibility, especially for HLA data. BIGDAWG also performs a contingency table review before performing chi-squared tests and returns ‘NCalc’ (not calculated) when all genotypes have expected counts < 5 or the degrees of freedom do not allow for a test (e.g., dof < 1). BIGDAWG will also check your HLA genotypes against the known alleles relative to the internal IMGT/HLA database version. This check is limited to the loci HLA-A, B, C, DPA1, DPB1, DQA1, DQB1, DRB1, DRB3, DRB4, and DRB5. Other HLA (and non-HLA) loci will throw an error. Please use the parameter "HLA = F" to bypass this check.

## Known Issues

BIGDAWG's output includes locus frequencies to provide convenient access for future reference. However, the values have been rounded to 5 digits (arbitrarily chosen) to make the output more concise. This rounding may introduce errors in the frequencies wherein they do not sum to 1. If downstream use of the allele frequency is required, we suggest the user calculate frequencies directly from the counts tables for their own application. Please refer to ?round help documentation and the section Warning for more detail on rounding considerations.

## Parameters

`BIGDAWG(Data, HLA=T, Run.Tests, Loci.Set, Exon, All.Pairwise=F, Trim=F, Res=2, Missing=0, Strict.Bin=F, Cores.Lim=1L, Results.Dir, Return=F, Output=T, Verbose=T, Data.Type="Locus")`

**Data**

Class: String. Required. No Default.

e.g., `Data=HLA_data` -or- `Data="HLA_data"` -or- `Data="foo.txt"` -or- `Data=foo.txt`

Specifies genotype data file name. May use file name within working directory or full file name path to specify file location. See Data Input section for details about file formatting. Use 'Data=HLA_data' to analyze the bundled synthetic dataset.

**HLA**

Class: logical. Optional. Default = T.
  
Indicates whether or not your data is specific for HLA loci. If your data is not HLA, is a mix of HLA and data for other loci, or includes non-standard HLA allele names, you should set `HLA = F`. This will override the Trim and EVS.rm arguments, and will skip various tests and checks. Set `HLA = T` if and only if the dataset HLA alleles name are consistent with the most recent [IPD-IMGT/HLA](https://www.ebi.ac.uk/ipd/imgt/hla/) database release.

**Run.Tests**

Class: String or Character vector. Optional. Default = Run all tests.

e.g., `Run.Tests = c("L","A")` -or- `Run.Tests = "HWE"`

Specifies which tests to run in analysis. "HWE" will run the Hardy Weinberg Equilibrium test, "H" will run the haplotype association test, "L" will run the locus association test, and "A" will run the amino acid association test. Combinations of the test are permitted as indicated in the example.
  
The amino acid test generally requires the most processing time. Taking advantage of multi-core machines can minimize this time (see below). Moreover, avoid defining multiple Loci.Sets (see below) with overlapping loci as processing time will increasing redundantly. Currently, the amino acid analysis is limited to the HLA-A, -B, -C, -DRB1, -DRB3, -DRB4, -DRB5, -DQA1, -DQB1, -DPA1 and -DPB1 loci.


**Loci.Set**

Class: List. Optional. Default = Use all loci.

e.g., `Loci.Set=list(c("DRB1","DQB1"),c("A","DRB1","DPB1"), c("DRB1","DRB3"))`  -or- `Loci.Set=list("A")`

Input list defining which loci to use for analyses. Combinations are permitted. If you included HLA-DRB3,-DRB4,-DRB5 as a collapsed column pair ('DRB3/4/5'), you must specify the single locus in the Loci.set if you wish them to be included in an analysis set (i.e., 'DRB3' **NOT** 'DRB3/4/5'). The pair of alleles for a locus must be in adjacent columns in the analyzed data set.

Running multiple sets is generally only relevant for the haplotype analysis without all pairwise combinations. For all other analyses, loci are treated independently. Consider running haplotype analysis independently when optioning multi-locus sets that included overlapping loci to avoid redundancies. Each locus set's output will be contained within a separate set folder numbered numerically corresponding to their order in the Loci.set parameter (see Data Output section).

**Exon**

Class: Numeric. Optional.

e.g., `Exon=3` -or- `Exon=c(3,5,6)` -or- `Exon=c(2:3)` -or- `Exon=1:4`

A single numeric or numeric vector that defines exons to target in the amino acid analysis. The amino acid alignment is parsed according to the overlap of the defined exons. When amino acid codons overlap exon boundaries, the exon with the majority overlap (2 out of 3 nucleotides) is assigned that residue. This argument is only relevant to the amino acid analysis. The defined exons are not required to be continuous. Multiple sets are not analyzed separately. The defined exons are applied to all loci in the the analysis. If an exon does not exist for a given locus, BIGDAWG will register an error and the analysis will stop. In such instances, it is recommended you analyze those loci separately.

**All.Pairwise**

Class: Logical. Optional. Default = F.

Should pairwise combinations of loci be run in the haplotype analysis? Only relevant to haplotype analysis. When optioned, only pairwise combinations of loci will be run and not all the loci in a given data set.

**EVS.rm**

Class: Logical. Optional. Default = F. (`HLA=T` specific).

Flags whether or not to strip expression variant suffixes from HLA alleles. Example: A\*01:11N will convert to A\*01:11. Should not be optioned for data that does not conform to HLA naming conventions.

**Trim**

Class: Logical. Optional. Default = F. (`HLA=T` specific).

Flags whether or not to Trim HLA alleles to a specified resolution. Should not be optioned for data that does not conform to HLA naming conventions.

**Resolution**

Class: Numeric. Optional. Default = 2. (`HLA=T` specific).

Sets the desired resolution when trimming HLA alleles. Used only when `Trim = T`. Fields for HLA formatting must follow current colon-delimited nomenclature conventions. Currently, the amino acid analysis will automatically truncate to 2-field resolution. Trimming is automatic and need not be optioned for amino acid analysis to run. This test will not run for data that does not conform to HLA naming conventions.

**Missing**

Class: String/Numeric. Optional. Default = 0.

Sets the allowable per subject threshold for missing alleles. Relevant to running the haplotype analysis. Effects can be disastrous on processing time and memory allocation for large values (>2) of missing. Missing may be set as a number or as "ignore" to skip removal and retain all subjects. If you find BIGDAWG spending a lot time on the "Estimating Haplotypes..." step, reduced you missing to a value less than or equal to 2.

**Strict.Bin**

Class: Logical. Optional. Default = FALSE.

Sets whether strict binning should be used during Chi Square testing. Strict binning (Strict.Bin = T) will bin all rare cells (expected count < 5). Otherwise, BIGDAWG will allow for up to 20% of the cells to have expected counts less than 5. Currently limited to the H, L, and A tests. This "relaxed" binning may rescue haplotypes/alleles/amino acids from binning and help identify significant loci/alleles.

**Cores.Lim**

Class: Integer. Optional. Default = 1 Core.

Specifies the number of cores accessible by BIGDAWG in amino acid analysis. Not relevant to Windows operating systems which will use only a single core. More than 1 core is best when optioned in command line R and is not recommend when used in combination with a GUI, e.g. RStudio.

**Results.Dir**

Class: String. Optional. Default = see Data Output section.

String name of a folder for BIGDAWG output. Subfolder for each locus set will be generated within any output folder specified.

**Return**

Class: Logical. Optional. Default = F.

Specifies if BIGDAWG should output analysis results to a specified object.

**Output**

Class: Logical. Optional. Default = T.

Turns on or off the writing of results to files. The default will write all results to text files in the output directory.

**Merge.Output**

Class: Logical. Optional. Default = F.

Turns on or off the merging of all analysis results into single files labeled 'Merged_xxxx.txt". This process is rapid for smaller sets of loci (less than 50). However it can become increasingly cpu time intensive when there are many loci analyzed in conjunction with all pairwise combinations in the haplotype analysis. This parameter is subordinate to Output=T.

**Verbose**

Class: Logical. Optional. Default = T.

Sets the levels of detail that should be displayed on the console. The default will display summaries of the analysis from each specified test. When turned off, only the completion status of each test is displayed.

**Data.Type**

Class: String. Required. Default = 'Locus'.

Describes the type of dataset to be analyzed. The default 'Locus' value indicates a dataset composed of allele names for specific loci. The alternative 'Motif' value identifies a dataset composed of nucleotide or amino-acid motifs.

## Examples

These are examples only and need not be run as defined below.

```

# Install the BIGDAWG package
install.packages("BIGDAWG")

# Run the full analysis using the example set bundled with BIGDAWG
BIGDAWG(Data="HLA_data")

# Run the haplotype analysis with all pairwise combinations on a file called 'data.txt'
BIGDAWG(Data="data.txt", Run.Tests="H", All.Pairwise=T)

# Run the Hardy-Weinberg and Locus analysis with non-HLA data while ignoring any missing data on a file called 'data.txt'
BIGDAWG(Data="data.txt", HLA=F, Run.Tests=c("HWE","L"), Missing="ignore")

# Run the amino acid analysis on exons 2 and 3, trimming data to 2-Field resolution on a file called 'data.txt'
BIGDAWG(Data="data.txt", Run.Tests="A", Exon=c(2,3), Trim=T, Res=2)

# Run the haplotype analysis with subsets of loci on a file called 'data.txt'
BIGDAWG(Data="data.txt", Run.Tests="H", Loci.Set=list(c("DRB1","DQB1","DPB1"),c("DRB1","DQB1")))

# Run the full analysis, minimize console output, disable write to file, output to object 'BD'
BD <- BIGDAWG(Data="data.txt", Output=F, Return=T, Verbose=F)

```

## Updating the bundled IMGT/HLA protein alignment

For the amino acid analysis, BIGDAWG is bundled with HLA protein alignment data using the above indicated database release. These bundled alignments can be updated to the most recent release [IPD-IMGT/HLA](https://www.ebi.ac.uk/ipd/imgt/hla/). Future database updates do not guarantee compatibility with the updating tool.

```
# Identify the installed and current release of the bundled IMGT/HLA database release
# Requires active internet connection.
CheckRelease()
CheckRelease(Package=F) # restricts to IMGT/HLA database versions only

# Update to the most recent IMGT/HLA database release
UpdateRelease()

# Force update
UpdateRelease(Force=T)

# Restore to original bundled update.
UpdateRelease(Restore=T)
```

## Updating BIGDAWG to latest developmental versions

Developmental versions of BIGDAWG can be downloaded through [GitHub](https://github.com/IgDAWG/BIGDAWG/) or using the following code (requires R package 'devtools'). These versions will include the most up-to-date bug fixes as well as access to new features that are still under development. GitHub versions are constantly under development and if you prefer a more stable fixed release, install BIGDAWG from the CRAN respository. You may check BIGDAWG versions using CheckRelease(). Local builing of vignettes requires pandoc and pandoc-citeproc if you do not use RStudio [Pandoc](https://pandoc.org/installing.html). Before installation from GitHub, it is recommended that all other R packages be up to date.

```
# Identify the installed (local), release (CRAN), and developmental (GitHub) versions of BIGDAWG.
# Requires active internet connection.
CheckRelease()
CheckRelease(Alignment=F) # restricts to BIGDAWG versions only

# If 'devtools' package installation is required for installation via GitHub.
install.packages("devtools")

# Load latest BIGDAWG version from GitHub
# May require closing and reopening of R Studio after install
library("devtools")
install_github("IgDAWG/BIGDAWG", build_vignettes = TRUE) # Requires Pandoc or RStudio
install_github("IgDAWG/BIGDAWG") # No Pandoc or RStudio

# For a temporary install of the developmental version
library("devtools")
dev_mode(on=T)
install_github("IgDAWG/BIGDAWG")
# .... run BIGDAWG analysis
dev_mode(on=F)
```

*End of vignette.*

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DRB_Parser.R
\name{DRB345.Check.Zygosity}
\alias{DRB345.Check.Zygosity}
\title{DRB345 haplotype zygosity checker single locus}
\usage{
DRB345.Check.Zygosity(Locus, Genotype)
}
\arguments{
\item{Locus}{Locus of interest to test for consistency}

\item{Genotype}{Row of data set data frame following DRB345 parsing}
}
\description{
Checks DR haplotypes for correct zygosity and flags unanticipated haplotypes for a single DRBx
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_ExonPtnAlign_functions.R
\name{PgrpExtract}
\alias{PgrpExtract}
\title{HLA P group Finder}
\usage{
PgrpExtract(x, y)
}
\arguments{
\item{x}{Allele of interest.}

\item{y}{Formatted P groups.}
}
\description{
Identify P group for a given allele if exists.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H_wrapper_MC.R
\name{H.MC.wrapper}
\alias{H.MC.wrapper}
\title{Haplotype Wrapper for Multicore}
\usage{
H.MC.wrapper(
  SID,
  Tabsub,
  loci,
  loci.ColNames,
  genos,
  grp,
  All.Pairwise,
  Strict.Bin,
  Output,
  Verbose,
  Cores
)
}
\arguments{
\item{SID}{Character vector of subject IDs.}

\item{Tabsub}{Data frame of genotype calls for set being analyzed.}

\item{loci}{Character vector of unique loci being analyzed.}

\item{loci.ColNames}{Character vector of genos column names.}

\item{genos}{The genotype columns of the loci set being analyzed.}

\item{grp}{Case/Control or Phenotype groupings.}

\item{All.Pairwise}{Haplotype argument carryover from main BIGDAWG function}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test}

\item{Output}{Data return carryover from main BIGDAWG function}

\item{Verbose}{Summary display carryover from main BIGDAWG function}

\item{Cores}{Cores carryover from main BIGDAWG function}
}
\description{
Wrapper for main H function
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE_support_functions.R
\name{getObsFreq}
\alias{getObsFreq}
\title{Observed Frequency}
\usage{
getObsFreq(x, genos.locus)
}
\arguments{
\item{x}{Single genotype.}

\item{genos.locus}{Locus genotypes.}
}
\description{
Get observed frequency of genotypes
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stat_functions.R
\name{make2x2}
\alias{make2x2}
\title{Creation of a 2x2 table using the indicated orientation.}
\usage{
make2x2(caseexp, controlex, casenonex, controlnonex)
}
\arguments{
\item{caseexp}{Number of cases exposed}

\item{controlex}{Number of controls exposed}

\item{casenonex}{Number of cases not exosed}

\item{controlnonex}{Number of controls not exposed}
}
\description{
make2x2 function port epicalc version 2.15.1.0 (Virasakdi Chongsuvivatwong, 2012)
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_ExonPtnAlign_functions.R
\name{GetFiles}
\alias{GetFiles}
\title{File Fetcher}
\usage{
GetFiles(Loci)
}
\arguments{
\item{Loci}{HLA Loci to be fetched. Limited Loci available.}
}
\description{
Download Protein Alignment and Accessory Files
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{Check.Params.GLS}
\alias{Check.Params.GLS}
\title{Check Input Parameters for GLS conversion}
\usage{
Check.Params.GLS(
  Convert,
  File.Output,
  System,
  HZY.Red,
  DRB345.Check,
  Cores.Lim
)
}
\arguments{
\item{Convert}{String Direction for conversion.}

\item{File.Output}{String Type of output.}

\item{System}{String Genetic system (HLA or KIR) of the data being converted}

\item{HZY.Red}{Logical Reduction of homozygote genotypes to single allele.}

\item{DRB345.Check}{Logical Check DR haplotypes for consistency and flag unusual haplotypes.}

\item{Cores.Lim}{Integer How many cores can be used.}
}
\description{
Check input parameters for invalid entries.
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/L.R
\name{L}
\alias{L}
\title{Locus Analysis Function 25Jun2025}
\usage{
L(loci.ColNames, Locus, genos, grp, Strict.Bin)
}
\arguments{
\item{loci.ColNames}{The column names of the loci being analyzed.}

\item{Locus}{Locus being analyzed.}

\item{genos}{Genotype table}

\item{grp}{Case/Control or Phenotype groupings.}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test}
}
\description{
This is the workhorse function for the locus level analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DRB_Parser.R
\name{DRB345.parser}
\alias{DRB345.parser}
\title{DRB345 Column Processing}
\usage{
DRB345.parser(Tab)
}
\arguments{
\item{Tab}{Data frame of sampleIDs, phenotypes, and genotypes}
}
\description{
Separates DRB345 column pair into separate columns for each locus
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{MergeData_Output}
\alias{MergeData_Output}
\title{Data Object Merge and Output}
\usage{
MergeData_Output(BD.out, Run, OutDir)
}
\arguments{
\item{BD.out}{Output of analysis as list.}

\item{Run}{Tests that are to be run as defined by Run.Tests.}

\item{OutDir}{Output directory defined by Results.Dir or default.}
}
\description{
Whole data set table construction of per haplotype for odds ratio, confidence intervals, and pvalues
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A.R
\name{A}
\alias{A}
\title{Amino Acid Analysis Function}
\usage{
A(Locus, loci.ColNames, genos, grp, Strict.Bin, ExonAlign, Cores)
}
\arguments{
\item{Locus}{Locus being analyzed.}

\item{loci.ColNames}{The column names of the loci being analyzed.}

\item{genos}{Genotype table.}

\item{grp}{Case/Control or Phenotype groupings.}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test.}

\item{ExonAlign}{Exon protein alignment filtered for locus.}

\item{Cores}{Number of cores to use for analysis.}
}
\description{
This is the workhorse function for the amino acid analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DRB_Parser.R
\name{DRB345.Check.Wrapper}
\alias{DRB345.Check.Wrapper}
\title{DRB345 haplotype zygosity wrapper}
\usage{
DRB345.Check.Wrapper(Genotype, Loci.DR)
}
\arguments{
\item{Genotype}{Row of data set data frame following DRB345 parsing}

\item{Loci.DR}{DRBx Loci of interest to test for consistency}
}
\description{
Checks DR haplotypes for correct zygosity and flags unanticipated haplotypes
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{rmABstrings}
\alias{rmABstrings}
\title{Replace absent allele strings}
\usage{
rmABstrings(df)
}
\arguments{
\item{df}{Genotypes dataframe.}
}
\description{
Replaces allowable absent allele strings with ^ symbol.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GLSconvert.R
\name{GLSconvert}
\alias{GLSconvert}
\title{Genotype List String Conversion}
\usage{
GLSconvert(
  Data,
  Convert,
  File.Output = "txt",
  System = "HLA",
  HZY.Red = FALSE,
  DRB345.Check = FALSE,
  Strip.Prefix = TRUE,
  Abs.Fill = FALSE,
  Cores.Lim = 1L
)
}
\arguments{
\item{Data}{String File name or R Data Frame.}

\item{Convert}{String Direction for conversion.}

\item{File.Output}{String Type of File.Output.}

\item{System}{String Genetic system (HLA or KIR) of the data being converted}

\item{HZY.Red}{Logical Reduction of homozygote genotypes to single allele.}

\item{DRB345.Check}{Logical Check DR haplotypes for consistency and flag unusual haplotypes.}

\item{Strip.Prefix}{Logical Should System/Locus prefixes be stripped from table data.}

\item{Abs.Fill}{Logical Should absent loci special designations be used.}

\item{Cores.Lim}{Integer How many cores can be used.}
}
\description{
Main Workhorse wrapper for cross converting columnar table to GL string representaion.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TAB2GL.R
\name{Tab2GL.wrapper}
\alias{Tab2GL.wrapper}
\title{Genotype List String to Tabular Data Conversion}
\usage{
Tab2GL.wrapper(df, System, HZY.Red, Abs.Fill, Cores)
}
\arguments{
\item{df}{Data frame containing GL strings}

\item{System}{Character Genetic system HLA or KIR}

\item{HZY.Red}{Logical Should homozygote genotypes be a single allele for non-DRB345.}

\item{Abs.Fill}{Logical Should absent loci special designations be used}

\item{Cores}{Integer How many cores can be used.}
}
\description{
Expands GL strings to columns of adjacent locus pairs.
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{HLA_data}
\alias{HLA_data}
\title{Example HLA Dataset}
\format{
A data frame with 2000 rows and 14 variables
}
\usage{
HLA_data
}
\description{
A synthetic dataset of HLA genotypes for using bigdawg.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_ExonPtnAlign_functions.R
\name{AlignObj.Update}
\alias{AlignObj.Update}
\title{Updated Alignment Object Creator}
\usage{
AlignObj.Update(Loci, Release, RefTab)
}
\arguments{
\item{Loci}{Loci to be bundled.}

\item{Release}{IMGT/HLA database release version.}

\item{RefTab}{Data of reference exons used for protein alignment creation.}
}
\description{
Synthesize Object for Exon Protein Alignments.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stat_functions.R
\name{cci}
\alias{cci}
\title{Case-Control Odds ratio calculation and graphing}
\usage{
cci(
  caseexp,
  controlex,
  casenonex,
  controlnonex,
  cctable = NULL,
  graph = FALSE,
  design = "cohort",
  main,
  xlab,
  ylab,
  xaxis,
  yaxis,
  alpha = 0.05,
  fisher.or = TRUE,
  exact.ci.or = TRUE,
  decimal = 2
)
}
\arguments{
\item{caseexp}{Number of cases exposed}

\item{controlex}{Number of controls exposed}

\item{casenonex}{Number of cases not exosed}

\item{controlnonex}{Number of controls not exposed}

\item{cctable}{A 2-by-2 table. If specified, will supercede the outcome and exposure variables}

\item{graph}{If TRUE (default), produces an odds ratio plot}

\item{design}{Specification for graph; can be "case control","case-control", "cohort" or "prospective"}

\item{main}{main title of the graph}

\item{xlab}{label on X axis}

\item{ylab}{label on Y axis}

\item{xaxis}{two categories of exposure in graph}

\item{yaxis}{two categories of outcome in graph}

\item{alpha}{level of significance}

\item{fisher.or}{whether odds ratio should be computed by the exact method}

\item{exact.ci.or}{whether confidence limit of the odds ratio should be computed by the exact method}

\item{decimal}{number of decimal places displayed}
}
\description{
cci function port epicalc version 2.15.1.0 (Virasakdi Chongsuvivatwong, 2012)
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{Append.System}
\alias{Append.System}
\title{Append Genetic System Locus Designation to Allele String}
\usage{
Append.System(x, df.name)
}
\arguments{
\item{x}{Vector Column genotypes to append}

\item{df.name}{String SystemLocus name for each allele.}
}
\description{
Adds genetic system (HLA/KIR) to each allele name
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ErrLog.R
\name{Err.Log}
\alias{Err.Log}
\title{Error Code Display and Logging}
\usage{
Err.Log(Output, x, y = NULL, z = NULL)
}
\arguments{
\item{Output}{Logical indicating if Error logging should be written to a file.}

\item{x}{Log Code.}

\item{y}{Misc information relevant to error.}

\item{z}{Misc information relevant to error.}
}
\description{
Displays error codes attributable to data formatting and Locus/Allele naming. Writes to log file.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{CheckString.Allele}
\alias{CheckString.Allele}
\title{GL String Allele Check}
\usage{
CheckString.Allele(x)
}
\arguments{
\item{x}{GL String to check against}
}
\description{
GL String check for allele ambiguity formatting
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE_support_functions.R
\name{HWE.ChiSq}
\alias{HWE.ChiSq}
\title{Hardy Weinbergy Equilibrium Function}
\usage{
HWE.ChiSq(genos.sub, loci, nloci)
}
\arguments{
\item{genos.sub}{data frame of genotype files post processing.}

\item{loci}{list of loci.}

\item{nloci}{number of loci in list}
}
\description{
This is the workhorse function for each group analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/update_wrapper.R
\name{UpdateRelease}
\alias{UpdateRelease}
\title{Update function for protein aligment upon new IMGT HLA data release}
\usage{
UpdateRelease(Force = F, Restore = F, Output = F)
}
\arguments{
\item{Force}{Logical specifiying if update should be forced.}

\item{Restore}{Logical specifying if the original alignment file be restored.}

\item{Output}{Logical indicating if error reporting should be written to file.}
}
\description{
This updates the protein aligment used in checking HLA loci and alleles as well as in the amino acid analysis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{EVSremoval}
\alias{EVSremoval}
\title{Expression Variant Suffix Removal}
\usage{
EVSremoval(Locus, EPList)
}
\arguments{
\item{Locus}{Locus to be filtered against.}

\item{EPList}{Exon Protein Alignment Object}
}
\description{
Removes expression variant suffixes from HLA alleles in the exon protein alignment object.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE_support_functions.R
\name{getCS.Mat}
\alias{getCS.Mat}
\title{Chi square matrices}
\usage{
getCS.Mat(Locus, genos.sub, Allele.Freq, Allele.Combn)
}
\arguments{
\item{Locus}{Locus of interest.}

\item{genos.sub}{Genotypes for locus of interest.}

\item{Allele.Freq}{Allele frequencies.}

\item{Allele.Combn}{Allele combinations.}
}
\description{
Chi Square contingency matrix builder with rare cell binning
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE_support_functions.R
\name{getCS.stat}
\alias{getCS.stat}
\title{Chi square test statistic}
\usage{
getCS.stat(Locus, Freq.Final)
}
\arguments{
\item{Locus}{Locus of interest.}

\item{Freq.Final}{Contingency Matrix getCS.Mat output.}
}
\description{
Calculate chi square test statistic
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_support_functions.R
\name{AlignmentFilter}
\alias{AlignmentFilter}
\title{Alignment Filter}
\usage{
AlignmentFilter(Align, Alleles, Locus)
}
\arguments{
\item{Align}{Protein Alignment Object.}

\item{Alleles}{to be pulled.}

\item{Locus}{Locus to be filtered against.}
}
\description{
Filter Protein Exon Alignment File for Specific Alleles.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_support_functions.R
\name{Condense.EPL}
\alias{Condense.EPL}
\title{Condensing Exon Specific Alignments to Single Dataframe}
\usage{
Condense.EPL(EPL.Exon)
}
\arguments{
\item{EPL.Exon}{Exon-Locus Specific Amino Acid Alignment.}
}
\description{
Combines multiple Exon Specific Alignments into a single Alignment object
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{Check.Params}
\alias{Check.Params}
\title{Check Input Parameters}
\usage{
Check.Params(
  HLA,
  Loci.Set,
  Exon,
  All.Pairwise,
  Trim,
  Res,
  EVS.rm,
  Missing,
  Cores.Lim,
  Return,
  Output,
  Merge.Output,
  Verbose
)
}
\arguments{
\item{HLA}{Logical indicating whether data is HLA class I/II genotyping data only.}

\item{Loci.Set}{Input list defining which loci to use for analyses (combinations permitted).}

\item{Exon}{Numeric Exon(s) for targeted amino acid analysis.}

\item{All.Pairwise}{Logical indicating whether all pairwise loci should be analyzed in haplotype analysis.}

\item{Trim}{Logical indicating if HLA alleles should be trimmed to a set resolution.}

\item{Res}{Numeric setting what desired resolution to trim HLA alleles.}

\item{EVS.rm}{Logical indicating if expression variant suffixes should be removed.}

\item{Missing}{Numeric setting allowable missing data for running analysis (may use "ignore").}

\item{Cores.Lim}{Integer setting the number of cores accessible to BIGDAWG (Windows limit is 1 core).}

\item{Return}{Logical Should analysis results be returned as list.}

\item{Output}{Logical Should analysis results be written to output directory.}

\item{Merge.Output}{Logical Should analysis results be merged into a single file for easy access.}

\item{Verbose}{Logical Should a summary of each analysis be displayed in console.}
}
\description{
Check input parameters for invalid entries.
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{Check.Data}
\alias{Check.Data}
\title{Check Data Structure}
\usage{
Check.Data(Data, System, Convert)
}
\arguments{
\item{Data}{String Type of output.}

\item{System}{Character Genetic system HLA or KIR}

\item{Convert}{String Direction for conversion.}
}
\description{
Check data structure for successful conversion.
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{prepData}
\alias{prepData}
\title{Prepare imported data v 1.1 10 December 2025}
\usage{
prepData(Tab, data_type)
}
\arguments{
\item{Tab}{Genotypes dataframe.}

\item{data_type}{The type of data being processed. Options are 'Locus' or 'Motif'.'}
}
\description{
Prepare imported data for processing, checks, and analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/L_wrapper.R
\name{L.wrapper}
\alias{L.wrapper}
\title{Locus Wrapper}
\usage{
L.wrapper(nloci, loci, loci.ColNames, genos, grp, Strict.Bin, Output, Verbose)
}
\arguments{
\item{nloci}{Number of loci being analyzed.}

\item{loci}{Loci being analyzed.}

\item{loci.ColNames}{The column names of the loci being analyzed.}

\item{genos}{Genotype table}

\item{grp}{Case/Control or Phenotype groupings.}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test}

\item{Output}{Data return carryover from main BIGDAWG function}

\item{Verbose}{Summary display carryover from main BIGDAWG function}
}
\description{
Wrapper for main L function
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{getFileName}
\alias{getFileName}
\title{File Name Extraction}
\usage{
getFileName(x)
}
\arguments{
\item{x}{File name.}
}
\description{
Function to extract file path.
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{CheckString.Locus}
\alias{CheckString.Locus}
\title{GL String Locus Check}
\usage{
CheckString.Locus(x, Loci)
}
\arguments{
\item{x}{GL String to check against}

\item{Loci}{Loci to check}
}
\description{
Check GL string for loci appearing in multiple gene fields.
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{GetField}
\alias{GetField}
\title{HLA trimming function}
\usage{
GetField(x, Res)
}
\arguments{
\item{x}{HLA allele.}

\item{Res}{Resolution desired.}
}
\description{
Trim a properly formatted HLA allele to desired number of fields.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stat_functions.R
\name{cci.pval}
\alias{cci.pval}
\title{Case Control Odds Ratio Calculation from Epicalc}
\usage{
cci.pval(x)
}
\arguments{
\item{x}{List of 2x2 matrices for calculation, output of TableMaker.}
}
\description{
Calculates odds ratio and pvalues from 2x2 table
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GL2TAB.R
\name{GL2Tab.Sub}
\alias{GL2Tab.Sub}
\title{Genotype List String Expander}
\usage{
GL2Tab.Sub(x, System)
}
\arguments{
\item{x}{Character GL string to expand}

\item{System}{Character Genetic system HLA or KIR}
}
\description{
Expands GL string into a table of adjacent loci
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stat_functions.R
\name{TableMaker}
\alias{TableMaker}
\title{Table Maker}
\usage{
TableMaker(x)
}
\arguments{
\item{x}{Contingency table with binned rare cells.}
}
\description{
Table construction of per haplotype for odds ratio, confidence intervals, and pvalues
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_ExonPtnAlign_functions.R
\name{ExonPtnAlign.Create}
\alias{ExonPtnAlign.Create}
\title{Protein Exon Alignment Formatter}
\usage{
ExonPtnAlign.Create(Locus, RefTab)
}
\arguments{
\item{Locus}{Locus alignment to be formatted.}

\item{RefTab}{Reference exon protein information for alignment formatting.}
}
\description{
Dynamically creates an alignmnet of Allele exons for Analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{Filler}
\alias{Filler}
\title{Replace or Fill 00:00 allele strings}
\usage{
Filler(x, Locus = NULL, Type)
}
\arguments{
\item{x}{Genotype}

\item{Locus}{Locus column to adjust.}

\item{Type}{String specifying whether to pad ('Fill') or leave blank ('Remove') absent calls}
}
\description{
Replaces or Fills absent allele strings.
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_wrapper.R
\name{A.wrapper}
\alias{A.wrapper}
\title{Amino Acid Wrapper}
\usage{
A.wrapper(
  loci,
  loci.ColNames,
  genos,
  grp,
  Exon,
  EPL,
  Cores,
  Strict.Bin,
  Output,
  Verbose
)
}
\arguments{
\item{loci}{Loci being analyzed.}

\item{loci.ColNames}{The column names of the loci being analyzed.}

\item{genos}{Genotype table.}

\item{grp}{Case/Control or Phenotype groupings.}

\item{Exon}{Exon(s)for targeted analysis.}

\item{EPL}{Protein Alignment List.}

\item{Cores}{Number of cores to use for analysis.}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test}

\item{Output}{Data return carryover from main BIGDAWG function}

\item{Verbose}{Summary display carryover from main BIGDAWG function}
}
\description{
Wrapper function for amino acid analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stat_functions.R
\name{RunChiSq_c}
\alias{RunChiSq_c}
\title{Contextual Binning Chi-squared Contingency Table Test}
\usage{
RunChiSq_c(x)
}
\arguments{
\item{x}{Contingency table.}
}
\description{
Calculates chi-squared contingency table tests and bins rare cells at 20% capture rate.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE_support_functions.R
\name{getAllele.Count}
\alias{getAllele.Count}
\title{Recompute number of alleles}
\usage{
getAllele.Count(x)
}
\arguments{
\item{x}{Locus specific contingency matrix getCS.Mat output.}
}
\description{
Using Freq.Final, recompute number of alleles
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_ExonPtnAlign_functions.R
\name{PgrpFormat}
\alias{PgrpFormat}
\title{HLA P group File Formatter}
\usage{
PgrpFormat(x, Locus)
}
\arguments{
\item{x}{P group object from read.table command.}

\item{Locus}{Locus to be filtered on.}
}
\description{
Format the hla_nom_p.txt read table object for a specific locus.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BIGDAWG.R
\name{BIGDAWG}
\alias{BIGDAWG}
\title{BIGDAWG Main Wrapper Function v1.1 Livia Tran March 26, 2026}
\usage{
BIGDAWG(
  Data,
  HLA = TRUE,
  Run.Tests,
  Loci.Set,
  Exon,
  All.Pairwise = FALSE,
  Trim = FALSE,
  Res = 2,
  EVS.rm = FALSE,
  Missing = 2,
  Strict.Bin = FALSE,
  Cores.Lim = 1L,
  Results.Dir,
  Return = FALSE,
  Output = TRUE,
  Merge.Output = FALSE,
  Verbose = TRUE,
  Data.Type = "Locus"
)
}
\arguments{
\item{Data}{Name of the genotype data file.}

\item{HLA}{Logical Indicating whether data is HLA class I/II genotyping data only.}

\item{Run.Tests}{Specifics which tests to run.}

\item{Loci.Set}{Input list defining which loci to use for analyses (combinations permitted).}

\item{Exon}{Numeric Exon(s) for targeted amino acid analysis.}

\item{All.Pairwise}{Logical indicating whether all pairwise loci should be analyzed in haplotype analysis.}

\item{Trim}{Logical indicating if HLA alleles should be trimmed to a set resolution.}

\item{Res}{Numeric setting what desired resolution to trim HLA alleles.}

\item{EVS.rm}{Logical indicating if expression variant suffixes should be removed.}

\item{Missing}{Numeric setting allowable missing data for running analysis (may use "ignore").}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test.}

\item{Cores.Lim}{Integer setting the number of cores accessible to BIGDAWG (Windows limit is 1 core).}

\item{Results.Dir}{Optional, string of full path directory name for BIGDAWG output.}

\item{Return}{Logical Should analysis results be returned as list.}

\item{Output}{Logical Should analysis results be written to output directory.}

\item{Merge.Output}{Logical Should analysis results be merged into a single file for easy access.}

\item{Verbose}{Logical Should a summary of each analysis be displayed in console.}

\item{Data.Type}{String describing the data type in the provided dataset. The
default is set to 'Locus'. Options are 'Locus' or 'Motif'.}
}
\description{
This is the main wrapper function for each analysis.
}
\examples{
\dontrun{
### The following examples use the synthetic data set bundled with BIGDAWG

# Haplotype analysis with no missing genotypes for two loci sets
# Significant haplotype association with phenotype
# BIGDAWG(Data="HLA_data", Run.Tests="H", Missing=0, Loci.Set=list(c("DRB1","DQB1")))

# Hardy-Weinberg and Locus analysis ignoring missing data
# Significant locus associations with phenotype at all but DQB1
# BIGDAWG(Data="HLA_data", Run.Tests="L", Missing="ignore")

# Hardy-Weinberg analysis trimming data to 2-Field resolution with no output to files (console only)
# Significant locus deviation at DQB1
BIGDAWG(Data="HLA_data", Run.Tests="HWE", Trim=TRUE, Res=2, Output=FALSE)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GL2TAB.R
\name{GL2Tab.wrapper}
\alias{GL2Tab.wrapper}
\title{Genotype List String to Tabular Data Conversion}
\usage{
GL2Tab.wrapper(df, System, Strip.Prefix, Abs.Fill, Cores)
}
\arguments{
\item{df}{Data frame containing GL strings}

\item{System}{Character Genetic system HLA or KIR}

\item{Strip.Prefix}{Logical Should System/Locus prefixes be stripped from table data.}

\item{Abs.Fill}{Logical Should absent loci special designations be used.}

\item{Cores}{Integer How many cores can be used}
}
\description{
Expands GL strings to columns of adjacent locus pairs.
}
\note{
This function is for internal use only
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DRB_Parser.R
\name{DRB345.Exp}
\alias{DRB345.Exp}
\title{DRB345 Expected}
\usage{
DRB345.Exp(DRB1.Genotype)
}
\arguments{
\item{DRB1.Genotype}{DRB1 Subject Genotypes}
}
\description{
Checks DRB1 Genotype and Returns Expected DR345 Loci
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE_wrapper.R
\name{HWE.wrapper}
\alias{HWE.wrapper}
\title{Hardy-Weinbery Wrapper}
\usage{
HWE.wrapper(Tab, Output, Verbose)
}
\arguments{
\item{Tab}{Data frame of genotype files post processing.}

\item{Output}{Data return carryover from main BIGDAWG function}

\item{Verbose}{Summary display carryover from main BIGDAWG function}
}
\description{
Wrapper for main HWE function
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE.R
\name{HWE}
\alias{HWE}
\title{Hardy Weinbergy Equilibrium Function}
\usage{
HWE(Tab)
}
\arguments{
\item{Tab}{data frame of genotype files post processing.}
}
\description{
This is the main function for the HWE analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{ExonPtnList}
\alias{ExonPtnList}
\title{Exon protein alignments.}
\format{
A list where each element is an alignment dataframe for a single locus.
}
\usage{
ExonPtnList
}
\description{
Alignment object for use in the amino acid analysis.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{summaryGeno.2}
\alias{summaryGeno.2}
\title{Haplotype missing Allele summary function}
\usage{
summaryGeno.2(geno, miss.val = 0)
}
\arguments{
\item{geno}{Matrix of genotypes.}

\item{miss.val}{Vector of codes for allele missing values.}
}
\description{
Summary function for identifying missing alleles in a matrix of genotypes.
}
\note{
This function is for internal BIGDAWG use only and is ported from haplo.stats.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H_support_functions.R
\name{buildHAPnames}
\alias{buildHAPnames}
\title{Haplotype Name Builder}
\usage{
buildHAPnames(Combn, loci)
}
\arguments{
\item{Combn}{Combination of loci to extraction from genos}

\item{loci}{Character vector of unique loci being analyzed.}
}
\description{
Builds table of names for HAPsets
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H_support_functions.R
\name{getHap}
\alias{getHap}
\title{Haplotype Table Maker}
\usage{
getHap(SID, HaploEM)
}
\arguments{
\item{SID}{Index number (i.e., row number) of sample ID from genotype matrix.}

\item{HaploEM}{Haplotype output object from haplo.stat::haplo.em function.}
}
\description{
Builds table of haplotypes
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_support_functions.R
\name{Create.Null.Table}
\alias{Create.Null.Table}
\title{Create Empty Table}
\usage{
Create.Null.Table(Locus, Names, nr)
}
\arguments{
\item{Locus}{Locus being analyzed.}

\item{Names}{Column names for final matrix.}

\item{nr}{Number of rows.}
}
\description{
Creates matrix of NA for no result tables.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{Check.Cores}
\alias{Check.Cores}
\title{Check Cores Parameters}
\usage{
Check.Cores(Cores.Lim, Output)
}
\arguments{
\item{Cores.Lim}{Integer How many cores can be used.}

\item{Output}{Logical Should analysis results be written to output directory.}
}
\description{
Check cores limitation for OS compatibility
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{CheckHLA}
\alias{CheckHLA}
\title{HLA Formatting Check for Amino Acid Analysis}
\usage{
CheckHLA(x)
}
\arguments{
\item{x}{All columns of HLA genotyping data.}
}
\description{
Checks data to see if HLA data is properly formatted .
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GL2TAB.R
\name{GL2Tab.Loci}
\alias{GL2Tab.Loci}
\title{Locus Ordering for GL2Tab}
\usage{
GL2Tab.Loci(Locus, Genotype, System)
}
\arguments{
\item{Locus}{Locus to condense}

\item{Genotype}{Row of loci to condense}

\item{System}{Character Genetic system HLA or KIR}
}
\description{
Orders Locus Calls
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{CheckRelease}
\alias{CheckRelease}
\title{Function to Check Release Versions}
\usage{
CheckRelease(Package = T, Alignment = T, Output = F)
}
\arguments{
\item{Package}{Logical to check for BIGDAWG package versions}

\item{Alignment}{Logical to check the IMGT/HLA database version for the alignment bundled with BIGDAWG.}

\item{Output}{Should any error be written to a file}
}
\description{
This updates the protein aligment used in checking HLA loci and alleles as well as in the amino acid analysis.
}
\note{
Requires active internet connection.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{PreCheck}
\alias{PreCheck}
\title{Data Summary Function}
\usage{
PreCheck(Tab, All.ColNames, rescall, HLA, Verbose, Output)
}
\arguments{
\item{Tab}{Loci available in exon protein list alignment object.}

\item{All.ColNames}{Column names from genotype data.}

\item{rescall}{HLA resolution set for analysis.}

\item{HLA}{HLA BIGDAWG argument passed to function}

\item{Verbose}{Summary display carryover from BIGDAWG function.}

\item{Output}{Data output carryover form BIGDAWG function}
}
\description{
Summary function for sample population within data file.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stat_functions.R
\name{cci.pval.list}
\alias{cci.pval.list}
\title{Case Control Odds Ratio Calculation from Epicalc list variation}
\usage{
cci.pval.list(x)
}
\arguments{
\item{x}{List of 2x2 matrices to apply the cci.pval function. List output of TableMaker.}
}
\description{
Variation of the cci.pval function
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{Build.Matrix}
\alias{Build.Matrix}
\title{Build Output Matrix for GL2Tab Conversion}
\usage{
Build.Matrix(System, Loci)
}
\arguments{
\item{System}{Character Genetic system HLA- or KIR}

\item{Loci}{The loci for header names}
}
\description{
Initializes output matrix format for GL2Tab conversion
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{Format.Allele}
\alias{Format.Allele}
\title{Ambiguous Alleles Locus Name Formatting}
\usage{
Format.Allele(x, Type)
}
\arguments{
\item{x}{Allele String}

\item{Type}{String specifying whether to strip ('off') or append ('on') locus prefix}
}
\description{
Remove or Append Locus name from/to allele in an ambiguous allele string
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TAB2GL.R
\name{Tab2GL.Loci}
\alias{Tab2GL.Loci}
\title{Locus Condenser for Tab2GL}
\usage{
Tab2GL.Loci(Locus, Genotype, System, HZY.Red)
}
\arguments{
\item{Locus}{Locus to condense}

\item{Genotype}{Row of loci to condense}

\item{System}{Character Genetic system HLA or KIR}

\item{HZY.Red}{Logical Should homozygote genotypes be a single allele for non-DRB345.}
}
\description{
Condenses alleles calls of a single locus string using "+"
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_functions.R
\name{CheckLoci}
\alias{CheckLoci}
\title{HLA Loci Legitimacy Check for Amino Acid Analysis}
\usage{
CheckLoci(x, y)
}
\arguments{
\item{x}{Loci available in exon protein list alignment object.}

\item{y}{Unique column names}
}
\description{
Checks available loci against data to ensure complete overlap.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{Stripper}
\alias{Stripper}
\title{Removes System and Locus from Alleles}
\usage{
Stripper(x)
}
\arguments{
\item{x}{Allele}
}
\description{
Removes the System and Locus designations for alleles calls in GL2Tab
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HWE_support_functions.R
\name{makeComb}
\alias{makeComb}
\title{Genotype Combination Maker}
\usage{
makeComb(x)
}
\arguments{
\item{x}{Number of alleles.}
}
\description{
Make data frame of possible genotype combinations
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_support_functions.R
\name{Exon.Filter}
\alias{Exon.Filter}
\title{Filter Exon Specific Alignment Sections}
\usage{
Exon.Filter(Locus, Exon, EPL.Locus, RefExons, E.Ptn.Starts)
}
\arguments{
\item{Locus}{Locus being analyzed.}

\item{Exon}{Exon being analyzed.}

\item{EPL.Locus}{ExonPtnAlign object filtered by Locus}

\item{RefExons}{Reference Exon Table}

\item{E.Ptn.Starts}{Exon Protein Overlay Map}
}
\description{
Filters the ExonPtnAlign object by locus and exon.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H_MC.R
\name{H.MC}
\alias{H.MC}
\title{Haplotype Analysis Function for Multicore}
\usage{
H.MC(genos.sub, grp, Strict.Bin, Verbose)
}
\arguments{
\item{genos.sub}{The genotype columns of the loci(locus) set being analyzed.}

\item{grp}{Case/Control or Phenotype groupings.}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test}

\item{Verbose}{Summary display carryover from main BIGDAWG function}
}
\description{
This is the workhorse function for the haplotype analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_support_functions.R
\name{AA.df.cs}
\alias{AA.df.cs}
\title{Contingency Table Amino Acid ChiSq Testing}
\usage{
AA.df.cs(x, Strict.Bin)
}
\arguments{
\item{x}{contingency table.}

\item{Strict.Bin}{Logical specify if strict rare cell binning should be used in ChiSq test.}
}
\description{
Runs ChiSq test on amino acid contingency table data frames.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/general_functions.R
\name{Format.Tab}
\alias{Format.Tab}
\title{Tabular Data Locus Format Tool}
\usage{
Format.Tab(x, Order)
}
\arguments{
\item{x}{Single row of converted GL string}

\item{Order}{Single row data frame for mapping converted GL strings}
}
\description{
Correctly orders the expanded GL string
}
\note{
This function is for internal use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/A_support_functions.R
\name{AAtable.builder}
\alias{AAtable.builder}
\title{Amino Acid Contingency Table Build}
\usage{
AAtable.builder(x, y)
}
\arguments{
\item{x}{Filtered alignmnet list element.}

\item{y}{Phenotype groupings.}
}
\description{
Build Contingency Tables for Amino Acid Analysis.
}
\note{
This function is for internal BIGDAWG use only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/H_support_functions.R
\name{buildHAPsets}
\alias{buildHAPsets}
\title{Haplotype List Builder}
\usage{
buildHAPsets(Combn, genos, loci, loci.ColNames)
}
\arguments{
\item{Combn}{Combination of loci to extraction from genos}

\item{genos}{The genotype columns of the loci set being analyzed.}

\item{loci}{Character vector of unique loci being analyzed.}

\item{loci.ColNames}{Character vector of genos column names.}
}
\description{
Builds table of haplotypes from combinations
}
\note{
This function is for internal BIGDAWG use only.
}
